=== modified file '.bzrignore'
--- .bzrignore	2010-09-16 18:33:17 +0000
+++ .bzrignore	2011-12-12 00:55:33 +0000
@@ -23,3 +23,54 @@
 tools/.libs
 src/application-menu-renderer-client.h
 src/application-menu-renderer-server.h
+test-usage-db-simple
+test-usage-db-simple-test
+test-usage-db-simple.xml
+test-usage-db-old
+test-usage-db-old-test
+test-usage-db-old.xml
+test-usage-db-ancient
+test-usage-db-ancient-test
+test-indicator-tracker
+test-indicator-tracker-owner
+test-indicator-tracker-test
+ABOUT-NLS
+config.rpath
+hud-[0-9]*.[0-9]*.[0-9]*.tar.gz
+m4
+data/com.canonical.hud.service
+po/Makevars.template
+po/Rules-quot
+po/boldquot.sed
+po/en@boldquot.header
+po/en@quot.header
+po/insert-header.sin
+po/quot.sed
+po/remove-potcdate.sin
+service/.deps
+service/.libs
+service/hud-cli
+service/hud-service
+service/hud.interface.c
+service/hud.interface.h
+tests/.deps
+tests/.libs
+tests/test-distance
+tests/test-distance-test
+tests/test-distance.xml
+po/hud.pot
+hud-dump-application
+hud-verify-app-info
+test-bad-app-info-dual-header
+test-bad-app-info-item-no-count
+test-bad-app-info-item-no-name
+test-bad-app-info-menu-no-name
+test-bad-app-info-missing-desktop
+test-bad-app-info-missing-menus
+test-bad-app-info
+test-good-app-info-tons-of-entries
+test-load-app-info
+test-usage-db-testapp
+test-usage-db-testapp-test
+test-usage-db-testapp.xml
+test-bad-app-info-multiple-menus

=== modified file 'Makefile.am'
--- Makefile.am	2010-10-08 22:16:41 +0000
+++ Makefile.am	2011-12-12 00:55:33 +0000
@@ -1,9 +1,16 @@
+ACLOCAL_AMFLAGS = -I m4 ${ACLOCAL_FLAGS}
 
 SUBDIRS = \
+	data \
+	po \
+	service \
 	src \
 	scripts \
+	tests \
 	tools
 
+tests: service src
+
 DISTCHECK_CONFIGURE_FLAGS = --enable-localinstall --enable-deprecations
 
 dist-hook:

=== modified file 'autogen.sh'
--- autogen.sh	2010-04-19 17:29:36 +0000
+++ autogen.sh	2011-12-12 00:55:33 +0000
@@ -9,4 +9,4 @@
 
 USE_GNOME2_MACROS=1 \
 USE_COMMON_DOC_BUILD=yes \
-gnome-autogen.sh --enable-gtk-doc $@
+. gnome-autogen.sh --enable-gtk-doc $@

=== modified file 'configure.ac'
--- configure.ac	2011-10-13 18:24:20 +0000
+++ configure.ac	2011-12-12 00:55:33 +0000
@@ -1,24 +1,29 @@
+AC_INIT([indicator-appmenu],
+        [0.3.2],
+        [http://bugs.launchpad.net/indicator-appmenu],
+        [indicator-appmenu],
+        [http://launchpad.net/indicator-appmenu])
 
-AC_INIT(indicator-appmenu, 0.3.2, ted@canonical.com)
 AC_COPYRIGHT([Copyright 2010 Canonical])
 
 AC_PREREQ(2.53)
 
 AM_CONFIG_HEADER(config.h)
-AM_INIT_AUTOMAKE(indicator-appmenu, 0.3.2)
-
-AM_MAINTAINER_MODE
-
-AC_ISC_POSIX
+AC_CONFIG_SRCDIR([configure.ac])
+AC_CONFIG_MACRO_DIR([m4])
+
+AM_INIT_AUTOMAKE([1.11 -Wall foreign subdir-objects])
+AM_MAINTAINER_MODE([enable])
+
+AM_SILENT_RULES([yes])
+
+# Check for programs
 AC_PROG_CC
 AM_PROG_CC_C_O
-AC_STDC_HEADERS
-AC_PROG_LIBTOOL
-
-AC_SUBST(VERSION)
-AC_CONFIG_MACRO_DIR([m4])
-
-m4_ifdef([AM_SILENT_RULES],[AM_SILENT_RULES([yes])])
+
+# Initialize libtool
+LT_PREREQ([2.2.6])
+LT_INIT
 
 AC_PATH_PROG([GLIB_MKENUMS], [glib-mkenums])
 AC_PATH_PROG([GLIB_GENMARSHAL], [glib-genmarshal])
@@ -80,6 +85,21 @@
 AC_SUBST(INDICATOR_LIBS)
 
 ###########################
+# Dependencies
+###########################
+
+DBUSMENU_GLIB_REQUIRED_VERSION=0.4.0
+BAMF_REQUIRED_VERSION=0.2.53
+SQLITE_REQUIRED_VERSION=0.0
+
+PKG_CHECK_MODULES([HUD],[
+		dbusmenu-glib-0.4 >= $DBUSMENU_GLIB_REQUIRED_VERSION
+		libbamf3 >= $BAMF_REQUIRED_VERSION
+		sqlite3 >= $SQLITE_REQUIRED_VERSION
+])
+
+
+###########################
 # Test Dependencies
 ###########################
 
@@ -133,6 +153,37 @@
 fi
 AC_SUBST(DBUSSERVICEDIR)
 
+##############################
+# Custom Junk
+##############################
+
+AC_DEFUN([AC_DEFINE_PATH], [
+	test "x$prefix" = xNONE && prefix="$ac_default_prefix"
+	test "x$exec_prefix" = xNONE && exec_prefix='${prefix}'
+	ac_define_path=`eval echo [$]$2`
+	ac_define_path=`eval echo [$]ac_define_path`
+	$1="$ac_define_path"
+	AC_SUBST($1)
+	ifelse($3, ,
+		AC_DEFINE_UNQUOTED($1, "$ac_define_path"),
+		AC_DEFINE_UNQUOTED($1, "$ac_define_path", $3))
+])
+
+###########################
+# Internationalization
+###########################
+
+GETTEXT_PACKAGE=indicator-appmenu
+
+IT_PROG_INTLTOOL([0.41.0])
+
+AM_GNU_GETTEXT([external])
+AM_GNU_GETTEXT_VERSION([0.17])
+
+AC_SUBST(GETTEXT_PACKAGE)
+AC_DEFINE_UNQUOTED(GETTEXT_PACKAGE, "$GETTEXT_PACKAGE", [Define to the gettext package name.])
+AC_DEFINE_PATH(GNOMELOCALEDIR, "${datadir}/locale", [locale directory])
+
 ###########################
 # Files
 ###########################
@@ -142,6 +193,10 @@
 src/Makefile
 scripts/Makefile
 tools/Makefile
+po/Makefile.in
+service/Makefile
+data/Makefile
+tests/Makefile
 ])
 
 ###########################
@@ -154,4 +209,5 @@
 
 	Prefix:        $prefix
 	Indicator Dir: $INDICATORDIR
+	Local Install: $with_localinstall
 ])

=== added directory 'data'
=== added file 'data/Makefile.am'
--- data/Makefile.am	1970-01-01 00:00:00 +0000
+++ data/Makefile.am	2011-10-18 21:20:51 +0000
@@ -0,0 +1,10 @@
+
+dbus_servicesdir = $(DBUSSERVICEDIR)
+dbus_services_DATA = com.canonical.hud.service
+
+%.service: %.service.in
+	sed -e "s|\@libexecdir\@|$(libexecdir)|" $< > $@
+
+EXTRA_DIST = com.canonical.hud.service.in
+
+CLEANFILES = com.canonical.hud.service

=== added file 'data/com.canonical.hud.service.in'
--- data/com.canonical.hud.service.in	1970-01-01 00:00:00 +0000
+++ data/com.canonical.hud.service.in	2011-10-18 21:20:51 +0000
@@ -0,0 +1,3 @@
+[D-BUS Service]
+Name=com.canonical.hud
+Exec=@libexecdir@/hud-service

=== added directory 'docs'
=== added file 'docs/HUD Architecture.svg'
--- docs/HUD Architecture.svg	1970-01-01 00:00:00 +0000
+++ docs/HUD Architecture.svg	2011-10-19 04:37:53 +0000
@@ -0,0 +1,690 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="990"
+   height="765"
+   id="svg2"
+   version="1.1"
+   inkscape:version="0.48.2 r9819"
+   sodipodi:docname="HUD Architecture.svg">
+  <defs
+     id="defs4">
+    <inkscape:path-effect
+       effect="spiro"
+       id="path-effect4218"
+       is_visible="true" />
+    <inkscape:path-effect
+       effect="spiro"
+       id="path-effect4214"
+       is_visible="true" />
+    <inkscape:path-effect
+       effect="spiro"
+       id="path-effect4210"
+       is_visible="true" />
+    <inkscape:path-effect
+       effect="spiro"
+       id="path-effect4206"
+       is_visible="true" />
+    <inkscape:path-effect
+       effect="spiro"
+       id="path-effect4054"
+       is_visible="true" />
+    <inkscape:path-effect
+       effect="spiro"
+       id="path-effect3863"
+       is_visible="true" />
+    <inkscape:path-effect
+       effect="spiro"
+       id="path-effect3829"
+       is_visible="true" />
+    <inkscape:path-effect
+       effect="spiro"
+       id="path-effect3825"
+       is_visible="true" />
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="1.1071895"
+     inkscape:cx="495"
+     inkscape:cy="382.5"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     showgrid="false"
+     inkscape:showpageshadow="false"
+     inkscape:window-width="1680"
+     inkscape:window-height="1026"
+     inkscape:window-x="0"
+     inkscape:window-y="24"
+     inkscape:window-maximized="1" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title></dc:title>
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1"
+     transform="translate(0,-287.36218)">
+    <rect
+       style="color:#000000;fill:none;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;stroke-dashoffset:0;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+       id="rect2985"
+       width="192.93913"
+       height="104.04572"
+       x="241.00642"
+       y="328.33542" />
+    <rect
+       style="color:#000000;fill:none;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;stroke-dashoffset:0;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+       id="rect2985-3"
+       width="192.93913"
+       height="104.04572"
+       x="242.9117"
+       y="562.45471" />
+    <rect
+       style="color:#000000;fill:none;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;stroke-dashoffset:0;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+       id="rect2985-9"
+       width="192.93913"
+       height="104.04572"
+       x="586.43182"
+       y="384.48648" />
+    <rect
+       style="color:#000000;fill:none;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;stroke-dashoffset:0;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+       id="rect2985-7"
+       width="192.93913"
+       height="104.04572"
+       x="617.05884"
+       y="561.62695" />
+    <rect
+       style="color:#000000;fill:none;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;stroke-dashoffset:0;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+       id="rect2985-3-6"
+       width="433.81705"
+       height="287.80829"
+       x="69.082268"
+       y="732.14532" />
+    <flowRoot
+       xml:space="preserve"
+       id="flowRoot3805"
+       style="fill:black;stroke:none;stroke-opacity:1;stroke-width:1px;stroke-linejoin:miter;stroke-linecap:butt;fill-opacity:1;font-family:Bumped BRK;font-style:normal;font-weight:normal;font-size:18px;line-height:100%;letter-spacing:0px;word-spacing:0px;-inkscape-font-specification:Bumped BRK;font-stretch:normal;font-variant:normal;text-anchor:start;text-align:start;writing-mode:lr"><flowRegion
+         id="flowRegion3807"><rect
+           id="rect3809"
+           width="187.07358"
+           height="95.192307"
+           x="242.53345"
+           y="43.193981"
+           style="-inkscape-font-specification:Bumped BRK;font-family:Bumped BRK" /></flowRegion><flowPara
+         id="flowPara3811"></flowPara></flowRoot>    <flowRoot
+       xml:space="preserve"
+       id="flowRoot3813"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:center;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:middle;fill:#000000;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       transform="translate(0,310.93426)"><flowRegion
+         id="flowRegion3815"><rect
+           id="rect3817"
+           width="175.48492"
+           height="46.354519"
+           x="249.15552"
+           y="52.299332"
+           style="text-align:center;text-anchor:middle"
+           ry="0"
+           rx="0" /></flowRegion><flowPara
+         id="flowPara3819"
+         style="font-weight:bold;-inkscape-font-specification:Ubuntu Bold">Unity</flowPara><flowPara
+         id="flowPara3821"
+         style="font-weight:bold;-inkscape-font-specification:Ubuntu Bold">GUI</flowPara></flowRoot>    <path
+       style="fill:none;stroke:#000000;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       d="m 449.47325,302.28261 c 29.69243,-2.03406 58.53652,-14.78861 80.02111,-35.38449 10.47599,-10.04266 19.17966,-21.79342 29.4484,-32.0479 8.83486,-8.8226 18.80808,-16.50398 29.59403,-22.79336"
+       id="path3823"
+       inkscape:path-effect="#path-effect3825"
+       inkscape:original-d="m 449.47325,302.28261 c 35.92724,5.92939 56.6183,-19.31435 80.02111,-35.38449 11.7014,-8.03507 19.73501,-22.46822 29.4484,-32.0479 9.7134,-9.57969 21.10658,-14.30591 29.59403,-22.79336"
+       inkscape:connector-curvature="0"
+       transform="translate(0,287.36218)"
+       sodipodi:nodetypes="cssc" />
+    <path
+       style="fill:none;stroke:#000000;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       d="m 449.81773,318.01003 c 21.09159,-2.06081 42.43769,-1.50335 63.39297,1.65552 17.10783,2.5789 34.02902,6.89013 51.32108,7.44983 12.84929,0.4159 25.76421,-1.26865 38.07692,-4.96655"
+       id="path3827"
+       inkscape:path-effect="#path-effect3829"
+       inkscape:original-d="m 449.81773,318.01003 c 11.59516,1.94007 62.94692,-1.93293 63.39297,1.65552 1.01665,8.17897 40.57446,3.86763 51.32108,7.44983 19.17114,6.39038 20.04051,-0.45745 38.07692,-4.96655"
+       inkscape:connector-curvature="0"
+       transform="translate(0,287.36218)"
+       sodipodi:nodetypes="cssc" />
+    <flowRoot
+       xml:space="preserve"
+       id="flowRoot3813-1"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:center;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:middle;fill:#000000;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       transform="translate(2.6759825,544.72955)"><flowRegion
+         id="flowRegion3815-4"><rect
+           id="rect3817-9"
+           width="175.48492"
+           height="46.354519"
+           x="249.15552"
+           y="52.299332"
+           style="text-align:center;text-anchor:middle"
+           ry="0"
+           rx="0" /></flowRegion><flowPara
+         id="flowPara3819-7"
+         style="font-weight:bold">HUD</flowPara><flowPara
+         id="flowPara3821-6"
+         style="font-weight:bold">Service</flowPara></flowRoot>    <path
+       style="fill:none;stroke:#000000;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       d="m 342.69231,158.25251 0,103.4699"
+       id="path3861"
+       inkscape:path-effect="#path-effect3863"
+       inkscape:original-d="m 342.69231,158.25251 c 0,102.64214 0,103.4699 0,103.4699"
+       inkscape:connector-curvature="0"
+       transform="translate(0,287.36218)" />
+    <text
+       xml:space="preserve"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       x="658.00934"
+       y="442.75534"
+       id="text3865"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3867"
+         x="658.00934"
+         y="442.75534"
+         style="font-weight:bold">BAMF</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:center;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:middle;fill:#000000;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       x="714.17834"
+       y="609.96881"
+       id="text3869"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3871"
+         x="714.17834"
+         y="609.96881"
+         style="font-weight:bold">Indicator</tspan><tspan
+         sodipodi:role="line"
+         x="714.17834"
+         y="627.96881"
+         id="tspan3873"
+         style="font-weight:bold">AppMenu</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#444444;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       x="203.62877"
+       y="481.20834"
+       id="text3875"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3877"
+         x="203.62877"
+         y="481.20834"
+         style="font-size:16px;fill:#444444;fill-opacity:1">Text Area</tspan><tspan
+         sodipodi:role="line"
+         x="203.62877"
+         y="497.20834"
+         id="tspan3879"
+         style="font-size:16px;fill:#444444;fill-opacity:1">Target Text</tspan><tspan
+         sodipodi:role="line"
+         x="203.62877"
+         y="513.20837"
+         id="tspan3881"
+         style="font-size:16px;fill:#444444;fill-opacity:1">Suggestions</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-indent:0;text-align:start;text-decoration:none;line-height:100%;letter-spacing:0px;word-spacing:0px;text-transform:none;direction:ltr;block-progression:tb;writing-mode:lr-tb;text-anchor:start;baseline-shift:baseline;color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       x="470.16724"
+       y="506.04111"
+       id="text3883"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3885"
+         x="470.16724"
+         y="506.04111">Focused</tspan><tspan
+         sodipodi:role="line"
+         x="470.16724"
+         y="524.04114"
+         id="tspan3925">Window</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-indent:0;text-align:start;text-decoration:none;line-height:100%;letter-spacing:0px;word-spacing:0px;text-transform:none;direction:ltr;block-progression:tb;writing-mode:lr-tb;text-anchor:start;baseline-shift:baseline;color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       x="471.28049"
+       y="644.96588"
+       id="text3887"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3889"
+         x="471.28049"
+         y="644.96588">Window to</tspan><tspan
+         sodipodi:role="line"
+         x="471.28049"
+         y="662.96588"
+         id="tspan3891">Menu mapping</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       x="74.029198"
+       y="724.17548"
+       id="text3865-8"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3867-7"
+         x="74.029198"
+         y="724.17548"
+         style="font-weight:bold">Application</tspan></text>
+    <rect
+       style="color:#000000;fill:none;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;stroke-dashoffset:0;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+       id="rect2985-3-6-2"
+       width="259.15988"
+       height="245.59258"
+       x="230.90923"
+       y="756.28912" />
+    <text
+       xml:space="preserve"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       x="326.11465"
+       y="994.28821"
+       id="text3865-8-2"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3867-7-3"
+         x="326.11465"
+         y="994.28821"
+         style="font-weight:bold">Window</tspan></text>
+    <rect
+       style="color:#000000;fill:none;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;stroke-dashoffset:0;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+       id="rect2985-7-7"
+       width="239.29364"
+       height="44.447052"
+       x="239.60066"
+       y="925.6922" />
+    <text
+       xml:space="preserve"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-indent:0;text-align:center;text-decoration:none;line-height:100%;letter-spacing:0px;word-spacing:0px;text-transform:none;direction:ltr;block-progression:tb;writing-mode:lr-tb;text-anchor:middle;baseline-shift:baseline;color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       x="359.65784"
+       y="953.23474"
+       id="text3887-1"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         x="359.65784"
+         y="953.23474"
+         id="tspan3891-2">Appmenu Module</tspan></text>
+    <path
+       style="fill:none;stroke:#000000;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       d="m 485.89465,652.84114 c 16.23733,-3.84221 30.5802,-15.04776 38.23686,-29.87304 6.96387,-13.48385 8.38625,-29.21496 7.3396,-44.35478 -1.04664,-15.13982 -4.41236,-30.01318 -6.51184,-45.04321 -2.74315,-19.63804 -3.3102,-39.70499 0.0347,-59.24953 3.34491,-19.54455 10.71754,-38.58634 22.79255,-54.3144 15.0578,-19.61323 37.35193,-33.53801 61.58305,-38.46438"
+       id="path4052"
+       inkscape:path-effect="#path-effect4054"
+       inkscape:original-d="m 485.89465,652.84114 c 69.8028,11.24543 30.70744,15.30352 38.23686,-29.87304 4.70103,-28.20618 0.82776,-60.68417 0.82776,-89.39799 0,-3.09441 20.32766,-111.06434 22.82725,-113.56393 2.41681,-2.4168 58.09902,-38.46438 61.58305,-38.46438"
+       inkscape:connector-curvature="0"
+       transform="translate(0,287.36218)"
+       sodipodi:nodetypes="csssc" />
+    <rect
+       style="color:#000000;fill:none;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;stroke-dashoffset:0;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+       id="rect4056"
+       width="115.3069"
+       height="150.42575"
+       x="239.97879"
+       y="765.35535" />
+    <rect
+       style="color:#000000;fill:none;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;stroke-dashoffset:0;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+       id="rect4056-8"
+       width="111.79498"
+       height="152.18163"
+       x="365.11047"
+       y="764.47742" />
+    <text
+       xml:space="preserve"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-indent:0;text-align:center;text-decoration:none;line-height:100%;letter-spacing:0px;word-spacing:0px;text-transform:none;direction:ltr;block-progression:tb;writing-mode:lr-tb;text-anchor:middle;baseline-shift:baseline;color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       x="297.37405"
+       y="846.6972"
+       id="text4093"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan4095"
+         x="297.37405"
+         y="846.6972">Menus</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-indent:0;text-align:center;text-decoration:none;line-height:100%;letter-spacing:0px;word-spacing:0px;text-transform:none;direction:ltr;block-progression:tb;writing-mode:lr-tb;text-anchor:middle;baseline-shift:baseline;color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       x="421.15808"
+       y="838.08423"
+       id="text4097"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan4099"
+         x="421.15808"
+         y="838.08423">Semantic</tspan><tspan
+         sodipodi:role="line"
+         x="421.15808"
+         y="856.08423"
+         id="tspan4101">Variables</tspan></text>
+    <rect
+       style="color:#000000;fill:none;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;stroke-dashoffset:0;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+       id="rect4129"
+       width="138.13414"
+       height="103.01529"
+       x="80.773354"
+       y="769.65546" />
+    <rect
+       style="color:#000000;fill:none;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;stroke-dashoffset:0;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+       id="rect4129-0"
+       width="138.13414"
+       height="103.01529"
+       x="80.773354"
+       y="889.65546" />
+    <text
+       xml:space="preserve"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-indent:0;text-align:center;text-decoration:none;line-height:100%;letter-spacing:0px;word-spacing:0px;text-transform:none;direction:ltr;block-progression:tb;writing-mode:lr-tb;text-anchor:middle;baseline-shift:baseline;color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       x="150.11324"
+       y="827.6701"
+       id="text4166"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan4168"
+         x="150.11324"
+         y="827.6701">Actions</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-indent:0;text-align:center;text-decoration:none;line-height:100%;letter-spacing:0px;word-spacing:0px;text-transform:none;direction:ltr;block-progression:tb;writing-mode:lr-tb;text-anchor:middle;baseline-shift:baseline;color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       x="149.88823"
+       y="947.6521"
+       id="text4170"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan4172"
+         x="149.88823"
+         y="947.6521">Semantics</tspan></text>
+    <path
+       style="fill:none;stroke:#000000;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       d="m 287.97456,472.92824 c -3.42872,-7.04416 -5.0107,-14.97733 -4.54619,-22.79786 0.46451,-7.82052 2.97446,-15.51064 7.21293,-22.0994 4.43899,-6.90047 10.66453,-12.51742 15.05132,-19.45118 4.11736,-6.5079 6.50844,-14.09719 6.86513,-21.78993"
+       id="path4204"
+       inkscape:path-effect="#path-effect4206"
+       inkscape:original-d="m 287.97456,472.92824 c -12.83313,-16.30425 -6.68734,-30.5721 2.66674,-44.89726 4.67704,-7.16258 10.74147,-11.99823 15.05132,-19.45118 4.30985,-7.45294 6.86513,-13.52319 6.86513,-21.78993"
+       inkscape:connector-curvature="0"
+       transform="translate(0,287.36218)"
+       sodipodi:nodetypes="cssc" />
+    <path
+       style="fill:none;stroke:#000000;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       d="m 398.59893,472.92824 c -1.86261,-14.36138 -8.138,-28.11986 -17.76158,-38.94138 -7.77566,-8.74356 -17.70814,-15.67393 -23.87153,-25.61995 -4.08301,-6.58885 -6.3106,-14.31396 -6.36265,-22.06516"
+       id="path4208"
+       inkscape:path-effect="#path-effect4210"
+       inkscape:original-d="m 398.59893,472.92824 c 2.07172,-21.37833 -6.12268,-27.28506 -17.76158,-38.94138 -5.81945,-5.82815 -19.37746,-18.6542 -23.87153,-25.61995 -4.49407,-6.96575 -6.36265,-11.58309 -6.36265,-22.06516"
+       inkscape:connector-curvature="0"
+       transform="translate(0,287.36218)"
+       sodipodi:nodetypes="cssc" />
+    <path
+       style="fill:none;stroke:#000000;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       d="m 193.73898,471.75761 c 12.23514,-12.4367 18.5297,-30.47868 16.68618,-47.82721 -0.82473,-7.7611 -3.16829,-15.26553 -5.02928,-22.84522 -1.86099,-7.57969 -3.2513,-15.44478 -2.12598,-23.16803 1.14989,-7.89192 4.98982,-15.36697 10.73534,-20.89813 5.74553,-5.53115 13.36112,-9.0842 21.29104,-9.93332"
+       id="path4212"
+       inkscape:path-effect="#path-effect4214"
+       inkscape:original-d="m 193.73898,471.75761 c -28.39543,-24.01825 0.961,-67.29065 16.68618,-47.82721 15.72518,19.46343 -40.71231,-76.8581 -7.15526,-46.01325 14.8348,15.16265 32.02638,-10.94492 32.02638,-30.83145"
+       inkscape:connector-curvature="0"
+       transform="translate(0,287.36218)"
+       sodipodi:nodetypes="cscc" />
+    <path
+       style="fill:none;stroke:#000000;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+       d="m 74.334896,623.35398 c -14.924262,-4.88817 -27.35013,-16.87026 -32.777592,-31.60696 -5.098158,-13.84258 -4.123437,-29.16891 -1.645432,-43.71083 2.478006,-14.54193 6.394399,-28.91572 6.98962,-43.65525 0.624739,-15.4705 -2.428685,-30.81844 -4.119905,-46.20891 -1.691221,-15.39046 -1.928122,-31.47156 4.001756,-45.77412 4.015133,-9.6843 10.733185,-18.12575 18.766824,-24.86129 8.033638,-6.73554 17.360124,-11.81663 27.09687,-15.70284 19.473493,-7.77242 40.443613,-10.81368 60.858883,-15.59324 27.69908,-6.48482 54.62622,-16.26039 80.03442,-29.05552"
+       id="path4216"
+       inkscape:path-effect="#path-effect4218"
+       inkscape:original-d="M 74.334896,623.35398 C 71.402468,611.78002 49.013197,602.93085 41.557304,591.74702 34.582823,581.28529 29.930055,555.11925 46.901492,504.38094 63.872929,453.64263 23.451163,441.54598 46.783343,412.39791 70.115524,383.24985 114.03473,367.4867 153.50592,356.24054 c 39.47118,-11.24617 74.49434,-17.97536 80.03442,-29.05552"
+       inkscape:connector-curvature="0"
+       transform="translate(0,287.36218)"
+       sodipodi:nodetypes="cssssc" />
+    <g
+       id="g4226">
+      <path
+         transform="translate(90.723692,292.63001)"
+         d="m 110.62438,314.30811 a 12.291597,12.291597 0 1 1 -24.583198,0 12.291597,12.291597 0 1 1 24.583198,0 z"
+         sodipodi:ry="12.291597"
+         sodipodi:rx="12.291597"
+         sodipodi:cy="314.30811"
+         sodipodi:cx="98.332779"
+         id="path4220"
+         style="color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="100%"
+         id="text4222"
+         y="613.17511"
+         x="189.97855"
+         style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:center;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:middle;fill:#ffffff;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+         xml:space="preserve"><tspan
+           y="613.17511"
+           x="189.97855"
+           id="tspan4224"
+           sodipodi:role="line">1</tspan></text>
+    </g>
+    <g
+       transform="translate(39.216044,77.261469)"
+       id="g4226-2">
+      <path
+         transform="translate(90.723692,292.63001)"
+         d="m 110.62438,314.30811 c 0,6.78846 -5.50314,12.29159 -12.291601,12.29159 -6.788462,0 -12.291597,-5.50313 -12.291597,-12.29159 0,-6.78847 5.503135,-12.2916 12.291597,-12.2916 6.788461,0 12.291601,5.50313 12.291601,12.2916 z"
+         sodipodi:ry="12.291597"
+         sodipodi:rx="12.291597"
+         sodipodi:cy="314.30811"
+         sodipodi:cx="98.332779"
+         id="path4220-2"
+         style="color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="100%"
+         id="text4222-8"
+         y="613.17511"
+         x="189.97855"
+         style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:center;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:middle;fill:#ffffff;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+         xml:space="preserve"><tspan
+           y="613.17511"
+           x="189.97855"
+           id="tspan4224-7"
+           sodipodi:role="line">2</tspan></text>
+    </g>
+    <g
+       transform="translate(134.62225,103.60061)"
+       id="g4226-3">
+      <path
+         transform="translate(90.723692,292.63001)"
+         d="m 110.62438,314.30811 c 0,6.78846 -5.50314,12.29159 -12.291601,12.29159 -6.788462,0 -12.291597,-5.50313 -12.291597,-12.29159 0,-6.78847 5.503135,-12.2916 12.291597,-12.2916 6.788461,0 12.291601,5.50313 12.291601,12.2916 z"
+         sodipodi:ry="12.291597"
+         sodipodi:rx="12.291597"
+         sodipodi:cy="314.30811"
+         sodipodi:cx="98.332779"
+         id="path4220-4"
+         style="color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="100%"
+         id="text4222-2"
+         y="613.17511"
+         x="189.97855"
+         style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:center;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:middle;fill:#ffffff;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+         xml:space="preserve"><tspan
+           y="613.17511"
+           x="189.97855"
+           id="tspan4224-0"
+           sodipodi:role="line">3</tspan></text>
+    </g>
+    <g
+       transform="translate(195.49492,80.773354)"
+       id="g4226-30">
+      <path
+         transform="translate(90.723692,292.63001)"
+         d="m 110.62438,314.30811 c 0,6.78846 -5.50314,12.29159 -12.291601,12.29159 -6.788462,0 -12.291597,-5.50313 -12.291597,-12.29159 0,-6.78847 5.503135,-12.2916 12.291597,-12.2916 6.788461,0 12.291601,5.50313 12.291601,12.2916 z"
+         sodipodi:ry="12.291597"
+         sodipodi:rx="12.291597"
+         sodipodi:cy="314.30811"
+         sodipodi:cx="98.332779"
+         id="path4220-7"
+         style="color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="100%"
+         id="text4222-9"
+         y="613.17511"
+         x="189.97855"
+         style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:center;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:middle;fill:#ffffff;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+         xml:space="preserve"><tspan
+           y="613.17511"
+           x="189.97855"
+           id="tspan4224-2"
+           sodipodi:role="line">4</tspan></text>
+    </g>
+    <g
+       transform="translate(431.14086,111.85216)"
+       id="g4226-1">
+      <path
+         transform="translate(90.723692,292.63001)"
+         d="m 110.62438,314.30811 c 0,6.78846 -5.50314,12.29159 -12.291601,12.29159 -6.788462,0 -12.291597,-5.50313 -12.291597,-12.29159 0,-6.78847 5.503135,-12.2916 12.291597,-12.2916 6.788461,0 12.291601,5.50313 12.291601,12.2916 z"
+         sodipodi:ry="12.291597"
+         sodipodi:rx="12.291597"
+         sodipodi:cy="314.30811"
+         sodipodi:cx="98.332779"
+         id="path4220-9"
+         style="color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="100%"
+         id="text4222-7"
+         y="613.17511"
+         x="189.97855"
+         style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:center;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:middle;fill:#ffffff;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+         xml:space="preserve"><tspan
+           y="613.17511"
+           x="189.97855"
+           id="tspan4224-5"
+           sodipodi:role="line">1</tspan></text>
+    </g>
+    <g
+       transform="translate(431.14086,222.82875)"
+       id="g4226-2-2">
+      <path
+         transform="translate(90.723692,292.63001)"
+         d="m 110.62438,314.30811 c 0,6.78846 -5.50314,12.29159 -12.291601,12.29159 -6.788462,0 -12.291597,-5.50313 -12.291597,-12.29159 0,-6.78847 5.503135,-12.2916 12.291597,-12.2916 6.788461,0 12.291601,5.50313 12.291601,12.2916 z"
+         sodipodi:ry="12.291597"
+         sodipodi:rx="12.291597"
+         sodipodi:cy="314.30811"
+         sodipodi:cx="98.332779"
+         id="path4220-2-6"
+         style="color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="100%"
+         id="text4222-8-0"
+         y="613.17511"
+         x="189.97855"
+         style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:center;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:middle;fill:#ffffff;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+         xml:space="preserve"><tspan
+           y="613.17511"
+           x="189.97855"
+           id="tspan4224-7-2"
+           sodipodi:role="line">2</tspan></text>
+    </g>
+    <g
+       transform="translate(431.14086,302.28862)"
+       id="g4226-3-1">
+      <path
+         transform="translate(90.723692,292.63001)"
+         d="m 110.62438,314.30811 c 0,6.78846 -5.50314,12.29159 -12.291601,12.29159 -6.788462,0 -12.291597,-5.50313 -12.291597,-12.29159 0,-6.78847 5.503135,-12.2916 12.291597,-12.2916 6.788461,0 12.291601,5.50313 12.291601,12.2916 z"
+         sodipodi:ry="12.291597"
+         sodipodi:rx="12.291597"
+         sodipodi:cy="314.30811"
+         sodipodi:cx="98.332779"
+         id="path4220-4-4"
+         style="color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="100%"
+         id="text4222-2-7"
+         y="613.17511"
+         x="189.97855"
+         style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:center;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:middle;fill:#ffffff;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+         xml:space="preserve"><tspan
+           y="613.17511"
+           x="189.97855"
+           id="tspan4224-0-9"
+           sodipodi:role="line">3</tspan></text>
+    </g>
+    <g
+       transform="translate(431.14086,360.85383)"
+       id="g4226-30-0">
+      <path
+         transform="translate(90.723692,292.63001)"
+         d="m 110.62438,314.30811 c 0,6.78846 -5.50314,12.29159 -12.291601,12.29159 -6.788462,0 -12.291597,-5.50313 -12.291597,-12.29159 0,-6.78847 5.503135,-12.2916 12.291597,-12.2916 6.788461,0 12.291601,5.50313 12.291601,12.2916 z"
+         sodipodi:ry="12.291597"
+         sodipodi:rx="12.291597"
+         sodipodi:cy="314.30811"
+         sodipodi:cx="98.332779"
+         id="path4220-7-5"
+         style="color:#000000;fill:#444444;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="100%"
+         id="text4222-9-3"
+         y="613.17511"
+         x="189.97855"
+         style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:center;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:middle;fill:#ffffff;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+         xml:space="preserve"><tspan
+           y="613.17511"
+           x="189.97855"
+           id="tspan4224-2-1"
+           sodipodi:role="line">4</tspan></text>
+    </g>
+    <flowRoot
+       xml:space="preserve"
+       id="flowRoot4406"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"
+       transform="translate(0,247.36216)"><flowRegion
+         id="flowRegion4408"><rect
+           id="rect4410"
+           width="259.08862"
+           height="118.36957"
+           x="642.34113"
+           y="455.41806" /></flowRegion><flowPara
+         id="flowPara4412">Provides the text to describe various commands in a human readable form, referencing the per window variables and which actions should be used.</flowPara></flowRoot>    <flowRoot
+       transform="translate(0.173144,358.13381)"
+       xml:space="preserve"
+       id="flowRoot4406-7"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"><flowRegion
+         id="flowRegion4408-2"><rect
+           id="rect4410-6"
+           width="259.08862"
+           height="118.36957"
+           x="642.34113"
+           y="455.41806" /></flowRegion><flowPara
+         id="flowPara4412-9">Standard actions for the application that are currently exported.</flowPara></flowRoot>    <flowRoot
+       transform="translate(0.17314,436.00144)"
+       xml:space="preserve"
+       id="flowRoot4406-7-6"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"><flowRegion
+         id="flowRegion4408-2-4"><rect
+           id="rect4410-6-7"
+           width="259.08862"
+           height="118.36957"
+           x="642.34113"
+           y="455.41806" /></flowRegion><flowPara
+         id="flowPara4412-9-9">Menus for the window including the labels and icons.</flowPara></flowRoot>    <flowRoot
+       transform="translate(0.17314,495.92308)"
+       xml:space="preserve"
+       id="flowRoot4406-7-6-5"
+       style="font-size:18px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;letter-spacing:0px;word-spacing:0px;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Ubuntu;-inkscape-font-specification:Ubuntu"><flowRegion
+         id="flowRegion4408-2-4-9"><rect
+           id="rect4410-6-7-3"
+           width="259.08862"
+           height="118.36957"
+           x="642.34113"
+           y="455.41806" /></flowRegion><flowPara
+         id="flowPara4412-9-9-5">Variables required for the semantic arguments including things like paper size for printing.</flowPara></flowRoot>  </g>
+</svg>

=== added directory 'po'
=== added file 'po/POTFILES.in'
--- po/POTFILES.in	1970-01-01 00:00:00 +0000
+++ po/POTFILES.in	2011-11-27 16:45:51 +0000
@@ -0,0 +1,11 @@
+service/hud-service.c
+service/indicator-tracker.c
+service/hud-dbus.c
+service/dbusmenu-collector.c
+service/usage-tracker.c
+service/hud.interface.c
+service/hud-search.c
+service/hud-cli.c
+service/distance.c
+service/load-app-info.c
+service/dump-app-info.c

=== added directory 'service'
=== added file 'service/Makefile.am'
--- service/Makefile.am	1970-01-01 00:00:00 +0000
+++ service/Makefile.am	2011-11-27 16:44:45 +0000
@@ -0,0 +1,116 @@
+
+BUILT_SOURCES =
+CLEANFILES =
+DISTCLEANFILES =
+EXTRA_DIST = \
+	hud-list-applications
+
+libexec_PROGRAMS = \
+	hud-cli \
+	hud-dump-application \
+	hud-service \
+	hud-verify-app-info
+
+libexec_SCRIPTS = \
+	hud-list-applications
+
+####################
+# HUD Service
+####################
+
+hud_service_SOURCES = \
+	dbusmenu-collector.h \
+	dbusmenu-collector.c \
+	distance.h \
+	distance.c \
+	dump-app-info.h \
+	dump-app-info.c \
+	shared-values.h \
+	hud-service.c \
+	hud-dbus.h \
+	hud-dbus.c \
+	hud-search.h \
+	hud-search.c \
+	hud.interface.h \
+	hud.interface.c \
+	indicator-tracker.h \
+	indicator-tracker.c \
+	load-app-info.h \
+	load-app-info.c \
+	usage-tracker.h \
+	usage-tracker.c
+
+hud_service_CFLAGS = \
+	$(HUD_CFLAGS) \
+	-DDATADIR=\""$(datadir)"\" \
+	-Wall -Werror
+hud_service_LDFLAGS = \
+	$(HUD_LIBS)
+
+####################
+# HUD CLI
+####################
+
+hud_cli_SOURCES = \
+	shared-values.h \
+	hud-cli.c \
+	hud.interface.h \
+	hud.interface.c
+
+hud_cli_CFLAGS = \
+	$(HUD_CFLAGS) \
+	-Wall -Werror
+hud_cli_LDFLAGS = \
+	$(HUD_LIBS)
+
+#######################
+# HUD Dump Application
+#######################
+
+hud_dump_application_SOURCES = \
+	dump-app-info.h \
+	dump-app-info.c \
+	hud-dump-application.c
+
+hud_dump_application_CFLAGS = \
+	$(HUD_CFLAGS) \
+	-Wall -Werror
+hud_dump_application_LDFLAGS = \
+	$(HUD_LIBS)
+
+#######################
+# HUD Verify App Info
+#######################
+
+hud_verify_app_info_SOURCES = \
+	load-app-info.h \
+	load-app-info.c \
+	hud-verify-app-info.c
+
+hud_verify_app_info_CFLAGS = \
+	$(HUD_CFLAGS) \
+	-Wall -Werror
+hud_verify_app_info_LDFLAGS = \
+	$(HUD_LIBS)
+
+####################
+# DBus Interface
+####################
+
+EXTRA_DIST += \
+	hud.xml
+
+BUILT_SOURCES += \
+	hud.interface.c \
+	hud.interface.h
+
+%.interface.h: %.xml
+	echo "extern const char * $(subst -,_,$(subst .,_,$(basename $(notdir $@))));" > $@
+
+%.interface.c: %.xml
+	echo "const char * $(subst -,_,$(subst .,_,$(basename $(notdir $@)))) = " > $@
+	sed -e "s:\":\\\\\":g" -e s:^:\": -e s:\$$:\\\\n\": $< >> $@
+	echo ";" >> $@
+
+
+CLEANFILES += $(BUILT_SOURCES)

=== added file 'service/dbusmenu-collector.c'
--- service/dbusmenu-collector.c	1970-01-01 00:00:00 +0000
+++ service/dbusmenu-collector.c	2011-12-05 15:23:17 +0000
@@ -0,0 +1,614 @@
+/*
+An object to collect the various DBusmenu objects that exist
+on dbus.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <gio/gio.h>
+#include <glib.h>
+#include <glib/gi18n.h>
+
+#include <libdbusmenu-glib/client.h>
+
+#include "dbusmenu-collector.h"
+#include "distance.h"
+#include "indicator-tracker.h"
+#include "shared-values.h"
+
+#define GENERIC_ICON   "dbusmenu-lens-panel"
+
+typedef struct _DbusmenuCollectorPrivate DbusmenuCollectorPrivate;
+
+struct _DbusmenuCollectorPrivate {
+	GDBusConnection * bus;
+	guint signal;
+	GHashTable * hash;
+	IndicatorTracker * tracker;
+};
+
+struct _DbusmenuCollectorFound {
+	gchar * dbus_addr;
+	gchar * dbus_path;
+	gint dbus_id;
+
+	gchar * display_string;
+	gchar * db_string;
+
+	guint distance;
+	DbusmenuMenuitem * item;
+	gchar * indicator;
+};
+
+typedef struct _menu_key_t menu_key_t;
+struct _menu_key_t {
+	gchar * sender;
+	gchar * path;
+};
+
+typedef struct _search_item_t search_item_t;
+struct _search_item_t {
+	gchar * string;
+	guint distance;
+};
+
+static void dbusmenu_collector_class_init (DbusmenuCollectorClass *klass);
+static void dbusmenu_collector_init       (DbusmenuCollector *self);
+static void dbusmenu_collector_dispose    (GObject *object);
+static void dbusmenu_collector_finalize   (GObject *object);
+static void update_layout_cb (GDBusConnection * connection, const gchar * sender, const gchar * path, const gchar * interface, const gchar * signal, GVariant * params, gpointer user_data);
+static guint menu_hash_func (gconstpointer key);
+static gboolean menu_equal_func (gconstpointer a, gconstpointer b);
+static void menu_key_destroy (gpointer key);
+static DbusmenuCollectorFound * dbusmenu_collector_found_new (DbusmenuClient * client, DbusmenuMenuitem * item, GStrv strings, guint distance, GStrv usedstrings, const gchar * indicator_name);
+
+G_DEFINE_TYPE (DbusmenuCollector, dbusmenu_collector, G_TYPE_OBJECT);
+
+static void
+dbusmenu_collector_class_init (DbusmenuCollectorClass *klass)
+{
+	GObjectClass *object_class = G_OBJECT_CLASS (klass);
+
+	g_type_class_add_private (klass, sizeof (DbusmenuCollectorPrivate));
+
+	object_class->dispose = dbusmenu_collector_dispose;
+	object_class->finalize = dbusmenu_collector_finalize;
+
+	return;
+}
+
+static void
+dbusmenu_collector_init (DbusmenuCollector *self)
+{
+	self->priv = G_TYPE_INSTANCE_GET_PRIVATE ((self), DBUSMENU_COLLECTOR_TYPE, DbusmenuCollectorPrivate);
+
+	self->priv->bus = NULL;
+	self->priv->signal = 0;
+	self->priv->hash = NULL;
+	self->priv->tracker = NULL;
+
+	self->priv->hash = g_hash_table_new_full(menu_hash_func, menu_equal_func,
+	                                         menu_key_destroy, g_object_unref /* DbusmenuClient */);
+
+	self->priv->bus = g_bus_get_sync(G_BUS_TYPE_SESSION, NULL, NULL);
+	self->priv->signal = g_dbus_connection_signal_subscribe(self->priv->bus,
+	                                                        NULL, /* sender */
+	                                                        "com.canonical.dbusmenu", /* interface */
+	                                                        "LayoutUpdated", /* member */
+	                                                        NULL, /* object path */
+	                                                        NULL, /* arg0 */
+	                                                        G_DBUS_SIGNAL_FLAGS_NONE, /* flags */
+	                                                        update_layout_cb, /* cb */
+	                                                        self, /* data */
+	                                                        NULL); /* free func */
+
+	GError * error = NULL;
+	g_dbus_connection_emit_signal(self->priv->bus,
+	                              NULL, /* destination */
+	                              "/", /* object */
+	                              "com.canonical.dbusmenu",
+	                              "FindServers",
+	                              NULL, /* params */
+	                              &error);
+	if (error != NULL) {
+		g_warning("Unable to emit 'FindServers': %s", error->message);
+		g_error_free(error);
+	}
+
+	self->priv->tracker = indicator_tracker_new();
+
+	return;
+}
+
+static void
+dbusmenu_collector_dispose (GObject *object)
+{
+	DbusmenuCollector * collector = DBUSMENU_COLLECTOR(object);
+
+	if (collector->priv->signal != 0) {
+		g_dbus_connection_signal_unsubscribe(collector->priv->bus, collector->priv->signal);
+		collector->priv->signal = 0;
+	}
+
+	if (collector->priv->hash != NULL) {
+		g_hash_table_destroy(collector->priv->hash);
+		collector->priv->hash = NULL;
+	}
+
+	if (collector->priv->tracker != NULL) {
+		g_object_unref(collector->priv->tracker);
+		collector->priv->tracker = NULL;
+	}
+
+	G_OBJECT_CLASS (dbusmenu_collector_parent_class)->dispose (object);
+	return;
+}
+
+static void
+dbusmenu_collector_finalize (GObject *object)
+{
+
+	G_OBJECT_CLASS (dbusmenu_collector_parent_class)->finalize (object);
+	return;
+}
+
+DbusmenuCollector *
+dbusmenu_collector_new (void)
+{
+	return DBUSMENU_COLLECTOR(g_object_new(DBUSMENU_COLLECTOR_TYPE, NULL));
+}
+
+static void
+update_layout_cb (GDBusConnection * connection, const gchar * sender, const gchar * path, const gchar * interface, const gchar * signal, GVariant * params, gpointer user_data)
+{
+	g_debug("Client updating %s:%s", sender, path);
+	DbusmenuCollector * collector = DBUSMENU_COLLECTOR(user_data);
+	g_return_if_fail(collector != NULL);
+
+	menu_key_t search_key = {
+		sender: (gchar *)sender,
+		path:   (gchar *)path
+	};
+
+	gpointer found = g_hash_table_lookup(collector->priv->hash, &search_key);
+	if (found == NULL) {
+		/* Build one becasue we don't have it */
+		menu_key_t * built_key = g_new0(menu_key_t, 1);
+		built_key->sender = g_strdup(sender);
+		built_key->path = g_strdup(path);
+
+		DbusmenuClient * client = dbusmenu_client_new(sender, path);
+
+		g_hash_table_insert(collector->priv->hash, built_key, client);
+	}
+
+	/* Assume that dbusmenu client is doing this for us */
+	return;
+}
+
+static guint
+menu_hash_func (gconstpointer key)
+{
+	const menu_key_t * mk = (const menu_key_t*)key;
+
+	return g_str_hash(mk->sender) + g_str_hash(mk->path) - 5381;
+}
+
+static gboolean
+menu_equal_func (gconstpointer a, gconstpointer b)
+{
+	const menu_key_t * ak = (const menu_key_t *)a;
+	const menu_key_t * bk = (const menu_key_t *)b;
+
+	if (g_strcmp0(ak->sender, bk->sender) == 0) {
+		return TRUE;
+	}
+
+	if (g_strcmp0(ak->path, bk->path) == 0) {
+		return TRUE;
+	}
+
+	return FALSE;
+}
+
+static void
+menu_key_destroy (gpointer key)
+{
+	menu_key_t * ikey = (menu_key_t *)key;
+
+	g_free(ikey->sender);
+	g_free(ikey->path);
+
+	g_free(ikey);
+	return;
+}
+
+gchar *
+remove_underline (const gchar * input)
+{
+	const gchar * in = input;
+	gchar * output = g_new0(gchar, g_utf8_strlen(input, -1) + 1);
+	gchar * out = output;
+
+	while (in[0] != '\0') {
+		if (in[0] == '_') {
+			in++;
+		} else {
+			out[0] = in[0];
+			in++;
+			out++;
+		}
+	}
+
+	return output;
+}
+
+static GList *
+tokens_to_children (DbusmenuMenuitem * rootitem, const gchar * search, GList * results, GStrv label_prefix, DbusmenuClient * client, const gchar * indicator_name)
+{
+	if (search == NULL) {
+		return results;
+	}
+
+	if (rootitem == NULL) {
+		return results;
+	}
+
+	if (!dbusmenu_menuitem_property_get_bool(rootitem, DBUSMENU_MENUITEM_PROP_ENABLED)) {
+		return results;
+	}
+
+	if (!dbusmenu_menuitem_property_get_bool(rootitem, DBUSMENU_MENUITEM_PROP_VISIBLE)) {
+		return results;
+	}
+
+	GStrv newstr = NULL;
+	if (dbusmenu_menuitem_property_exist(rootitem, DBUSMENU_MENUITEM_PROP_LABEL) &&
+			!dbusmenu_menuitem_property_exist(rootitem, DBUSMENU_MENUITEM_PROP_TYPE)) {
+		const gchar * label = dbusmenu_menuitem_property_get(rootitem, DBUSMENU_MENUITEM_PROP_LABEL);
+
+		if (label_prefix != NULL && label_prefix[0] != NULL) {
+			gint i;
+			guint prefix_len = g_strv_length(label_prefix);
+			newstr = g_new(gchar *, prefix_len + 2);
+
+			for (i = 0; i < prefix_len; i++) {
+				newstr[i] = g_strdup(label_prefix[i]);
+			}
+
+			newstr[prefix_len] = g_strdup(label);
+			newstr[prefix_len + 1] = NULL;
+		} else {
+			newstr = g_new0(gchar *, 2);
+			newstr[0] = g_strdup(label);
+			newstr[1] = NULL;
+		}
+	}
+
+	if (!dbusmenu_menuitem_get_root(rootitem) && newstr != NULL) {
+		GStrv used_strings = NULL;
+		guint distance = calculate_distance(search, newstr, &used_strings);
+		if (distance < G_MAXUINT) {
+			// g_debug("Distance %d for '%s' in \"'%s'\" using \"'%s'\"", distance, search, g_strjoinv("' '", newstr), g_strjoinv("' '", used_strings));
+			results = g_list_prepend(results, dbusmenu_collector_found_new(client, rootitem, newstr, distance, used_strings, indicator_name));
+		}
+		g_strfreev(used_strings);
+	}
+
+	if (newstr == NULL) {
+		newstr = g_strdupv(label_prefix);
+	}
+
+	GList * children = dbusmenu_menuitem_get_children(rootitem);
+	GList * child;
+
+	for (child = children; child != NULL; child = g_list_next(child)) {
+		DbusmenuMenuitem * item = DBUSMENU_MENUITEM(child->data);
+
+		results = tokens_to_children(item, search, results, newstr, client, indicator_name);
+	}
+
+	g_strfreev(newstr);
+	return results;
+}
+
+static GList *
+process_client (DbusmenuCollector * collector, DbusmenuClient * client, const gchar * search, GList * results, const gchar * indicator_name, GStrv prefix)
+{
+	/* Handle the case where there are no search terms */
+	if (search == NULL || search[0] == '\0') {
+		GList * children = dbusmenu_menuitem_get_children(dbusmenu_client_get_root(client));
+		GList * child;
+
+		for (child = children; child != NULL; child = g_list_next(child)) {
+			DbusmenuMenuitem * item = DBUSMENU_MENUITEM(child->data);
+
+			if (!dbusmenu_menuitem_property_exist(item, DBUSMENU_MENUITEM_PROP_LABEL)) {
+				continue;
+			}
+
+			const gchar * label = dbusmenu_menuitem_property_get(item, DBUSMENU_MENUITEM_PROP_LABEL);
+			const gchar * array[2];
+			array[0] = label;
+			array[1] = NULL;
+
+			results = g_list_prepend(results, dbusmenu_collector_found_new(client, item, (GStrv)array, calculate_distance(NULL, (GStrv)array, NULL), NULL, indicator_name));
+		}
+
+		return results;
+	}
+
+	results = tokens_to_children(dbusmenu_client_get_root(client), search, results, prefix, client, indicator_name);
+	return results;
+}
+
+static GList *
+just_do_it (DbusmenuCollector * collector, const gchar * dbus_addr, const gchar * dbus_path, const gchar * search, GList * results, const gchar * indicator_name, GStrv prefix)
+{
+	g_return_val_if_fail(IS_DBUSMENU_COLLECTOR(collector), results);
+
+	menu_key_t search_key = {
+		sender: (gchar *)dbus_addr,
+		path:   (gchar *)dbus_path
+	};
+
+	gpointer found = g_hash_table_lookup(collector->priv->hash, &search_key);
+	if (found != NULL) {
+		results = process_client(collector, DBUSMENU_CLIENT(found), search, results, indicator_name, prefix);
+	}
+
+	return results;
+}
+
+static gint
+dbusmenu_collector_found_sort (gconstpointer a, gconstpointer b)
+{
+	DbusmenuCollectorFound * founda;
+	DbusmenuCollectorFound * foundb;
+
+	founda = (DbusmenuCollectorFound *)a;
+	foundb = (DbusmenuCollectorFound *)b;
+
+	return dbusmenu_collector_found_get_distance(founda) - dbusmenu_collector_found_get_distance(foundb);
+}
+
+GList *
+dbusmenu_collector_search (DbusmenuCollector * collector, const gchar * dbus_addr, const gchar * dbus_path, const gchar * search)
+{
+	GList * items = NULL;
+
+	if (dbus_addr != NULL && dbus_path != NULL) {
+		items = just_do_it(collector, dbus_addr, dbus_path, search, NULL, NULL, NULL);
+	}
+
+	/* This is where we'll do the indicators if we're not
+	   looking at the null search.  In that case we'll let
+	   the client take over. */
+	if (search != NULL && search[0] != '\0') {
+		GArray * indicators = indicator_tracker_get_indicators(collector->priv->tracker);
+		gint indicator_cnt;
+		for (indicator_cnt = 0; indicator_cnt < indicators->len; indicator_cnt++) {
+			IndicatorTrackerIndicator * indicator = &g_array_index(indicators, IndicatorTrackerIndicator, indicator_cnt);
+
+			gchar * array[2];
+			array[0] = indicator->prefix;
+			array[1] = NULL;
+
+			GList * iitems = just_do_it(collector, indicator->dbus_name, indicator->dbus_object, search, NULL, indicator->name, array);
+
+			/* Increase indicator's distance by 50% */
+			GList * iitem = iitems;
+			while (iitem != NULL) {
+				DbusmenuCollectorFound * found = (DbusmenuCollectorFound *)iitem->data;
+				found->distance = found->distance + (found->distance / 2);
+				iitem = g_list_next(iitem);
+			}
+
+			items = g_list_concat(items, iitems);
+		}
+	}
+
+	items = g_list_sort(items, dbusmenu_collector_found_sort);
+
+	return items;
+}
+
+void
+dbusmenu_collector_execute (DbusmenuCollector * collector, const gchar * dbus_addr, const gchar * dbus_path, gint id, guint timestamp)
+{
+	g_return_if_fail(IS_DBUSMENU_COLLECTOR(collector));
+
+	menu_key_t search_key = {
+		sender: (gchar *)dbus_addr,
+		path:   (gchar *)dbus_path
+	};
+
+	gpointer found = g_hash_table_lookup(collector->priv->hash, &search_key);
+	if (found == NULL) {
+		g_warning("Unable to find dbusmenu client: %s:%s", dbus_addr, dbus_path);
+		return;
+	}
+
+	DbusmenuMenuitem * root = dbusmenu_client_get_root(DBUSMENU_CLIENT(found));
+	if (root == NULL) {
+		g_warning("Dbusmenu Client %s:%s has no menuitems", dbus_addr, dbus_path);
+		return;
+	}
+
+	DbusmenuMenuitem * item = dbusmenu_menuitem_find_id(root, id);
+	if (item == NULL) {
+		g_warning("Unable to find menuitem %d on client %s:%s", id, dbus_addr, dbus_path);
+		return;
+	}
+
+	g_debug("Executing menuitem %d: %s", id, dbusmenu_menuitem_property_get(item, DBUSMENU_MENUITEM_PROP_LABEL));
+	dbusmenu_menuitem_handle_event(item, DBUSMENU_MENUITEM_EVENT_ACTIVATED, NULL, timestamp);
+
+	return;
+}
+
+guint
+dbusmenu_collector_found_get_distance (DbusmenuCollectorFound * found)
+{
+	g_return_val_if_fail(found != NULL, G_MAXUINT);
+	return found->distance;
+}
+
+const gchar *
+dbusmenu_collector_found_get_display (DbusmenuCollectorFound * found)
+{
+	g_return_val_if_fail(found != NULL, NULL);
+	return found->display_string;
+}
+
+const gchar *
+dbusmenu_collector_found_get_db (DbusmenuCollectorFound * found)
+{
+	g_return_val_if_fail(found != NULL, NULL);
+	return found->db_string;
+}
+
+void
+dbusmenu_collector_found_list_free (GList * found_list)
+{
+	g_list_free_full(found_list, (GDestroyNotify)dbusmenu_collector_found_free);
+	return;
+}
+
+static DbusmenuCollectorFound *
+dbusmenu_collector_found_new (DbusmenuClient * client, DbusmenuMenuitem * item, GStrv strings, guint distance, GStrv usedstrings, const gchar * indicator_name)
+{
+	// g_debug("New Found: '%s', %d, '%s'", string, distance, indicator_name);
+	DbusmenuCollectorFound * found = g_new0(DbusmenuCollectorFound, 1);
+
+	g_object_get(client,
+	             DBUSMENU_CLIENT_PROP_DBUS_NAME, &found->dbus_addr,
+	             DBUSMENU_CLIENT_PROP_DBUS_OBJECT, &found->dbus_path,
+	             NULL);
+	found->dbus_id = dbusmenu_menuitem_get_id(item);
+
+	found->db_string = g_strjoinv(DB_SEPARATOR, strings);
+	found->distance = distance;
+	found->item = item;
+	found->indicator = NULL;
+
+	found->display_string = NULL;
+	if (strings != NULL) {
+		static gchar * connector = NULL;
+
+		if (connector == NULL) {
+			/* TRANSLATORS: This string is a printf format string to build
+			   a string representing menu hierarchy in an application.  The
+			   strings are <top> <separator> <bottom>.  So if the separator
+			   is ">" and the item is "Open" in the "File" menu the final
+			   string would be "File > Open" */
+			connector = g_markup_escape_text(_("%s > %s"), -1);
+		}
+
+		gchar * firstunderline = remove_underline(strings[0]);
+		found->display_string = g_markup_escape_text(firstunderline, -1);
+		g_free(firstunderline);
+		int i;
+		for (i = 1; strings[i] != NULL; i++) {
+			gchar * nounder = remove_underline(strings[i]);
+			gchar * escaped = g_markup_escape_text(nounder, -1);
+			gchar * tmp = g_strdup_printf(connector, found->display_string, escaped);
+			g_free(found->display_string);
+			g_free(escaped);
+			g_free(nounder);
+			found->display_string = tmp;
+		}
+
+		/* NOTE: Should probably find some way to use remalloc here, not sure
+		   how to do that with the escaping and the translated connector
+		   though.  Will take some thinking. */
+	}
+
+	if (found->display_string != NULL && usedstrings != NULL) {
+		int str;
+		for (str = 0; usedstrings[str] != NULL; str++) {
+			if (usedstrings[str][0] == '\0') continue; // No NULL strings
+			gchar * nounder = remove_underline(usedstrings[str]);
+			GStrv split = g_strsplit(found->display_string, nounder, -1);
+			gchar * bold = g_strconcat("<b>", nounder, "</b>", NULL);
+			gchar * tmp = g_strjoinv(bold, split);
+
+			g_free(found->display_string);
+			found->display_string = tmp;
+
+			g_strfreev(split);
+			g_free(bold);
+			g_free(nounder);
+		}
+	}
+
+	if (indicator_name != NULL) {
+		found->indicator = g_strdup(indicator_name);
+	}
+
+	g_object_ref(G_OBJECT(item));
+
+	return found;
+}
+
+void
+dbusmenu_collector_found_free (DbusmenuCollectorFound * found)
+{
+	g_return_if_fail(found != NULL);
+	g_free(found->dbus_addr);
+	g_free(found->dbus_path);
+	g_free(found->display_string);
+	g_free(found->db_string);
+	g_free(found->indicator);
+	g_object_unref(found->item);
+	g_free(found);
+	return;
+}
+
+const gchar *
+dbusmenu_collector_found_get_indicator (DbusmenuCollectorFound * found)
+{
+	// g_debug("Getting indicator for found '%s', indicator: '%s'", found->display_string, found->indicator);
+	g_return_val_if_fail(found != NULL, NULL);
+	return found->indicator;
+}
+
+const gchar *
+dbusmenu_collector_found_get_dbus_addr (DbusmenuCollectorFound * found)
+{
+	g_return_val_if_fail(found != NULL, NULL);
+	return found->dbus_addr;
+}
+
+const gchar *
+dbusmenu_collector_found_get_dbus_path (DbusmenuCollectorFound * found)
+{
+	g_return_val_if_fail(found != NULL, NULL);
+	return found->dbus_path;
+}
+
+gint
+dbusmenu_collector_found_get_dbus_id (DbusmenuCollectorFound * found)
+{
+	g_return_val_if_fail(found != NULL, -1);
+	return found->dbus_id;
+}

=== added file 'service/dbusmenu-collector.h'
--- service/dbusmenu-collector.h	1970-01-01 00:00:00 +0000
+++ service/dbusmenu-collector.h	2011-12-01 15:46:20 +0000
@@ -0,0 +1,70 @@
+/*
+An object to collect the various DBusmenu objects that exist
+on dbus.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __DBUSMENU_COLLECTOR_H__
+#define __DBUSMENU_COLLECTOR_H__
+
+#include <glib.h>
+#include <glib-object.h>
+
+G_BEGIN_DECLS
+
+#define DBUSMENU_COLLECTOR_TYPE            (dbusmenu_collector_get_type ())
+#define DBUSMENU_COLLECTOR(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), DBUSMENU_COLLECTOR_TYPE, DbusmenuCollector))
+#define DBUSMENU_COLLECTOR_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), DBUSMENU_COLLECTOR_TYPE, DbusmenuCollectorClass))
+#define IS_DBUSMENU_COLLECTOR(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DBUSMENU_COLLECTOR_TYPE))
+#define IS_DBUSMENU_COLLECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DBUSMENU_COLLECTOR_TYPE))
+#define DBUSMENU_COLLECTOR_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), DBUSMENU_COLLECTOR_TYPE, DbusmenuCollectorClass))
+
+typedef struct _DbusmenuCollector          DbusmenuCollector;
+typedef struct _DbusmenuCollectorClass     DbusmenuCollectorClass;
+typedef struct _DbusmenuCollectorPrivate   DbusmenuCollectorPrivate;
+typedef struct _DbusmenuCollectorFound     DbusmenuCollectorFound;
+
+struct _DbusmenuCollectorClass {
+	GObjectClass parent_class;
+};
+
+struct _DbusmenuCollector {
+	GObject parent;
+
+	DbusmenuCollectorPrivate * priv;
+};
+
+GType dbusmenu_collector_get_type (void);
+DbusmenuCollector * dbusmenu_collector_new (void);
+GList * dbusmenu_collector_search (DbusmenuCollector * collector, const gchar * dbus_addr, const gchar * dbus_path, const gchar * search);
+void dbusmenu_collector_execute (DbusmenuCollector * collector, const gchar * dbus_addr, const gchar * dbus_path, gint id, guint timestamp);
+
+guint dbusmenu_collector_found_get_distance (DbusmenuCollectorFound * found);
+const gchar * dbusmenu_collector_found_get_display (DbusmenuCollectorFound * found);
+const gchar * dbusmenu_collector_found_get_db (DbusmenuCollectorFound * found);
+void dbusmenu_collector_found_free (DbusmenuCollectorFound * found);
+void dbusmenu_collector_found_list_free (GList * found_list);
+const gchar *  dbusmenu_collector_found_get_indicator (DbusmenuCollectorFound * found);
+const gchar * dbusmenu_collector_found_get_dbus_addr (DbusmenuCollectorFound * found);
+const gchar * dbusmenu_collector_found_get_dbus_path (DbusmenuCollectorFound * found);
+gint dbusmenu_collector_found_get_dbus_id (DbusmenuCollectorFound * found);
+
+G_END_DECLS
+
+#endif

=== added file 'service/distance.c'
--- service/distance.c	1970-01-01 00:00:00 +0000
+++ service/distance.c	2011-12-02 18:53:08 +0000
@@ -0,0 +1,382 @@
+/*
+Functions to calculate the distance between two strings.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <glib.h>
+#include <glib/gprintf.h>
+#include <glib-object.h>
+#include <glib/gi18n.h>
+
+#include "distance.h"
+
+#define ADD_PENALTY 10
+#define PRE_ADD_PENALTY 1
+#define DROP_PENALTY 10
+#define END_DROP_PENALTY 10
+#define TRANSPOSE_PENALTY 10
+#define DELETE_PENALTY 10
+#define SWAP_PENALTY 10
+
+static gboolean
+ignore_character (gchar inchar)
+{
+	static gchar * ignore = NULL;
+	if (ignore == NULL) {
+		/* TRANSLATORS: These are chacaters that should not be considered
+		   mistakes in the comparison functions.  Typically they are gramatical
+		   characters that can be found in menus. */
+		ignore = _(" _->");
+	}
+
+	int i;
+	for (i = 0; i < 4; i++) {
+		if (ignore[i] == inchar) {
+			return TRUE;
+		}
+	}
+	return FALSE;
+}
+
+static guint
+swap_cost (gchar a, gchar b)
+{
+	if (a == b)
+		return 0;
+	if (ignore_character(a) || ignore_character(b))
+		return 0;
+	if (g_unichar_toupper(a) == g_unichar_toupper(b))
+		return SWAP_PENALTY / 10; /* Some penalty, but close */
+	return SWAP_PENALTY;
+}
+
+#define MATRIX_VAL(needle_loc, haystack_loc) (penalty_matrix[(needle_loc + 1) + (haystack_loc + 1) * (len_needle + 1)])
+
+static void
+dumpmatrix (const gchar * needle, guint len_needle, const gchar * haystack, guint len_haystack, guint * penalty_matrix)
+{
+#ifndef DUMP_MATRIX
+	return;
+#endif
+	gint i, j;
+
+	g_printf("\n");
+	/* Character Column */
+	g_printf("  ");
+	/* Base val column */
+	g_printf("  ");
+	for (i = 0; i < len_needle; i++) {
+		g_printf("%c ", needle[i]);
+	}
+	g_printf("\n");
+
+	/* Character Column */
+	g_printf("  ");
+	for (i = -1; i < (gint)len_needle; i++) {
+		g_printf("%u ", MATRIX_VAL(i, -1));
+	}
+	g_printf("\n");
+
+	for (j = 0; j < len_haystack; j++) {
+		g_printf("%c ", haystack[j]);
+		for (i = -1; i < (gint)len_needle; i++) {
+			g_printf("%u ", MATRIX_VAL(i, j));
+		}
+		g_printf("\n");
+	}
+	g_printf("\n");
+
+	return;
+}
+
+static guint
+calculate_token_distance (const gchar * needle, const gchar * haystack)
+{
+	// g_debug("Comparing token '%s' to token '%s'", needle, haystack);
+
+	guint len_needle = 0;
+	guint len_haystack = 0;
+
+	if (needle != NULL) {
+		len_needle = g_utf8_strlen(needle, -1);
+	}
+
+	if (haystack != NULL) {
+		len_haystack = g_utf8_strlen(haystack, -1);
+	}
+
+	/* Handle the cases of very short or NULL strings quickly */
+	if (len_needle == 0) {
+		return DROP_PENALTY * len_haystack;
+	}
+
+	if (len_haystack == 0) {
+		return ADD_PENALTY * len_needle;
+	}
+
+	/* Allocate the matrix of penalties */
+	guint * penalty_matrix = g_malloc0(sizeof(guint) * (len_needle + 1) * (len_haystack + 1));
+	int i;
+
+	/* Take the first row and first column and make them additional letter penalties */
+	for (i = 0; i < len_needle + 1; i++) {
+		MATRIX_VAL(i - 1, -1) = i * ADD_PENALTY;
+	}
+
+	for (i = 0; i < len_haystack + 1; i++) {
+		if (i < len_haystack - len_needle) {
+			MATRIX_VAL(-1, i - 1) = i * PRE_ADD_PENALTY;
+		} else {
+			MATRIX_VAL(-1, i - 1) = (len_haystack - len_needle) * PRE_ADD_PENALTY + (i - (len_haystack - len_needle)) * DROP_PENALTY;
+		}
+	}
+
+	/* Now go through the matrix building up the penalties */
+	int ineedle, ihaystack;
+	for (ineedle = 0; ineedle < len_needle; ineedle++) {
+		for (ihaystack = 0; ihaystack < len_haystack; ihaystack++) {
+			char needle_let = needle[ineedle];
+			char haystack_let = haystack[ihaystack];
+
+			guint subst_pen = MATRIX_VAL(ineedle - 1, ihaystack - 1) + swap_cost(needle_let, haystack_let);
+			guint drop_pen = MATRIX_VAL(ineedle - 1, ihaystack);
+			if (ineedle < ihaystack) {
+				drop_pen += DROP_PENALTY;
+			} else {
+				drop_pen += END_DROP_PENALTY;
+			}
+
+			guint add_pen = MATRIX_VAL(ineedle, ihaystack - 1);
+			if (len_haystack - len_needle - ineedle > 0) {
+				add_pen += PRE_ADD_PENALTY;
+			} else {
+				add_pen += ADD_PENALTY;
+			}
+			guint transpose_pen = drop_pen + 1; /* ensures won't be chosen */
+
+			if (ineedle > 0 && ihaystack > 0 && needle_let == haystack[ihaystack - 1] && haystack_let == needle[ineedle - 1]) {
+				transpose_pen = MATRIX_VAL(ineedle - 2, ihaystack - 2) + TRANSPOSE_PENALTY;
+			}
+
+			MATRIX_VAL(ineedle, ihaystack) = MIN(MIN(subst_pen, drop_pen), MIN(add_pen, transpose_pen));
+		}
+	}
+
+	dumpmatrix(needle, len_needle, haystack, len_haystack, penalty_matrix);
+
+	guint retval = penalty_matrix[(len_needle + 1) * (len_haystack + 1) - 1];
+	g_free(penalty_matrix);
+
+	return retval;
+}
+
+/* Looks through the array of paths and tries to find a minimum path
+   looking up from the needle specified.  This way we can look through
+   all the possible paths */
+guint
+minimize_distance_recurse (guint needle, guint num_needles, guint haystack, guint num_haystacks, guint * distances, guint * matches)
+{
+	gint i;
+
+	/* Put where we are in the array so that we don't forget */
+	matches[needle] = haystack;
+
+	/* First check to see if we've already used this entry */
+	for (i = needle - 1; i >= 0; i--) {
+		if (matches[i] == haystack) {
+			return G_MAXUINT;
+		}
+	}
+
+	/* If we're the last needle, we can return our distance */
+	if (needle + 1 >= num_needles) {
+		return distances[(needle * num_haystacks) + haystack];
+	}
+
+	guint * local_match = g_new0(guint, num_needles);
+	for (i = 0; i < num_needles && i < needle + 1; i++) {
+		local_match[i] = matches[i];
+	}
+
+	/* Now look where we can get the minimum with the other needles */
+	guint min = G_MAXUINT;
+	for (i = 0; i < num_haystacks; i++) {
+		guint local = minimize_distance_recurse(needle + 1, num_needles, i, num_haystacks, distances, local_match);
+
+		if (local < min) {
+			min = local;
+
+			int j;
+			for (j = needle + 1; j < num_needles; j++) {
+				matches[j] = local_match[j];
+			}
+		}
+	}
+
+	g_free(local_match);
+
+	/* Return the min of everyone else plus our distance */
+	if (min < G_MAXUINT) {
+		min += distances[(needle * num_haystacks) + haystack];
+	}
+
+	return min;
+}
+
+/* Figuring out the lowest path through the distance array
+   where we don't use the same haystack tokens */
+guint
+minimize_distance (guint num_needles, guint num_haystacks, guint * distances, guint * matches)
+{
+	guint final_distance = G_MAXUINT;
+	guint * local_matches = g_new0(guint, num_needles);
+
+	guint haystack_token;
+	for (haystack_token = 0; haystack_token < num_haystacks; haystack_token++) {
+		guint distance = minimize_distance_recurse(0, num_needles, haystack_token, num_haystacks, distances, local_matches);
+
+		if (distance < final_distance) {
+			final_distance = distance;
+
+			guint match_cnt;
+			for (match_cnt = 0; match_cnt < num_needles; match_cnt++) {
+				matches[match_cnt] = local_matches[match_cnt];
+			}
+		}
+	}
+
+	g_free(local_matches);
+
+	return final_distance;
+}
+
+/* Dups a specific token in the array of strv arrays */
+gchar *
+find_token (guint token_number, GStrv * haystacks, guint num_haystacks)
+{
+	guint haystack;
+
+	for (haystack = 0; haystack < num_haystacks; haystack++) {
+		guint strvlen = g_strv_length(haystacks[haystack]);
+
+		if (token_number < strvlen) {
+			return g_strdup(haystacks[haystack][token_number]);
+		}
+
+		token_number -= strvlen;
+	}
+
+	return NULL;
+}
+
+#define SEPARATORS " .->"
+
+guint
+calculate_distance (const gchar * needle, GStrv haystacks, GStrv * matches)
+{
+	g_return_val_if_fail(needle != NULL || haystacks != NULL, G_MAXUINT);
+	guint final_distance = G_MAXUINT;
+
+	if (needle == NULL) {
+		return DROP_PENALTY * g_utf8_strlen(haystacks[0], 1024);
+	}
+	if (haystacks == NULL) {
+		return ADD_PENALTY * g_utf8_strlen(needle, 1024);
+	}
+
+	/* Tokenize all the haystack strings */
+	gint i;
+	guint num_haystacks = g_strv_length(haystacks);
+	guint num_haystack_tokens = 0;
+	GStrv * haystacks_array = g_new0(GStrv, num_haystacks);
+	for (i = 0; i < num_haystacks; i++) {
+		haystacks_array[i] = g_strsplit_set(haystacks[i], SEPARATORS, 0);
+		num_haystack_tokens += g_strv_length(haystacks_array[i]);
+	}
+
+	/* Tokenize our needles the same way */
+	GStrv needle_tokens = g_strsplit_set(needle, SEPARATORS, 0);
+	guint num_needle_tokens = g_strv_length(needle_tokens);
+
+	/* If we can't even find a set that works, let's just cut
+	   our losses here */
+	if (num_needle_tokens > num_haystack_tokens) {
+		goto cleanup_tokens;
+	}
+
+	/* We need a place to store all the distances */
+	guint * distances = g_new0(guint, num_haystack_tokens * num_needle_tokens);
+
+	/* Calculate all the distance combinations */
+	gint needle_token;
+	for (needle_token = 0; needle_tokens[needle_token] != NULL; needle_token++) {
+		gchar * ineedle = needle_tokens[needle_token];
+
+		guint haystacks_cnt;
+		guint haystack_token_cnt = 0;
+		for (haystacks_cnt = 0; haystacks_cnt < num_haystacks; haystacks_cnt++) {
+			guint haystack_cnt;
+			for (haystack_cnt = 0; haystacks_array[haystacks_cnt][haystack_cnt] != NULL; haystack_cnt++) {
+				gchar * ihaystack = haystacks_array[haystacks_cnt][haystack_cnt];
+				guint distance = calculate_token_distance(ineedle, ihaystack);
+
+				distances[(needle_token * num_haystack_tokens) + haystack_token_cnt] = distance;
+				haystack_token_cnt++;
+			}
+		}
+	}
+
+	/* Now, try to find a path through the array that results in the
+	   lowest total value */
+	guint * final_matches = g_new0(guint, num_needle_tokens);
+
+	final_distance = minimize_distance(num_needle_tokens, num_haystack_tokens, distances, final_matches);
+
+	/* Set up an array for matches so that we can enter
+	   the items as we go */
+	if (matches != NULL) {
+		GStrv match_array = NULL;
+		match_array = g_new0(gchar *, num_needle_tokens + 1);
+		match_array[num_needle_tokens] = NULL;
+
+		/* Copy the strings that we care about */
+		int i;
+		for (i = 0; i < num_needle_tokens; i++) {
+			match_array[i] = find_token(final_matches[i], haystacks_array, num_haystacks);
+		}
+
+		*matches = match_array;
+	}
+
+	g_free(final_matches);
+	g_free(distances);
+
+cleanup_tokens:
+	g_strfreev(needle_tokens);
+	for (i = 0; i < num_haystacks; i++) {
+		g_strfreev(haystacks_array[i]);
+	}
+	g_free(haystacks_array);
+
+	if (final_distance != G_MAXUINT) {
+		return final_distance / num_needle_tokens;
+	} else {
+		return G_MAXUINT;
+	}
+}

=== added file 'service/distance.h'
--- service/distance.h	1970-01-01 00:00:00 +0000
+++ service/distance.h	2011-12-01 22:02:42 +0000
@@ -0,0 +1,31 @@
+/*
+Functions to calculate the distance between two strings.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __DISTANCE_H__
+#define __DISTANCE_H__
+
+G_BEGIN_DECLS
+
+guint calculate_distance (const gchar * needle, GStrv haystack, GStrv * matched);
+
+G_END_DECLS
+
+#endif /* __DISTANCE_H__ */

=== added file 'service/dump-app-info.c'
--- service/dump-app-info.c	1970-01-01 00:00:00 +0000
+++ service/dump-app-info.c	2011-12-01 15:15:55 +0000
@@ -0,0 +1,174 @@
+/*
+Prints out application info for debugging and CLI tools
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "dump-app-info.h"
+#include "shared-values.h"
+
+typedef enum _tree_type_t tree_type_t;
+enum _tree_type_t {
+	MENU_TYPE,
+	ITEM_TYPE
+};
+
+typedef struct _menu_t menu_t;
+struct _menu_t {
+	tree_type_t tree_type;
+	gchar * name;
+	int count;
+	GList * subitems;
+};
+
+GList *
+place_on_tree (GList * tree_in, gchar ** entries)
+{
+	menu_t * menu;
+
+	if (entries[0] == NULL) {
+		return tree_in;
+	}
+
+	GList * entry = tree_in;
+	while (entry != NULL) {
+		menu = (menu_t *)entry->data;
+
+		if (g_strcmp0(menu->name, entries[0]) == 0) {
+			break;
+		}
+
+		entry = g_list_next(entry);
+	}
+
+	if (entry != NULL) {
+		if (menu->tree_type == ITEM_TYPE) {
+			if (entries[1] != NULL) {
+				g_warning("Error parsing on entry '%s'", entries[0]);
+			} else {
+				menu->count++;
+			}
+		} else {
+			menu->subitems = place_on_tree(menu->subitems, &entries[1]);
+		}
+
+		return tree_in;
+	}
+
+	menu = g_new0(menu_t, 1);
+	menu->name = g_strdup(entries[0]);
+
+	if (entries[1] == NULL) {
+		/* This is an item */
+		menu->tree_type = ITEM_TYPE;
+		menu->count = 1;
+		menu->subitems = NULL;
+	} else {
+		/* This is a menu */
+		menu->tree_type = MENU_TYPE;
+		menu->subitems = place_on_tree(NULL, &entries[1]);
+	}
+
+	return g_list_append(tree_in, menu);
+}
+
+static int
+entry_cb (void * user_data, int columns, char ** values, char ** names)
+{
+	GList ** tree = (GList **)user_data;
+
+	gchar ** entries = g_strsplit(values[0], DB_SEPARATOR, -1);
+
+	*tree = place_on_tree(*tree, entries);
+
+	g_strfreev(entries);
+
+	return SQLITE_OK;
+}
+
+void
+print_tree (GList * tree, guint tab_depth)
+{
+	if (tree == NULL) {
+		return;
+	}
+
+	int i;
+	for (i = 0; i < tab_depth; i++) {
+		g_print("\t");
+	}
+
+	menu_t * menu = (menu_t *)tree->data;
+
+	if (menu->tree_type == ITEM_TYPE) {
+		g_print("<item name=\"%s\" count=\"%d\" />\n", menu->name, menu->count);
+	} else {
+		g_print("<menu name=\"%s\">\n", menu->name);
+
+		GList * subs = menu->subitems;
+		while (subs != NULL) {
+			print_tree(subs, tab_depth + 1);
+			subs = g_list_next(subs);
+		}
+
+		for (i = 0; i < tab_depth; i++) {
+			g_print("\t");
+		}
+		g_print("</menu>\n");
+	}
+
+	return;
+}
+
+void
+dump_app_info (const gchar * app, const gchar * domain, sqlite3 * db)
+{
+	g_return_if_fail(app != NULL);
+	g_return_if_fail(db != NULL);
+
+	g_print("<hudappinfo>\n");
+
+	g_print("\t<desktopfile path=\"%s\" />\n", app);
+
+	if (domain != NULL) {
+		g_print("\t<gettext-domain>%s</gettext-domain>\n", domain);
+	}
+
+	gchar * statement = g_strdup_printf("select entry from usage where application = '%s';", app);
+
+	int exec_status = SQLITE_OK;
+	gchar * failstring = NULL;
+	GList * tree = NULL;
+	exec_status = sqlite3_exec(db,
+	                           statement,
+	                           entry_cb, &tree, &failstring);
+	if (exec_status != SQLITE_OK) {
+		g_warning("Unable to get entries: %s", failstring);
+	}
+
+	g_free(statement);
+
+	if (tree != NULL) {
+		g_print("\t<menus>\n");
+		print_tree(tree, 2);
+		g_print("\t</menus>\n");
+	}
+
+	g_print("</hudappinfo>\n");
+	return;
+}

=== added file 'service/dump-app-info.h'
--- service/dump-app-info.h	1970-01-01 00:00:00 +0000
+++ service/dump-app-info.h	2011-11-21 22:01:19 +0000
@@ -0,0 +1,30 @@
+/*
+Prints out application info for debugging and CLI tools
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __DUMP_APP_INFO_H__
+#define __DUMP_APP_INFO_H__
+
+#include <glib.h>
+#include <sqlite3.h>
+
+void dump_app_info (const gchar * app, const gchar * domain, sqlite3 * db);
+
+#endif /* __DUMP_APP_INFO_H__ */

=== added file 'service/hud-cli.c'
--- service/hud-cli.c	1970-01-01 00:00:00 +0000
+++ service/hud-cli.c	2011-11-30 14:45:23 +0000
@@ -0,0 +1,225 @@
+/*
+Small utility to excersise the HUD from the command line
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <glib.h>
+#include <gio/gunixinputstream.h>
+#include <unistd.h>
+#include <stdio.h>
+
+#include "shared-values.h"
+#include "hud.interface.h"
+
+static void input_cb (GObject * object, GAsyncResult * res, gpointer user_data);
+static void print_suggestions(const gchar * query);
+static void execute_query();
+static void append_query (gchar ** query, const gchar * append);
+
+static GMainLoop * mainloop = NULL;
+static gchar * query = NULL;
+static GDBusProxy * proxy = NULL;
+static GVariant * last_key = NULL;
+
+int
+main (int argv, char * argc[])
+{
+	g_type_init();
+
+	query = g_strdup("");
+
+	GInputStream * stdinput = g_unix_input_stream_new(STDIN_FILENO, FALSE);
+	g_return_val_if_fail(stdinput != NULL, 1);
+
+	gchar buffer[256];
+	g_input_stream_read_async(stdinput,
+	                          /* buffer */    buffer,
+	                          /* size */      256,
+	                          /* priority */  G_PRIORITY_DEFAULT,
+	                          /* cancel */    NULL,
+	                          /* callback */  input_cb,
+	                          /* userdata */  buffer);
+
+	GDBusConnection * session = g_bus_get_sync(G_BUS_TYPE_SESSION, NULL, NULL);
+	g_return_val_if_fail(session != NULL, 1);
+
+	GDBusNodeInfo * nodeinfo = g_dbus_node_info_new_for_xml(hud_interface, NULL);
+	g_return_val_if_fail(nodeinfo != NULL, 1);
+
+	GDBusInterfaceInfo * ifaceinfo = g_dbus_node_info_lookup_interface(nodeinfo, DBUS_IFACE);
+	g_return_val_if_fail(ifaceinfo != NULL, 1);
+
+	proxy = g_dbus_proxy_new_sync(session,
+	                              G_DBUS_PROXY_FLAGS_DO_NOT_LOAD_PROPERTIES,
+	                              ifaceinfo,
+	                              DBUS_NAME,
+	                              DBUS_PATH,
+	                              DBUS_IFACE,
+	                              NULL, NULL);
+	g_return_val_if_fail(proxy != NULL, 1);
+
+	print_suggestions(query);
+	g_print("Query: ");
+
+	mainloop = g_main_loop_new(NULL, FALSE);
+	g_main_loop_run(mainloop);
+
+	g_main_loop_unref(mainloop);
+	g_object_unref(proxy);
+	g_dbus_node_info_unref(nodeinfo);
+	g_object_unref(session);
+	g_object_unref(stdinput);
+
+	return 0;
+}
+
+/* Input coming from STDIN */
+static void
+input_cb (GObject * object, GAsyncResult * res, gpointer user_data)
+{
+	GInputStream * stdinput = G_INPUT_STREAM(object);
+	GError * error = NULL;
+	gssize size = 0;
+
+	size = g_input_stream_read_finish(stdinput, res, &error);
+
+	if (error != NULL) {
+		g_error("Error from STDIN: %s", error->message);
+		g_error_free(error);
+		g_main_loop_quit(mainloop);
+		return;
+	}
+
+	if (size == 0 || size == 1) {
+		g_print("Final command, executing\n");
+		execute_query();
+		g_main_loop_quit(mainloop);
+		return;
+	}
+
+	gchar * buffer = (gchar *)user_data;
+	g_input_stream_read_async(stdinput,
+	                          /* buffer */    buffer,
+	                          /* size */      256,
+	                          /* priority */  G_PRIORITY_DEFAULT,
+	                          /* cancel */    NULL,
+	                          /* callback */  input_cb,
+	                          /* userdata */  buffer);
+
+	buffer[size - 1] = '\0';
+
+	append_query(&query, buffer);
+
+	print_suggestions(query);
+	g_print("Query: %s", query);
+
+	return;
+}
+
+static void
+print_suggestions (const gchar * query)
+{
+	GError * error = NULL;
+	GVariant * suggests = g_dbus_proxy_call_sync(proxy,
+	                                             "GetSuggestions",
+	                                             g_variant_new("(s)", query),
+	                                             G_DBUS_CALL_FLAGS_NONE,
+	                                             -1,
+	                                             NULL,
+	                                             &error);
+
+	if (error != NULL) {
+		g_warning("Unable to get suggestions: %s", error->message);
+		g_error_free(error);
+		return;
+	}
+
+	GVariant * appicon = g_variant_get_child_value(suggests, 0);
+	// g_print("Icon: %s\n", g_variant_get_string(appicon, NULL));
+	g_variant_unref(appicon);
+
+	GVariant * target = g_variant_get_child_value(suggests, 1);
+	// g_print("Target: %s\n", g_variant_get_string(target, NULL));
+	g_variant_unref(target);
+
+	GVariant * suggestions = g_variant_get_child_value(suggests, 2);
+	GVariantIter iter;
+	g_variant_iter_init(&iter, suggestions);
+	gchar * suggestion = NULL;
+	gchar * icon = NULL;
+	GVariant * key = NULL;
+
+	if (last_key != NULL) {
+		g_variant_unref(last_key);
+		last_key = NULL;
+	}
+
+	while (g_variant_iter_loop(&iter, "(ssv)", &suggestion, &icon, &key)) {
+		g_print(" %s\n", suggestion);
+		if (last_key == NULL) {
+			last_key = key;
+			g_variant_ref(last_key);
+		}
+	}
+
+	g_variant_unref(suggestions);
+
+	return;
+}
+
+static void
+execute_query (void)
+{
+	GError * error = NULL;
+
+	if (last_key == NULL) {
+		g_warning("Unable to execute without previous suggestion");
+		return;
+	}
+
+	GVariantBuilder tuple;
+	g_variant_builder_init(&tuple, G_VARIANT_TYPE_TUPLE);
+	g_variant_builder_add_value(&tuple, g_variant_new_variant(last_key));
+	g_variant_builder_add_value(&tuple, g_variant_new_uint32(0));
+
+	g_dbus_proxy_call_sync(proxy,
+	                       "ExecuteQuery",
+	                       g_variant_builder_end(&tuple),
+	                       G_DBUS_CALL_FLAGS_NONE,
+	                       -1,
+	                       NULL,
+	                       &error);
+
+	if (error != NULL) {
+		g_warning("Unable to get suggestions: %s", error->message);
+		g_error_free(error);
+		return;
+	}
+
+	return;
+}
+
+static void
+append_query (gchar ** query, const gchar * append)
+{
+	gchar * temp = g_strdup_printf("%s%s", *query, append);
+	g_free(*query);
+	*query = temp;
+	return;
+}

=== added file 'service/hud-dbus.c'
--- service/hud-dbus.c	1970-01-01 00:00:00 +0000
+++ service/hud-dbus.c	2011-11-30 20:28:59 +0000
@@ -0,0 +1,319 @@
+/*
+DBus facing code for the HUD
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <gio/gio.h>
+#include <gio/gdesktopappinfo.h>
+
+#include "shared-values.h"
+#include "hud.interface.h"
+#include "hud-dbus.h"
+#include "hud-search.h"
+
+struct _HudDbusPrivate {
+	GDBusConnection * bus;
+	GCancellable * bus_lookup;
+	guint bus_registration;
+	HudSearch * search;
+};
+
+#define HUD_DBUS_GET_PRIVATE(o) \
+(G_TYPE_INSTANCE_GET_PRIVATE ((o), HUD_DBUS_TYPE, HudDbusPrivate))
+
+static void hud_dbus_class_init (HudDbusClass *klass);
+static void hud_dbus_init       (HudDbus *self);
+static void hud_dbus_dispose    (GObject *object);
+static void hud_dbus_finalize   (GObject *object);
+
+static void bus_got_cb          (GObject *object, GAsyncResult * res, gpointer user_data);
+static void bus_method          (GDBusConnection *connection,
+                                 const gchar *sender,
+                                 const gchar *object_path,
+                                 const gchar *interface_name,
+                                 const gchar *method_name,
+                                 GVariant *parameters,
+                                 GDBusMethodInvocation *invocation,
+                                 gpointer user_data);
+static GVariant * get_suggestions (HudDbus * self, const gchar * query);
+static void execute_query (HudDbus * self, GVariant * key, guint timestamp);
+
+
+G_DEFINE_TYPE (HudDbus, hud_dbus, G_TYPE_OBJECT);
+static GDBusNodeInfo * node_info = NULL;
+static GDBusInterfaceInfo * iface_info = NULL;
+static GDBusInterfaceVTable bus_vtable = {
+	method_call: bus_method,
+	get_property: NULL,
+	set_property: NULL,
+};
+
+static void
+hud_dbus_class_init (HudDbusClass *klass)
+{
+	GObjectClass *object_class = G_OBJECT_CLASS (klass);
+
+	g_type_class_add_private (klass, sizeof (HudDbusPrivate));
+
+	object_class->dispose = hud_dbus_dispose;
+	object_class->finalize = hud_dbus_finalize;
+
+	if (node_info == NULL) {
+		GError * error = NULL;
+
+		node_info = g_dbus_node_info_new_for_xml(hud_interface, &error);
+		if (error != NULL) {
+			g_error("Unable to parse HUD interface: %s", error->message);
+			g_error_free(error);
+		}
+	}
+
+	if (node_info != NULL && iface_info == NULL) {
+		iface_info = g_dbus_node_info_lookup_interface(node_info, DBUS_IFACE);
+		if (iface_info == NULL) {
+			g_error("Unable to find interface '" DBUS_IFACE "'");
+		}
+	}
+
+	return;
+}
+
+static void
+hud_dbus_init (HudDbus *self)
+{
+	self->priv = HUD_DBUS_GET_PRIVATE(self);
+
+	self->priv->bus = NULL;
+	self->priv->bus_lookup = NULL;
+	self->priv->bus_registration = 0;
+	self->priv->search = NULL;
+
+	self->priv->bus_lookup = g_cancellable_new();
+	g_bus_get(G_BUS_TYPE_SESSION, self->priv->bus_lookup, bus_got_cb, self);
+
+	self->priv->search = hud_search_new();
+
+	return;
+}
+
+static void
+hud_dbus_dispose (GObject *object)
+{
+	HudDbus * self = HUD_DBUS(object);
+	g_return_if_fail(self != NULL);
+
+	if (self->priv->bus_lookup != NULL) {
+		g_cancellable_cancel(self->priv->bus_lookup);
+		g_object_unref(self->priv->bus_lookup);
+		self->priv->bus_lookup = NULL;
+	}
+
+	if (self->priv->bus_registration != 0) {
+		g_dbus_connection_unregister_object(self->priv->bus, self->priv->bus_registration);
+		self->priv->bus_registration = 0;
+	}
+
+	if (self->priv->bus != NULL) {
+		g_object_unref(self->priv->bus);
+		self->priv->bus = NULL;
+	}
+
+	if (self->priv->search != NULL) {
+		g_object_unref(self->priv->search);
+		self->priv->search = NULL;
+	}
+
+	G_OBJECT_CLASS (hud_dbus_parent_class)->dispose (object);
+	return;
+}
+
+static void
+hud_dbus_finalize (GObject *object)
+{
+
+	G_OBJECT_CLASS (hud_dbus_parent_class)->finalize (object);
+	return;
+}
+
+HudDbus *
+hud_dbus_new (void)
+{
+	return g_object_new(HUD_DBUS_TYPE, NULL);
+}
+
+static void
+bus_got_cb (GObject *object, GAsyncResult * res, gpointer user_data)
+{
+	GError * error = NULL;
+	HudDbus * self = HUD_DBUS(user_data);
+	GDBusConnection * bus;
+
+	bus = g_bus_get_finish(res, &error);
+	if (error != NULL) {
+		g_critical("Unable to get bus: %s", error->message);
+		g_error_free(error);
+		return;
+	}
+
+	self->priv->bus = bus;
+
+	/* Register object */
+	self->priv->bus_registration = g_dbus_connection_register_object(bus,
+	                                                /* path */       DBUS_PATH,
+	                                                /* interface */  iface_info,
+	                                                /* vtable */     &bus_vtable,
+	                                                /* userdata */   self,
+	                                                /* destroy */    NULL,
+	                                                /* error */      &error);
+
+	return;
+}
+
+static void
+bus_method (GDBusConnection *connection, const gchar *sender, const gchar *object_path, const gchar *interface_name, const gchar *method_name, GVariant *parameters, GDBusMethodInvocation *invocation, gpointer user_data)
+{
+	HudDbus * self = HUD_DBUS(user_data);
+
+	if (g_strcmp0(method_name, "GetSuggestions") == 0) {
+		GVariant * ret = NULL;
+		gchar * query = NULL;
+
+		g_variant_get(parameters, "(s)", &query);
+
+		ret = get_suggestions(self, query);
+
+		g_dbus_method_invocation_return_value(invocation, ret);
+		g_free(query);
+	} else if (g_strcmp0(method_name, "ExecuteQuery") == 0) {
+		GVariant * key = NULL;
+		guint timestamp = 0;
+
+		key = g_variant_get_child_value(parameters, 0);
+		g_variant_get_child(parameters, 1, "u", &timestamp);
+
+		execute_query(self, key, timestamp);
+		
+		g_dbus_method_invocation_return_value(invocation, NULL);
+		g_variant_unref(key);
+	}
+
+	return;
+}
+
+/* Take a path to a desktop file and find its icon */
+static gchar *
+desktop2icon (gchar * desktop)
+{
+	g_return_val_if_fail(desktop != NULL, g_strdup(""));
+
+	if (!g_file_test(desktop, G_FILE_TEST_EXISTS)) {
+		return g_strdup("");
+	}
+
+	/* Try to build an app info from the desktop file
+	   path */
+	GDesktopAppInfo * appinfo = g_desktop_app_info_new_from_filename(desktop);
+
+	if (!G_IS_DESKTOP_APP_INFO(appinfo)) {
+		return g_strdup("");
+	}
+
+	/* Get the name out of the icon, note the icon is not
+	   ref'd so it doesn't need to be free'd */
+	gchar * retval = NULL;
+	GIcon * icon = g_app_info_get_icon(G_APP_INFO(appinfo));
+	if (icon != NULL) {
+		retval = g_icon_to_string(icon);
+	} else {
+		retval = g_strdup("");
+	}
+
+	/* Drop the app info */
+	g_object_unref(appinfo);
+	appinfo = NULL;
+
+	return retval;
+}
+
+/* Respond to the GetSuggestions command from DBus by looking
+   in our HUD search object for suggestions from that query */
+static GVariant *
+get_suggestions (HudDbus * self, const gchar * query)
+{
+	/* Do the search */
+	gchar * desktop = NULL;
+	gchar * target = NULL;
+	GList * suggestions = hud_search_suggestions(self->priv->search, query, &desktop, &target);
+
+	gchar * icon = NULL;
+	icon = desktop2icon(desktop);
+
+	/* Build into into a variant */
+	GVariantBuilder ret;
+	g_variant_builder_init(&ret, G_VARIANT_TYPE_TUPLE);
+	g_variant_builder_add_value(&ret, g_variant_new_string(icon));
+	g_variant_builder_add_value(&ret, g_variant_new_string(target));
+
+	/* Free the strings */
+	g_free(icon);
+	g_free(target);
+	g_free(desktop);
+
+	if (suggestions != NULL) {
+		GList * suggestion = suggestions;
+		GVariantBuilder builder;
+		g_variant_builder_init(&builder, G_VARIANT_TYPE_ARRAY);
+
+		while (suggestion != NULL) {
+			HudSearchSuggest * suggest = (HudSearchSuggest *)suggestion->data;
+
+			GVariantBuilder tuple;
+			g_variant_builder_init(&tuple, G_VARIANT_TYPE_TUPLE);
+			g_variant_builder_add_value(&tuple, g_variant_new_string(hud_search_suggest_get_display(suggest)));
+			g_variant_builder_add_value(&tuple, g_variant_new_string(hud_search_suggest_get_icon(suggest)));
+			g_variant_builder_add_value(&tuple, hud_search_suggest_get_key(suggest));
+
+			g_variant_builder_add_value(&builder, g_variant_builder_end(&tuple));
+
+			suggestion = g_list_next(suggestion);
+		}
+
+		g_variant_builder_add_value(&ret, g_variant_builder_end(&builder));
+	} else {
+		/* If we didn't get any suggestions we need to build
+		   a null array to make the DBus interface happy */
+		g_variant_builder_add_value(&ret, g_variant_new_array(G_VARIANT_TYPE("(ssv)"), NULL, 0));
+	}
+
+	/* Clean up the list */
+	g_list_free_full(suggestions, (GDestroyNotify)hud_search_suggest_free);
+
+	return g_variant_builder_end(&ret);
+}
+
+static void
+execute_query (HudDbus * self, GVariant * key, guint timestamp)
+{
+	hud_search_execute(self->priv->search, key, timestamp);
+	return;
+}

=== added file 'service/hud-dbus.h'
--- service/hud-dbus.h	1970-01-01 00:00:00 +0000
+++ service/hud-dbus.h	2011-11-17 04:27:35 +0000
@@ -0,0 +1,55 @@
+/*
+DBus facing code for the HUD
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __HUD_DBUS_H__
+#define __HUD_DBUS_H__
+
+#include <glib.h>
+#include <glib-object.h>
+
+G_BEGIN_DECLS
+
+#define HUD_DBUS_TYPE            (hud_dbus_get_type ())
+#define HUD_DBUS(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), HUD_DBUS_TYPE, HudDbus))
+#define HUD_DBUS_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), HUD_DBUS_TYPE, HudDbusClass))
+#define IS_HUD_DBUS(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HUD_DBUS_TYPE))
+#define IS_HUD_DBUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HUD_DBUS_TYPE))
+#define HUD_DBUS_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), HUD_DBUS_TYPE, HudDbusClass))
+
+typedef struct _HudDbus        HudDbus;
+typedef struct _HudDbusClass   HudDbusClass;
+typedef struct _HudDbusPrivate HudDbusPrivate;
+
+struct _HudDbusClass {
+	GObjectClass parent_class;
+};
+
+struct _HudDbus {
+	GObject parent;
+	HudDbusPrivate * priv;
+};
+
+GType hud_dbus_get_type (void);
+HudDbus * hud_dbus_new (void);
+
+G_END_DECLS
+
+#endif

=== added file 'service/hud-dump-application.c'
--- service/hud-dump-application.c	1970-01-01 00:00:00 +0000
+++ service/hud-dump-application.c	2011-11-21 22:01:19 +0000
@@ -0,0 +1,73 @@
+/*
+Small utility to dump application info in the HUD usage DB
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <glib.h>
+#include "dump-app-info.h"
+
+int
+main (int argv, char * argc[])
+{
+	if (argv != 2 && argv != 3) {
+		g_error("Usage: %s <desktop file path> [gettext domain]\n", argc[0]);
+		return 1;
+	}
+
+	const gchar * basecachedir = g_getenv("HUD_CACHE_DIR");
+	if (basecachedir == NULL) {
+		basecachedir = g_get_user_cache_dir();
+	}
+
+	gchar * cachedir = g_build_filename(basecachedir, "hud", NULL);
+	if (!g_file_test(cachedir, G_FILE_TEST_EXISTS | G_FILE_TEST_IS_DIR)) {
+		g_warning("Cache directory '%s' doesn't exist", cachedir);
+		return 1;
+	}
+	g_free(cachedir);
+
+	gchar * cachefile = g_build_filename(basecachedir, "hud", "usage-log.sqlite", NULL);
+	gboolean db_exists = g_file_test(cachefile, G_FILE_TEST_EXISTS);
+
+	if (!db_exists) {
+		g_warning("There is no HUD usage log: %s", cachefile);
+		return 1;
+	}
+
+	sqlite3 * db;
+	int open_status = sqlite3_open(cachefile, &db); 
+
+	if (open_status != SQLITE_OK) {
+		g_warning("Error opening usage DB: %s", cachefile);
+		sqlite3_close(db);
+		return 1;
+	}
+
+	gchar * domain = NULL;
+	if (argv == 3) {
+		domain = argc[2];
+	}
+
+	dump_app_info(argc[1], domain, db);
+
+	sqlite3_close(db);
+	g_free(cachefile);
+
+	return 0;
+}

=== added file 'service/hud-list-applications'
--- service/hud-list-applications	1970-01-01 00:00:00 +0000
+++ service/hud-list-applications	2011-11-22 16:38:36 +0000
@@ -0,0 +1,9 @@
+#!/bin/sh
+
+if [ -n $HUD_CACHE_DIR ]; then
+	HUD_CACHE_DIR=~/.cache
+fi;
+
+FINAL_DIR="$HUD_CACHE_DIR/hud"
+
+sqlite3 $FINAL_DIR/usage-log.sqlite "select distinct application from usage"

=== added file 'service/hud-search.c'
--- service/hud-search.c	1970-01-01 00:00:00 +0000
+++ service/hud-search.c	2011-12-01 15:46:20 +0000
@@ -0,0 +1,486 @@
+/*
+The HUD searching logic that brings together the DBus menus along
+with the user data to make a good search.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <libbamf/bamf-matcher.h>
+#include <gio/gio.h>
+
+#include "hud-search.h"
+#include "dbusmenu-collector.h"
+#include "usage-tracker.h"
+
+struct _HudSearchPrivate {
+	BamfMatcher * matcher;
+	gulong window_changed_sig;
+
+	guint32 active_xid;
+	BamfApplication * active_app;
+
+	DbusmenuCollector * collector;
+	UsageTracker * usage;
+
+	GDBusProxy * appmenu;
+};
+
+#define HUD_SEARCH_GET_PRIVATE(o) \
+(G_TYPE_INSTANCE_GET_PRIVATE ((o), HUD_SEARCH_TYPE, HudSearchPrivate))
+
+static void hud_search_class_init (HudSearchClass *klass);
+static void hud_search_init       (HudSearch *self);
+static void hud_search_dispose    (GObject *object);
+static void hud_search_finalize   (GObject *object);
+
+static void active_window_changed (BamfMatcher * matcher, BamfView * oldview, BamfView * newview, gpointer user_data);
+HudSearchSuggest * hud_search_suggest_new (const gchar * app, const gchar * display, const gchar * db, const gchar * icon, const gchar * dbus_address, const gchar * dbus_path, gint dbus_id);
+
+G_DEFINE_TYPE (HudSearch, hud_search, G_TYPE_OBJECT);
+
+static void
+hud_search_class_init (HudSearchClass *klass)
+{
+	GObjectClass *object_class = G_OBJECT_CLASS (klass);
+
+	g_type_class_add_private (klass, sizeof (HudSearchPrivate));
+
+	object_class->dispose = hud_search_dispose;
+	object_class->finalize = hud_search_finalize;
+
+	return;
+}
+
+static void
+hud_search_init (HudSearch *self)
+{
+	/* Get Private */
+	self->priv = HUD_SEARCH_GET_PRIVATE(self);
+
+	/* Initialize Private */
+	self->priv->matcher = NULL;
+	self->priv->window_changed_sig = 0;
+	self->priv->active_xid = 0;
+	self->priv->collector = NULL;
+	self->priv->usage = NULL;
+	self->priv->appmenu = NULL;
+
+	/* BAMF */
+	self->priv->matcher = bamf_matcher_get_default();
+	self->priv->window_changed_sig = g_signal_connect(G_OBJECT(self->priv->matcher), "active-window-changed", G_CALLBACK(active_window_changed), self);
+
+	BamfWindow * active_window = bamf_matcher_get_active_window(self->priv->matcher);
+	if (active_window != NULL) {
+		self->priv->active_xid = bamf_window_get_xid(active_window);
+		self->priv->active_app = bamf_matcher_get_application_for_window(self->priv->matcher, active_window);
+	}
+
+	/* DBusMenu */
+	self->priv->collector = dbusmenu_collector_new();
+
+	/* Usage Tracker */
+	self->priv->usage = usage_tracker_new();
+
+	/* Appmenu */
+	self->priv->appmenu = g_dbus_proxy_new_for_bus_sync(G_BUS_TYPE_SESSION,
+	                                                    G_DBUS_PROXY_FLAGS_DO_NOT_LOAD_PROPERTIES,
+	                                                    /* info */ NULL,
+	                                                    "com.canonical.AppMenu.Registrar",
+	                                                    "/com/canonical/AppMenu/Registrar",
+	                                                    "com.canonical.AppMenu.Registrar",
+	                                                    NULL, NULL);
+
+	return;
+}
+
+static void
+hud_search_dispose (GObject *object)
+{
+	HudSearch * self = HUD_SEARCH(object);
+
+	if (self->priv->window_changed_sig != 0) {
+		g_signal_handler_disconnect(self->priv->matcher, self->priv->window_changed_sig);
+		self->priv->window_changed_sig = 0;
+	}
+
+	if (self->priv->matcher != NULL) {
+		g_object_unref(self->priv->matcher);
+		self->priv->matcher = NULL;
+	}
+
+	if (self->priv->collector != NULL) {
+		g_object_unref(self->priv->collector);
+		self->priv->collector = NULL;
+	}
+
+	if (self->priv->usage != NULL) {
+		g_object_unref(self->priv->usage);
+		self->priv->usage = NULL;
+	}
+
+	if (self->priv->appmenu != NULL) {
+		g_object_unref(self->priv->appmenu);
+		self->priv->appmenu = NULL;
+	}
+
+	G_OBJECT_CLASS (hud_search_parent_class)->dispose (object);
+	return;
+}
+
+static void
+hud_search_finalize (GObject *object)
+{
+
+	G_OBJECT_CLASS (hud_search_parent_class)->finalize (object);
+	return;
+}
+
+HudSearch *
+hud_search_new (void)
+{
+	HudSearch * ret = HUD_SEARCH(g_object_new(HUD_SEARCH_TYPE, NULL));
+	return ret;
+}
+
+static void
+get_current_window_address(HudSearch * search, gchar ** address, gchar ** path)
+{
+	if (search->priv->active_xid == 0) {
+		g_warning("Active application is unknown");
+		return;
+	}
+
+	if (search->priv->appmenu == NULL) {
+		g_warning("Unable to proxy appmenu");
+		return;
+	}
+
+	GError * error = NULL;
+	GVariant * dbusinfo = g_dbus_proxy_call_sync(search->priv->appmenu,
+	                                             "GetMenuForWindow",
+	                                             g_variant_new("(u)", search->priv->active_xid),
+	                                             G_DBUS_CALL_FLAGS_NONE,
+	                                             -1,
+	                                             NULL,
+	                                             &error);
+
+	if (error != NULL) {
+		g_warning("Unable to get menus from appmenu: %s", error->message);
+		g_error_free(error);
+		return;
+	}
+
+	g_variant_get(dbusinfo, "(so)", address, path);
+	return;
+}
+
+typedef struct _usage_wrapper_t usage_wrapper_t;
+struct _usage_wrapper_t {
+	DbusmenuCollectorFound * found;
+	guint count;
+	gfloat percent_usage;
+	gfloat percent_distance;
+};
+
+static gint
+usage_sort (gconstpointer a, gconstpointer b)
+{
+	usage_wrapper_t * wa = (usage_wrapper_t *)a;
+	usage_wrapper_t * wb = (usage_wrapper_t *)b;
+
+	gfloat totala = (1.0 - wa->percent_usage) + wa->percent_distance;
+	gfloat totalb = (1.0 - wb->percent_usage) + wb->percent_distance;
+
+	gfloat difference = (totala - totalb) * 100.0;
+	return (gint)difference;
+}
+
+static void
+search_and_sort (HudSearch * search, const gchar * searchstr, GArray * usagedata, GList ** foundlist)
+{
+	gchar * address = NULL;
+	gchar * path = NULL;
+	GList * found_list = NULL;
+	guint count = 0;
+	GList * found = NULL;
+
+	get_current_window_address(search, &address, &path);
+	found_list = dbusmenu_collector_search(search->priv->collector, address, path, searchstr);
+
+	g_free(address);
+	g_free(path);
+
+	count = 0;
+	found = found_list;
+	guint overall_usage = 0;
+	guint overall_distance = 0;
+	while (found != NULL) {
+		usage_wrapper_t usage;
+		usage.found = (DbusmenuCollectorFound *)found->data;
+		usage.count = 0;
+
+		if (dbusmenu_collector_found_get_distance(usage.found) > 30) {
+			break;
+		}
+
+		const gchar * desktopfile = NULL;
+
+		desktopfile = dbusmenu_collector_found_get_indicator(usage.found);
+
+		if (desktopfile == NULL && search->priv->active_app != NULL) {
+			desktopfile = bamf_application_get_desktop_file(search->priv->active_app);
+		}
+
+		if (desktopfile != NULL) {
+			usage.count = usage_tracker_get_usage(search->priv->usage, desktopfile, dbusmenu_collector_found_get_db(usage.found));
+		}
+
+		overall_usage += usage.count;
+		overall_distance += dbusmenu_collector_found_get_distance(usage.found);
+
+		g_array_append_val(usagedata, usage);
+		found = g_list_next(found);
+		count++;
+		if (count >= 15) {
+			break;
+		}
+	}
+
+	for (count = 0; count < usagedata->len; count++) {
+		usage_wrapper_t * usage = &g_array_index(usagedata, usage_wrapper_t, count);
+
+		if (overall_usage != 0) {
+			usage->percent_usage = (gfloat)usage->count/(gfloat)overall_usage;
+		} else {
+			usage->percent_usage = 1.0;
+		}
+
+		usage->percent_distance = (gfloat)dbusmenu_collector_found_get_distance(usage->found)/(gfloat)overall_distance;
+	}
+
+	g_array_sort(usagedata, usage_sort);
+	*foundlist = found_list;
+	return;
+}
+
+/* Find a list of suggestions that should be sent to the user.  Looks
+   through both applications and indicators. */
+GList *
+hud_search_suggestions (HudSearch * search, const gchar * searchstr, gchar ** desktop, gchar ** target)
+{
+	g_return_val_if_fail(IS_HUD_SEARCH(search), NULL);
+
+	/* We're currently not getting this data, let's just give a
+	   NULL string back for now */
+	if (target != NULL) {
+		*target = g_strdup("");
+	}
+
+	/* Build an array of the entries that we're going
+	   to use as an interim structure */
+	GArray * usagedata = g_array_sized_new(FALSE, TRUE, sizeof(usage_wrapper_t), 15);
+	GList * found_list = NULL;
+
+
+	/* The application desktop file is the default if the
+	   entry in question is not for an indicator */
+	const gchar * appdesktopfile = NULL;
+
+	if (search->priv->active_app != NULL) {
+		appdesktopfile = bamf_application_get_desktop_file(search->priv->active_app);
+	}
+
+	if (appdesktopfile == NULL) {
+		appdesktopfile = "";
+	}
+
+	/* If we're given a valid pointer, return the value back to
+	   it */
+	if (desktop != NULL) {
+		*desktop = g_strdup(appdesktopfile);
+	}
+
+	/* This is the core of searching a given application for their
+	   entries.  It will also delve into the indicators */
+	search_and_sort(search, searchstr, usagedata, &found_list);
+
+	/* Convert the entries that we were given into a list of structures
+	   that we want to export an an API */
+	GList * retval = NULL;
+	int count;
+	for (count = 0; count < 5 && count < usagedata->len; count++) {
+		usage_wrapper_t * usage = &g_array_index(usagedata, usage_wrapper_t, count);
+
+		const gchar * desktopfile = dbusmenu_collector_found_get_indicator(usage->found);
+		if (desktopfile == NULL) {
+			desktopfile = appdesktopfile;
+		}
+
+		HudSearchSuggest * suggest = hud_search_suggest_new(desktopfile,
+		                                                    dbusmenu_collector_found_get_display(usage->found),
+		                                                    dbusmenu_collector_found_get_db(usage->found),
+		                                                    "none",
+		                                                    dbusmenu_collector_found_get_dbus_addr(usage->found),
+		                                                    dbusmenu_collector_found_get_dbus_path(usage->found),
+		                                                    dbusmenu_collector_found_get_dbus_id(usage->found)
+		                                                    );
+
+		retval = g_list_append(retval, suggest);
+	}
+
+	/* Free the interim arrays of data */
+	g_array_free(usagedata, TRUE);
+	dbusmenu_collector_found_list_free(found_list);
+
+	return retval;
+}
+
+void
+hud_search_execute (HudSearch * search, GVariant * key, guint timestamp)
+{
+	g_return_if_fail(IS_HUD_SEARCH(search));
+	gchar * app = NULL;
+	gchar * display = NULL;
+	gchar * address = NULL;
+	gchar * path = NULL;
+	gint id = 0;
+	GVariant * unwrapped_key = g_variant_get_variant(key);
+
+	g_variant_get(unwrapped_key, "(sssoi)", &app, &display, &address, &path, &id);
+
+	dbusmenu_collector_execute(search->priv->collector, address, path, id, timestamp);
+	usage_tracker_mark_usage(search->priv->usage, app, display);
+
+	g_free(address);
+	g_free(path);
+	g_free(app);
+	g_free(display);
+
+	g_variant_unref(unwrapped_key);
+
+	return;
+}
+
+static void
+active_window_changed (BamfMatcher * matcher, BamfView * oldview, BamfView * newview, gpointer user_data)
+{
+	HudSearch * self = HUD_SEARCH(user_data);
+
+	if (!BAMF_IS_WINDOW(newview)) { return; }
+	BamfWindow * window = BAMF_WINDOW(newview);
+
+	BamfApplication * app = bamf_matcher_get_application_for_window(self->priv->matcher, window);
+	const gchar * desktop = NULL;
+
+	if (app != NULL) {
+		desktop = bamf_application_get_desktop_file(app);
+	}
+
+	/* If BAMF can't match it to an application we probably don't
+	   want to be involved with it anyway. */
+	if (desktop == NULL) {
+		return;
+	}
+
+	/* NOTE: Both of these are debugging tools for now, so we want
+	   to be able to use them effectively to work on the HUD, so we're
+	   going to pretend we didn't switch windows if we switch to one 
+	   of them */
+	if (g_strstr_len(desktop, -1, "termina") != NULL ||
+	        g_strstr_len(desktop, -1, "dfeet") != NULL) {
+		return;
+	}
+
+	/* Ignore the hud prototype window directly */
+	const gchar * window_name = bamf_view_get_name(newview);
+	if (g_strcmp0(window_name, "Hud Prototype Test") == 0
+	  || g_strcmp0(window_name, "Hud") == 0) {
+		return;
+	}
+
+	/* This should ignore most of the windows involved in Unity */
+	const gchar * name = bamf_view_get_name(newview);
+	if (g_strcmp0(name, "DNDCollectionWindow") == 0) {
+		return;
+	}
+
+	self->priv->active_xid = bamf_window_get_xid(window);
+	self->priv->active_app = app;
+
+	return;
+}
+
+struct _HudSearchSuggest {
+	gchar * display;
+	gchar * icon;
+	GVariant * key;
+};
+
+HudSearchSuggest *
+hud_search_suggest_new (const gchar * app, const gchar * display, const gchar * db, const gchar * icon, const gchar * dbus_address, const gchar * dbus_path, gint dbus_id)
+{
+	HudSearchSuggest * suggest = g_new0(HudSearchSuggest, 1);
+
+	suggest->display = g_strdup(display);
+	suggest->icon = g_strdup(icon);
+
+	GVariantBuilder builder;
+	g_variant_builder_init(&builder, G_VARIANT_TYPE_TUPLE);
+	g_variant_builder_add_value(&builder, g_variant_new_string(app));
+	g_variant_builder_add_value(&builder, g_variant_new_string(db));
+	g_variant_builder_add_value(&builder, g_variant_new_string(dbus_address));
+	g_variant_builder_add_value(&builder, g_variant_new_object_path(dbus_path));
+	g_variant_builder_add_value(&builder, g_variant_new_int32(dbus_id));
+
+	suggest->key = g_variant_new_variant(g_variant_builder_end(&builder));
+	g_variant_ref_sink(suggest->key);
+
+	return suggest;
+}
+
+const gchar *
+hud_search_suggest_get_icon (HudSearchSuggest * suggest)
+{
+	return suggest->icon;
+}
+
+const gchar *
+hud_search_suggest_get_display (HudSearchSuggest * suggest)
+{
+	return suggest->display;
+}
+
+GVariant *
+hud_search_suggest_get_key (HudSearchSuggest * suggest)
+{
+	return suggest->key;
+}
+
+void
+hud_search_suggest_free (HudSearchSuggest * suggest)
+{
+	g_free(suggest->display);
+	g_free(suggest->icon);
+	g_variant_unref(suggest->key);
+	g_free(suggest);
+	return;
+}

=== added file 'service/hud-search.h'
--- service/hud-search.h	1970-01-01 00:00:00 +0000
+++ service/hud-search.h	2011-11-30 19:47:18 +0000
@@ -0,0 +1,64 @@
+/*
+The HUD searching logic that brings together the DBus menus along
+with the user data to make a good search.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __HUD_SEARCH_H__
+#define __HUD_SEARCH_H__
+
+#include <glib.h>
+#include <glib-object.h>
+
+G_BEGIN_DECLS
+
+#define HUD_SEARCH_TYPE            (hud_search_get_type ())
+#define HUD_SEARCH(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), HUD_SEARCH_TYPE, HudSearch))
+#define HUD_SEARCH_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), HUD_SEARCH_TYPE, HudSearchClass))
+#define IS_HUD_SEARCH(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HUD_SEARCH_TYPE))
+#define IS_HUD_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HUD_SEARCH_TYPE))
+#define HUD_SEARCH_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), HUD_SEARCH_TYPE, HudSearchClass))
+
+typedef struct _HudSearch         HudSearch;
+typedef struct _HudSearchClass    HudSearchClass;
+typedef struct _HudSearchPrivate  HudSearchPrivate;
+typedef struct _HudSearchSuggest  HudSearchSuggest;
+
+struct _HudSearchClass {
+	GObjectClass parent_class;
+};
+
+struct _HudSearch {
+	GObject parent;
+	HudSearchPrivate * priv;
+};
+
+GType hud_search_get_type (void);
+HudSearch * hud_search_new (void);
+GList * hud_search_suggestions (HudSearch * search, const gchar * searchstr, gchar ** desktop, gchar ** target);
+void hud_search_execute (HudSearch * search, GVariant * key, guint timestamp);
+
+const gchar * hud_search_suggest_get_icon (HudSearchSuggest * suggest);
+const gchar * hud_search_suggest_get_display (HudSearchSuggest * suggest);
+GVariant * hud_search_suggest_get_key (HudSearchSuggest * suggest);
+void hud_search_suggest_free (HudSearchSuggest * suggest);
+
+G_END_DECLS
+
+#endif

=== added file 'service/hud-service.c'
--- service/hud-service.c	1970-01-01 00:00:00 +0000
+++ service/hud-service.c	2011-11-17 04:27:35 +0000
@@ -0,0 +1,62 @@
+/*
+Basic HUD service.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <glib.h>
+#include <gio/gio.h>
+
+#include "shared-values.h"
+#include "hud-dbus.h"
+
+static GMainLoop * mainloop = NULL;
+
+static void
+name_lost_cb (GDBusConnection * connection, const gchar * name, gpointer user_data)
+{
+	g_error("Unable to get name '%s'", name);
+	g_main_loop_quit(mainloop);
+	return;
+}
+
+int
+main (int argv, char * argc[])
+{
+	g_type_init();
+
+	HudDbus * dbus = hud_dbus_new();
+
+	g_bus_own_name(G_BUS_TYPE_SESSION,
+	/* Name */           DBUS_NAME,
+	/* Flags */          G_BUS_NAME_OWNER_FLAGS_NONE,
+	/* Bus Acquired */   NULL,
+	/* Name Acquired */  NULL,
+	/* Name Lost */      name_lost_cb,
+	/* User Data */      NULL,
+	/* Destroy */        NULL);
+
+
+	mainloop = g_main_loop_new(NULL, FALSE);
+	g_main_loop_run(mainloop);
+
+	g_main_loop_unref(mainloop);
+	g_object_unref(dbus);
+
+	return 0;
+}

=== added file 'service/hud-verify-app-info.c'
--- service/hud-verify-app-info.c	1970-01-01 00:00:00 +0000
+++ service/hud-verify-app-info.c	2011-11-27 15:23:35 +0000
@@ -0,0 +1,105 @@
+/*
+Verify the validity of the App Info file to make sure it parses
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <unistd.h>
+#include <glib.h>
+#include <glib/gstdio.h>
+#include <glib-object.h>
+#include "load-app-info.h"
+
+static void
+build_db (sqlite3 * db)
+{
+	/* Create the table */
+	int exec_status = SQLITE_OK;
+	gchar * failstring = NULL;
+	exec_status = sqlite3_exec(db,
+	                           "create table usage (application text, entry text, timestamp datetime);",
+	                           NULL, NULL, &failstring);
+	if (exec_status != SQLITE_OK) {
+		g_warning("Unable to create table: %s", failstring);
+	}
+
+	/* Import data from the system */
+
+	return;
+}
+
+int
+main (int argv, char * argc[])
+{
+	gboolean passed = TRUE;
+
+	if (argv != 2) {
+		g_printerr("Usage: %s <app-info file path>\n", argc[0]);
+		return 1;
+	}
+
+	g_type_init();
+
+	gchar * filename = NULL;
+	gint tmpfile = g_file_open_tmp("hud-verify-app-info-temp-db-XXXXXX", &filename, NULL);
+
+	if (tmpfile < 0) {
+		passed = FALSE;
+		goto cleanup;
+	}
+
+	close(tmpfile);
+	/* NOTE: there is a small security bug here in that we're closing the
+	   file and reopening it, so the temp isn't really gauranteed to be
+	   safe.  But, I don't think we're really worried about security in this
+	   utility. */
+
+	sqlite3 * db = NULL;
+	int open_status = sqlite3_open(filename, &db); 
+
+	if (open_status != SQLITE_OK) {
+		g_warning("Error opening usage DB: %s", filename);
+		passed = FALSE;
+		goto cleanup;
+	}
+
+	/* Create the table in the DB */
+	build_db(db);
+
+	passed = load_app_info(argc[1], db);
+
+cleanup:
+	if (db != NULL) {
+		sqlite3_close(db);
+	}
+
+	if (filename != NULL) {
+		if (g_getenv("HUD_VERIFY_NO_UNLINK") == NULL) {
+			g_unlink(filename);
+		} else {
+			g_print("Temp db '%s' not deleted\n", filename);
+		}
+		g_free(filename);
+	}
+
+	if (passed) {
+		return 0;
+	} else {
+		return 1;
+	}
+}

=== added file 'service/hud.xml'
--- service/hud.xml	1970-01-01 00:00:00 +0000
+++ service/hud.xml	2011-11-30 14:29:07 +0000
@@ -0,0 +1,26 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<node name="/">
+	<interface name="com.canonical.hud">
+<!-- Properties -->
+		<!-- None -->
+
+<!-- Functions -->
+		<method name="GetSuggestions">
+			<arg type="s" name="query" direction="in" />
+			<arg type="s" name="icon" direction="out" />
+			<arg type="s" name="target" direction="out" />
+			<arg type="a(ssv)" name="suggestions" direction="out" />
+		</method>
+
+		<method name="ExecuteQuery">
+			<arg type="v" name="key" direction="in" />
+			<arg type="u" name="timestamp" direction="in" />
+		</method>
+
+<!-- Signals -->
+		<!-- None -->
+
+<!-- End of interesting stuff -->
+
+	</interface>
+</node>

=== added file 'service/indicator-tracker.c'
--- service/indicator-tracker.c	1970-01-01 00:00:00 +0000
+++ service/indicator-tracker.c	2011-11-17 04:27:35 +0000
@@ -0,0 +1,233 @@
+/*
+Tracks the various indicators to know when they come on and off
+the bus for searching their menus.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include "indicator-tracker.h"
+
+#include <glib/gi18n.h>
+#include <gio/gio.h>
+
+typedef struct _SystemIndicator SystemIndicator;
+struct _SystemIndicator {
+	gchar * dbus_name;
+	gchar * dbus_menu_path;
+	gchar * indicator_name;
+	gchar * user_visible_name;
+};
+
+SystemIndicator system_indicators[] = {
+	{dbus_name: "com.canonical.indicator.datetime", dbus_menu_path: "/com/canonical/indicator/datetime/menu", indicator_name: "indicator-datetime",       user_visible_name: N_("Date") },
+	{dbus_name: "com.canonical.indicator.session",  dbus_menu_path: "/com/canonical/indicator/session/menu",  indicator_name: "indicator-session-device", user_visible_name: N_("Device") },
+	{dbus_name: "com.canonical.indicator.session",  dbus_menu_path: "/com/canonical/indicator/user/menu",     indicator_name: "indicator-session-user",   user_visible_name: N_("User") },
+	{dbus_name: "com.canonical.indicators.sound",   dbus_menu_path: "/com/canonical/indicators/sound/menu",   indicator_name: "indicator-sound",          user_visible_name: N_("Sound") },
+	{dbus_name: "com.canonical.indicator.messages", dbus_menu_path: "/com/canonical/indicator/messages/menu", indicator_name: "indicator-messages",       user_visible_name: N_("Messages") }
+};
+
+struct _IndicatorTrackerPrivate {
+	GArray * indicators;
+	guint watches[G_N_ELEMENTS(system_indicators)];
+};
+
+#define INDICATOR_TRACKER_GET_PRIVATE(o) \
+(G_TYPE_INSTANCE_GET_PRIVATE ((o), INDICATOR_TRACKER_TYPE, IndicatorTrackerPrivate))
+
+static void indicator_tracker_class_init (IndicatorTrackerClass *klass);
+static void indicator_tracker_init       (IndicatorTracker *self);
+static void indicator_tracker_dispose    (GObject *object);
+static void indicator_tracker_finalize   (GObject *object);
+static void system_watch_appeared        (GDBusConnection * connection, const gchar * name, const gchar * name_owner, gpointer user_data);
+static void system_watch_vanished        (GDBusConnection * connection, const gchar * name, gpointer user_data);
+
+G_DEFINE_TYPE (IndicatorTracker, indicator_tracker, G_TYPE_OBJECT);
+
+static void
+indicator_tracker_class_init (IndicatorTrackerClass *klass)
+{
+	GObjectClass *object_class = G_OBJECT_CLASS (klass);
+
+	g_type_class_add_private (klass, sizeof (IndicatorTrackerPrivate));
+
+	object_class->dispose = indicator_tracker_dispose;
+	object_class->finalize = indicator_tracker_finalize;
+
+	return;
+}
+
+static void
+indicator_tracker_init (IndicatorTracker *self)
+{
+	self->priv = INDICATOR_TRACKER_GET_PRIVATE(self);
+	self->priv->indicators = NULL;
+
+	self->priv->indicators = g_array_new(FALSE, TRUE, sizeof(IndicatorTrackerIndicator));
+
+	int indicator_cnt;
+	for (indicator_cnt = 0; indicator_cnt < G_N_ELEMENTS(system_indicators); indicator_cnt++) {
+		self->priv->watches[indicator_cnt] = g_bus_watch_name(G_BUS_TYPE_SESSION,
+		                                                      system_indicators[indicator_cnt].dbus_name,
+		                                                      G_BUS_NAME_WATCHER_FLAGS_NONE,
+		                                                      system_watch_appeared, /* acquired */
+		                                                      system_watch_vanished, /* vanished */
+		                                                      self,
+		                                                      NULL); /* free func */
+	}
+
+	return;
+}
+
+static void
+indicator_tracker_dispose (GObject *object)
+{
+	IndicatorTracker * self = INDICATOR_TRACKER(object);
+
+	int indicator_cnt;
+	for (indicator_cnt = 0; indicator_cnt < G_N_ELEMENTS(system_indicators); indicator_cnt++) {
+		if (self->priv->watches[indicator_cnt] != 0) {
+			g_bus_unwatch_name(self->priv->watches[indicator_cnt]);
+			self->priv->watches[indicator_cnt] = 0;
+		}
+	}
+	
+
+	G_OBJECT_CLASS (indicator_tracker_parent_class)->dispose (object);
+	return;
+}
+
+static void
+indicator_tracker_finalize (GObject *object)
+{
+
+	G_OBJECT_CLASS (indicator_tracker_parent_class)->finalize (object);
+	return;
+}
+
+IndicatorTracker *
+indicator_tracker_new (void)
+{
+	return INDICATOR_TRACKER(g_object_new(INDICATOR_TRACKER_TYPE, NULL));
+}
+
+GArray *
+indicator_tracker_get_indicators (IndicatorTracker * tracker)
+{
+	g_return_val_if_fail(IS_INDICATOR_TRACKER(tracker), NULL);
+	return tracker->priv->indicators;
+}
+
+/* Function watches names on Dbus to find out when the system indicators
+   go on and off the bus.  This makes it so that we can handle them properly
+   at the higher levels in the system.  If a system indicator gets added to
+   the list it gets put the indicator structure. */
+static void
+system_watch_appeared (GDBusConnection * connection, const gchar * name, const gchar * name_owner, gpointer user_data)
+{
+	g_return_if_fail(IS_INDICATOR_TRACKER(user_data));
+	g_return_if_fail(name_owner != NULL);
+	g_return_if_fail(name_owner[0] != '\0');
+	IndicatorTracker * self = INDICATOR_TRACKER(user_data);
+
+	/* Check all the system indicators because there might be more than
+	   one menu/indicator on a well known name */
+	int indicator_cnt;
+	for (indicator_cnt = 0; indicator_cnt < G_N_ELEMENTS(system_indicators); indicator_cnt++) {
+		SystemIndicator * sys_indicator = &system_indicators[indicator_cnt];
+
+		if (g_strcmp0(sys_indicator->dbus_name, name) != 0) {
+			continue;
+		}
+
+		/* Check to see if we already have this system indicator in the
+		   list of indicators */
+		int i;
+		for (i = 0; i < self->priv->indicators->len; i++) {
+			IndicatorTrackerIndicator * indicator = &g_array_index(self->priv->indicators, IndicatorTrackerIndicator, i);
+
+			if (g_strcmp0(sys_indicator->dbus_name, indicator->dbus_name_wellknown) != 0) {
+				continue;
+			}
+
+			if (g_strcmp0(sys_indicator->dbus_menu_path, indicator->dbus_object) != 0) {
+				continue;
+			}
+
+			/* If both of them match, we need to break */
+			break;
+		}
+
+		/* We found it in the list so we broke out eary */
+		if (i != self->priv->indicators->len) {
+			continue;
+		}
+
+		g_debug("Adding an indicator for '%s' at owner '%s'", name, name_owner);
+		/* Okay, we need to build one for this system indicator */
+		IndicatorTrackerIndicator final_indicator = {
+			name: g_strdup(sys_indicator->indicator_name),
+			dbus_name: g_strdup(name_owner),
+			dbus_name_wellknown: g_strdup(sys_indicator->dbus_name),
+			dbus_object: g_strdup(sys_indicator->dbus_menu_path),
+			prefix: g_strdup(_(sys_indicator->user_visible_name))
+		};
+
+		g_array_append_val(self->priv->indicators, final_indicator);
+	}
+
+	return;
+}
+
+/* When the names drop off of DBus we need to check to see if that
+   means any indicators getting lost as well.  If so, remove them from
+   the indicator list. */
+static void
+system_watch_vanished (GDBusConnection * connection, const gchar * name, gpointer user_data)
+{
+	g_return_if_fail(IS_INDICATOR_TRACKER(user_data));
+	IndicatorTracker * self = INDICATOR_TRACKER(user_data);
+
+	/* See if any of our indicators know this name */
+	int i;
+	for (i = 0; i < self->priv->indicators->len; i++) {
+		IndicatorTrackerIndicator * indicator = &g_array_index(self->priv->indicators, IndicatorTrackerIndicator, i);
+
+		/* Doesn't match */
+		if (g_strcmp0(indicator->dbus_name_wellknown, name) != 0) {
+			continue;
+		}
+
+		g_free(indicator->name);
+		g_free(indicator->dbus_name);
+		g_free(indicator->dbus_name_wellknown);
+		g_free(indicator->dbus_object);
+		g_free(indicator->prefix);
+
+		g_array_remove_index_fast(self->priv->indicators, i);
+		/* Oh, this is confusing.  Basically becasue we shorten the array
+		   we need to check the one that replaced the entry we deleted
+		   so we have to look in this same slot again. */
+		i--;
+	}
+
+	return;
+}

=== added file 'service/indicator-tracker.h'
--- service/indicator-tracker.h	1970-01-01 00:00:00 +0000
+++ service/indicator-tracker.h	2011-11-17 04:27:35 +0000
@@ -0,0 +1,66 @@
+/*
+Tracks the various indicators to know when they come on and off
+the bus for searching their menus.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __INDICATOR_TRACKER_H__
+#define __INDICATOR_TRACKER_H__
+
+#include <glib.h>
+#include <glib-object.h>
+
+G_BEGIN_DECLS
+
+#define INDICATOR_TRACKER_TYPE            (indicator_tracker_get_type ())
+#define INDICATOR_TRACKER(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), INDICATOR_TRACKER_TYPE, IndicatorTracker))
+#define INDICATOR_TRACKER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), INDICATOR_TRACKER_TYPE, IndicatorTrackerClass))
+#define IS_INDICATOR_TRACKER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), INDICATOR_TRACKER_TYPE))
+#define IS_INDICATOR_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), INDICATOR_TRACKER_TYPE))
+#define INDICATOR_TRACKER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), INDICATOR_TRACKER_TYPE, IndicatorTrackerClass))
+
+typedef struct _IndicatorTracker          IndicatorTracker;
+typedef struct _IndicatorTrackerClass     IndicatorTrackerClass;
+typedef struct _IndicatorTrackerPrivate   IndicatorTrackerPrivate;
+typedef struct _IndicatorTrackerIndicator IndicatorTrackerIndicator;
+
+struct _IndicatorTrackerClass {
+	GObjectClass parent_class;
+};
+
+struct _IndicatorTracker {
+	GObject parent;
+	IndicatorTrackerPrivate * priv;
+};
+
+struct _IndicatorTrackerIndicator {
+	gchar * name;
+	gchar * dbus_name;
+	gchar * dbus_name_wellknown;
+	gchar * dbus_object;
+	gchar * prefix;
+};
+
+GType indicator_tracker_get_type (void);
+IndicatorTracker * indicator_tracker_new (void);
+GArray * indicator_tracker_get_indicators (IndicatorTracker * tracker);
+
+G_END_DECLS
+
+#endif

=== added file 'service/load-app-info.c'
--- service/load-app-info.c	1970-01-01 00:00:00 +0000
+++ service/load-app-info.c	2011-12-01 15:25:42 +0000
@@ -0,0 +1,317 @@
+/*
+Loads application info for initial app usage and verification
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <gio/gio.h>
+#include <glib/gi18n.h>
+
+#include "load-app-info.h"
+#include "shared-values.h"
+
+static void new_element (GMarkupParseContext *context, const gchar * name, const gchar ** attribute_names, const gchar ** attribute_values, gpointer user_data, GError **error);
+static void end_element (GMarkupParseContext  *context, const gchar * name, gpointer user_data, GError ** error);
+
+static GMarkupParser app_info_parser = {
+	start_element:  new_element,
+	end_element:    end_element,
+	text:           NULL,
+	passthrough:    NULL,
+	error:          NULL
+};
+
+typedef struct _menu_data_t menu_data_t;
+struct _menu_data_t {
+	sqlite3 * db;
+	gchar * desktopfile;
+	gchar * domain;
+	gboolean seen_header;
+	gboolean seen_menus;
+	GQueue queue;
+	GString * statement;
+};
+
+typedef enum _menu_errors_t menu_errors_t;
+enum _menu_errors_t {
+	DUPLICATE_HEADERS,
+	DUPLICATE_DESKTOPFILE,
+	DUPLICATE_MENUS,
+	MISSING_HEADER,
+	MISSING_DESKTOP,
+	MISSING_MENUS,
+	ERROR_LAST
+};
+
+gboolean
+load_app_info (const gchar * filename, sqlite3 * db)
+{
+	/* verify */
+	g_return_val_if_fail(filename != NULL, FALSE);
+	g_return_val_if_fail(db != NULL, FALSE);
+
+	if (!g_file_test(filename, G_FILE_TEST_EXISTS)) {
+		return FALSE;
+	}
+
+	/* get data */
+	GFile * file = g_file_new_for_path(filename);
+	gchar * data = NULL;
+	gsize len = 0;
+	GError * error = NULL;
+
+	gboolean load = g_file_load_contents(file,
+	                                     NULL, /* cancelable */
+	                                     &data,
+	                                     &len,
+	                                     NULL, /* end tag */
+	                                     &error);
+
+	if (error != NULL) {
+		g_warning("Unable to load file '%s': %s", filename, error->message);
+		g_error_free(error);
+		g_object_unref(file);
+		return FALSE;
+	}
+
+	if (!load) {
+		g_warning("Unable to load file '%s'", filename);
+		g_object_unref(file);
+		return FALSE;
+	}
+
+	/* parse it */
+	menu_data_t menu_data = {
+		db: db,
+		seen_header: FALSE,
+		seen_menus: FALSE,
+		desktopfile: NULL,
+		domain: NULL,
+		queue: G_QUEUE_INIT,
+		statement: NULL
+	};
+
+	menu_data.statement = g_string_new("");
+
+	GMarkupParseContext * context = g_markup_parse_context_new(&app_info_parser,
+	                                                           0, /* flags */
+	                                                           &menu_data,
+	                                                           NULL /* destroy func */);
+
+	gboolean parsed = g_markup_parse_context_parse(context, data, len, &error);
+
+	if (error != NULL) {
+		g_warning("Unable to parse file '%s': %s", filename, error->message);
+		g_error_free(error);
+		error = NULL;
+	}
+
+	if (!parsed) {
+		g_warning("Unable to parse file '%s'", filename);
+	}
+
+	if (!menu_data.seen_header) {
+		g_warning("Never found a header in '%s'", filename);
+		parsed = FALSE;
+	}
+
+	if (!menu_data.seen_menus) {
+		g_warning("Never found menus in '%s'", filename);
+		parsed = FALSE;
+	}
+
+	g_markup_parse_context_free(context);
+
+	/* Execute SQL Statement */
+	/* If we have one */
+	if (parsed && menu_data.statement->str[0] != '\0') {
+		int exec_status = SQLITE_OK;
+		gchar * failstring = NULL;
+		exec_status = sqlite3_exec(db,
+		                           menu_data.statement->str,
+		                           NULL, NULL, &failstring);
+		if (exec_status != SQLITE_OK) {
+			g_warning("Unable to execute SQL statement to load DB: %s", failstring);
+		}
+	}
+
+	g_free(menu_data.desktopfile);
+	g_free(menu_data.domain);
+	g_string_free(menu_data.statement, TRUE);
+
+	/* Free data */
+	g_free(data);
+	g_object_unref(file);
+
+	return parsed;
+}
+
+static GQuark
+error_domain (void)
+{
+	static GQuark domain = 0;
+	if (domain == 0) {
+		domain = g_quark_from_static_string("hud-app-info-parser");
+	}
+	return domain;
+}
+
+#define COLLECT(first, ...) \
+  g_markup_collect_attributes (name,                                         \
+                               attribute_names, attribute_values, error,     \
+                               first, __VA_ARGS__, G_MARKUP_COLLECT_INVALID)
+#define OPTIONAL   G_MARKUP_COLLECT_OPTIONAL
+#define STRDUP     G_MARKUP_COLLECT_STRDUP
+#define STRING     G_MARKUP_COLLECT_STRING
+#define NO_ATTRS() COLLECT (G_MARKUP_COLLECT_INVALID, NULL)
+
+static void
+new_element (GMarkupParseContext *context, const gchar * name, const gchar ** attribute_names, const gchar ** attribute_values, gpointer user_data, GError **error)
+{
+	menu_data_t * menu_data = (menu_data_t *)user_data;
+
+	if (g_strcmp0(name, "hudappinfo") == 0) {
+		if (menu_data->seen_header) {
+			g_set_error(error, error_domain(), DUPLICATE_HEADERS, "Recieved second header");
+		}
+
+		menu_data->seen_header = TRUE;
+		return;
+	}
+
+	if (!menu_data->seen_header) {
+		g_set_error(error, error_domain(), MISSING_HEADER, "Missing the header when we got to element '%s'", name);
+		return;
+	}
+
+	if (g_strcmp0(name, "desktopfile") == 0) {
+		const gchar * desktopfile;
+
+		if (!COLLECT(STRING, "path", &desktopfile)) {
+			return;
+		}
+
+		if (menu_data->desktopfile != NULL) {
+			g_set_error(error, error_domain(), DUPLICATE_DESKTOPFILE, "Two desktop file definitions.  First as '%s' then as '%s'.", menu_data->desktopfile, desktopfile);
+			return;
+		}
+
+		menu_data->desktopfile = g_strdup(desktopfile);
+		return;
+	}
+
+	if (g_strcmp0(name, "menus") == 0) {
+		if (menu_data->desktopfile == NULL) {
+			g_set_error(error, error_domain(), MISSING_DESKTOP, "No desktop file is defined");
+		}
+
+		if (menu_data->seen_menus) {
+			g_set_error(error, error_domain(), DUPLICATE_MENUS, "Second set of menus found");
+		}
+
+		menu_data->seen_menus = TRUE;
+
+		return;
+	}
+
+	if (g_strcmp0(name, "menu") == 0) {
+		if (!menu_data->seen_menus) {
+			g_set_error(error, error_domain(), MISSING_MENUS, "Menu tag found without enclosing menus");
+			return;
+		}
+
+		const gchar * mname;
+
+		if (!COLLECT(STRING, "name", &mname)) {
+			return;
+		}
+
+		const gchar * translated = NULL;
+		if (menu_data->domain != NULL) {
+			translated = g_dgettext(menu_data->domain, mname);
+		} else {
+			translated = _(mname);
+		}
+
+		if (g_queue_is_empty(&menu_data->queue)) {
+			g_queue_push_head(&menu_data->queue, g_strdup(translated));
+		} else {
+			g_queue_push_head(&menu_data->queue, g_strconcat((gchar *)g_queue_peek_head(&menu_data->queue), DB_SEPARATOR, translated, NULL));
+		}
+
+		return;
+	}
+
+	if (g_strcmp0(name, "item") == 0) {
+		if (!menu_data->seen_menus) {
+			g_set_error(error, error_domain(), MISSING_MENUS, "Item tag found without enclosing menus");
+			return;
+		}
+
+		const gchar * iname;
+		const gchar * scount;
+
+		if (!COLLECT(STRING, "name", &iname,
+		             STRING, "count", &scount)) {
+			return;
+		}
+
+		const gchar * translated = NULL;
+		if (menu_data->domain != NULL) {
+			translated = g_dgettext(menu_data->domain, iname);
+		} else {
+			translated = _(iname);
+		}
+
+		gchar * finalitem = g_strconcat((gchar *)g_queue_peek_head(&menu_data->queue), DB_SEPARATOR, translated, NULL);
+		gint64 count = g_ascii_strtoll(scount, NULL, 10);
+
+		int i;
+		for (i = 0; i < count; i++) {
+			if (i == 0) {
+				g_string_append_printf(menu_data->statement, "insert into usage (application, entry, timestamp) values ('%s', '%s', date('now', 'utc'));", menu_data->desktopfile, finalitem);
+			} else {
+				g_string_append_printf(menu_data->statement, "insert into usage (application, entry, timestamp) values ('%s', '%s', date('now', 'utc', '-%d days'));", menu_data->desktopfile, finalitem, i);
+			}
+		}
+
+		g_free(finalitem);
+		return;
+	}
+
+	return;
+}
+
+static void
+end_element (GMarkupParseContext  *context, const gchar * name, gpointer user_data, GError ** error)
+{
+	menu_data_t * menu_data = (menu_data_t *)user_data;
+
+	if (g_strcmp0(name, "menu") == 0) {
+		if (g_queue_is_empty(&menu_data->queue)) {
+			g_warning("Menu stack is empty!");
+		} else {
+			g_free(g_queue_pop_head(&menu_data->queue));
+		}
+
+		return;
+	}
+
+	return;
+}
+

=== added file 'service/load-app-info.h'
--- service/load-app-info.h	1970-01-01 00:00:00 +0000
+++ service/load-app-info.h	2011-11-22 20:31:49 +0000
@@ -0,0 +1,30 @@
+/*
+Loads application info for initial app usage and verification
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __LOAD_APP_INFO_H__
+#define __LOAD_APP_INFO_H__
+
+#include <glib.h>
+#include <sqlite3.h>
+
+gboolean load_app_info (const gchar * filename, sqlite3 * db);
+
+#endif /* __LOAD_APP_INFO_H__ */

=== added file 'service/shared-values.h'
--- service/shared-values.h	1970-01-01 00:00:00 +0000
+++ service/shared-values.h	2011-12-01 15:15:55 +0000
@@ -0,0 +1,33 @@
+/*
+Values that we share between the various objects
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef SHARED_VALUES_H__
+#define SHARED_VALUES_H__
+
+
+#define DBUS_NAME  "com.canonical.hud"
+#define DBUS_PATH  "/com/canonical/hud"
+#define DBUS_IFACE "com.canonical.hud"
+
+#define DB_SEPARATOR "||"
+
+
+#endif /* SHARED_VALUES_H__ */

=== added file 'service/usage-tracker.c'
--- service/usage-tracker.c	1970-01-01 00:00:00 +0000
+++ service/usage-tracker.c	2011-11-28 02:45:21 +0000
@@ -0,0 +1,288 @@
+/*
+Tracks which menu items get used by users and works to promote those
+higher in the search rankings than others.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <glib.h>
+#include <glib/gstdio.h>
+#include <sqlite3.h>
+#include "usage-tracker.h"
+#include "load-app-info.h"
+
+struct _UsageTrackerPrivate {
+	gchar * cachefile;
+	sqlite3 * db;
+	guint drop_timer;
+};
+
+#define USAGE_TRACKER_GET_PRIVATE(o) \
+(G_TYPE_INSTANCE_GET_PRIVATE ((o), USAGE_TRACKER_TYPE, UsageTrackerPrivate))
+
+static void usage_tracker_class_init (UsageTrackerClass *klass);
+static void usage_tracker_init       (UsageTracker *self);
+static void usage_tracker_dispose    (GObject *object);
+static void usage_tracker_finalize   (GObject *object);
+static void build_db                 (UsageTracker * self);
+static gboolean drop_entries         (gpointer user_data);
+static void check_app_init (UsageTracker * self, const gchar * application);
+
+G_DEFINE_TYPE (UsageTracker, usage_tracker, G_TYPE_OBJECT);
+
+static void
+usage_tracker_class_init (UsageTrackerClass *klass)
+{
+	GObjectClass *object_class = G_OBJECT_CLASS (klass);
+
+	g_type_class_add_private (klass, sizeof (UsageTrackerPrivate));
+
+	object_class->dispose = usage_tracker_dispose;
+	object_class->finalize = usage_tracker_finalize;
+
+	return;
+}
+
+static void
+usage_tracker_init (UsageTracker *self)
+{
+	self->priv = USAGE_TRACKER_GET_PRIVATE(self);
+
+	self->priv->cachefile = NULL;
+	self->priv->db = NULL;
+	self->priv->drop_timer = 0;
+
+	const gchar * basecachedir = g_getenv("HUD_CACHE_DIR");
+	if (basecachedir == NULL) {
+		basecachedir = g_get_user_cache_dir();
+	}
+
+	gchar * cachedir = g_build_filename(basecachedir, "hud", NULL);
+	if (!g_file_test(cachedir, G_FILE_TEST_EXISTS | G_FILE_TEST_IS_DIR)) {
+		g_mkdir(cachedir, 1 << 6 | 1 << 7 | 1 << 8); // 700
+	}
+	g_free(cachedir);
+
+	self->priv->cachefile = g_build_filename(basecachedir, "hud", "usage-log.sqlite", NULL);
+	gboolean db_exists = g_file_test(self->priv->cachefile, G_FILE_TEST_EXISTS);
+	int open_status = sqlite3_open(self->priv->cachefile, &self->priv->db); 
+
+	if (open_status != SQLITE_OK) {
+		g_warning("Error building LRU DB");
+		sqlite3_close(self->priv->db);
+		self->priv->db = NULL;
+	}
+
+	if (self->priv->db != NULL && !db_exists) {
+		build_db(self);
+	}
+
+	drop_entries(self);
+	/* Drop entries daily if we run for a really long time */
+	self->priv->drop_timer = g_timeout_add_seconds(24 * 60 * 60, drop_entries, self);
+	
+	return;
+}
+
+static void
+usage_tracker_dispose (GObject *object)
+{
+	UsageTracker * self = USAGE_TRACKER(object);
+
+	if (self->priv->db != NULL) {
+		sqlite3_close(self->priv->db);
+		self->priv->db = NULL;
+	}
+
+	if (self->priv->drop_timer != 0) {
+		g_source_remove(self->priv->drop_timer);
+		self->priv->drop_timer = 0;
+	}
+
+	G_OBJECT_CLASS (usage_tracker_parent_class)->dispose (object);
+	return;
+}
+
+static void
+usage_tracker_finalize (GObject *object)
+{
+	UsageTracker * self = USAGE_TRACKER(object);
+
+	if (self->priv->cachefile != NULL) {
+		g_free(self->priv->cachefile);
+		self->priv->cachefile = NULL;
+	}
+
+	G_OBJECT_CLASS (usage_tracker_parent_class)->finalize (object);
+	return;
+}
+
+UsageTracker *
+usage_tracker_new (void)
+{
+	return g_object_new(USAGE_TRACKER_TYPE, NULL);
+}
+
+static void
+build_db (UsageTracker * self)
+{
+	g_debug("New database, initializing");
+
+	/* Create the table */
+	int exec_status = SQLITE_OK;
+	gchar * failstring = NULL;
+	exec_status = sqlite3_exec(self->priv->db,
+	                           "create table usage (application text, entry text, timestamp datetime);",
+	                           NULL, NULL, &failstring);
+	if (exec_status != SQLITE_OK) {
+		g_warning("Unable to create table: %s", failstring);
+	}
+
+	/* Import data from the system */
+
+	return;
+}
+
+void
+usage_tracker_mark_usage (UsageTracker * self, const gchar * application, const gchar * entry)
+{
+	g_return_if_fail(IS_USAGE_TRACKER(self));
+	check_app_init(self, application);
+
+	gchar * statement = g_strdup_printf("insert into usage (application, entry, timestamp) values ('%s', '%s', date('now'));", application, entry);
+	// g_debug("Executing: %s", statement);
+
+	int exec_status = SQLITE_OK;
+	gchar * failstring = NULL;
+	exec_status = sqlite3_exec(self->priv->db,
+	                           statement,
+	                           NULL, NULL, &failstring);
+	if (exec_status != SQLITE_OK) {
+		g_warning("Unable to insert into table: %s", failstring);
+	}
+
+	g_free(statement);
+	return;
+}
+
+static int
+count_cb (void * user_data, int columns, char ** values, char ** names)
+{
+	g_return_val_if_fail(columns == 1, -1);
+
+	guint * count = (guint *)user_data;
+
+	*count = g_ascii_strtoull(values[0], NULL, 10);
+
+	return SQLITE_OK;
+}
+
+guint
+usage_tracker_get_usage (UsageTracker * self, const gchar * application, const gchar * entry)
+{
+	g_return_val_if_fail(IS_USAGE_TRACKER(self), 0);
+	check_app_init(self, application);
+
+	gchar * statement = g_strdup_printf("select count(*) from usage where application = '%s' and entry = '%s' and timestamp > date('now', 'utc', '-30 days');", application, entry); // TODO: Add timestamp
+	// g_debug("Executing: %s", statement);
+
+	int exec_status = SQLITE_OK;
+	gchar * failstring = NULL;
+	guint count;
+	exec_status = sqlite3_exec(self->priv->db,
+	                           statement,
+	                           count_cb, &count, &failstring);
+	if (exec_status != SQLITE_OK) {
+		g_warning("Unable to insert into table: %s", failstring);
+	}
+
+	g_free(statement);
+	return count;
+}
+
+static gboolean
+drop_entries (gpointer user_data)
+{
+	g_return_val_if_fail(IS_USAGE_TRACKER(user_data), FALSE);
+	UsageTracker * self = USAGE_TRACKER(user_data);
+
+	const gchar * statement = "delete from usage where timestamp < date('now', 'utc', '-30 days');";
+	// g_debug("Executing: %s", statement);
+
+	int exec_status = SQLITE_OK;
+	gchar * failstring = NULL;
+	exec_status = sqlite3_exec(self->priv->db,
+	                           statement,
+	                           NULL, NULL, &failstring);
+	if (exec_status != SQLITE_OK) {
+		g_warning("Unable to drop entries from table: %s", failstring);
+	}
+
+	return TRUE;
+}
+
+static void
+check_app_init (UsageTracker * self, const gchar * application)
+{
+	gchar * statement = g_strdup_printf("select count(*) from usage where application = '%s';", application);
+
+	int exec_status = SQLITE_OK;
+	gchar * failstring = NULL;
+	guint count = 0;
+	exec_status = sqlite3_exec(self->priv->db,
+	                           statement,
+	                           count_cb, &count, &failstring);
+	if (exec_status != SQLITE_OK) {
+		g_warning("Unable to insert into table: %s", failstring);
+	}
+
+	g_free(statement);
+
+	if (count > 0) {
+		return;
+	}
+
+	g_debug("Initializing application: %s", application);
+	gchar * basename = g_path_get_basename(application);
+
+	gchar * app_info_path = NULL;
+
+	if (g_getenv("HUD_APP_INFO_DIR") != NULL) {
+		app_info_path = g_strdup(g_getenv("HUD_APP_INFO_DIR"));
+	} else {
+		app_info_path = g_build_filename(DATADIR, "hud", "app-info", NULL);
+	}
+
+	gchar * app_info_filename = g_strdup_printf("%s.hud-app-info", basename);
+	gchar * app_info = g_build_filename(app_info_path, app_info_filename, NULL);
+
+	if (!load_app_info(app_info, self->priv->db)) {
+		g_warning("Unable to load application information for application '%s' at path '%s'", application, app_info);
+	}
+
+	g_free(app_info);
+	g_free(app_info_filename);
+	g_free(app_info_path);
+	g_free(basename);
+
+	return;
+}

=== added file 'service/usage-tracker.h'
--- service/usage-tracker.h	1970-01-01 00:00:00 +0000
+++ service/usage-tracker.h	2011-11-17 04:27:35 +0000
@@ -0,0 +1,59 @@
+/*
+Tracks which menu items get used by users and works to promote those
+higher in the search rankings than others.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __USAGE_TRACKER_H__
+#define __USAGE_TRACKER_H__
+
+#include <glib.h>
+#include <glib-object.h>
+
+G_BEGIN_DECLS
+
+#define USAGE_TRACKER_TYPE            (usage_tracker_get_type ())
+#define USAGE_TRACKER(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TRACKER_TYPE, UsageTracker))
+#define USAGE_TRACKER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TRACKER_TYPE, UsageTrackerClass))
+#define IS_USAGE_TRACKER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TRACKER_TYPE))
+#define IS_USAGE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TRACKER_TYPE))
+#define USAGE_TRACKER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TRACKER_TYPE, UsageTrackerClass))
+
+typedef struct _UsageTracker        UsageTracker;
+typedef struct _UsageTrackerClass   UsageTrackerClass;
+typedef struct _UsageTrackerPrivate UsageTrackerPrivate;
+
+struct _UsageTrackerClass {
+	GObjectClass parent_class;
+};
+
+struct _UsageTracker {
+	GObject parent;
+
+	UsageTrackerPrivate * priv;
+};
+
+GType usage_tracker_get_type (void);
+UsageTracker * usage_tracker_new (void);
+void usage_tracker_mark_usage (UsageTracker * self, const gchar * application, const gchar * entry);
+guint usage_tracker_get_usage (UsageTracker * self, const gchar * application, const gchar * entry);
+
+G_END_DECLS
+
+#endif

=== added directory 'tests'
=== added file 'tests/Makefile.am'
--- tests/Makefile.am	1970-01-01 00:00:00 +0000
+++ tests/Makefile.am	2011-11-28 05:30:55 +0000
@@ -0,0 +1,351 @@
+DISTCLEANFILES =
+EXTRA_DIST =
+
+TESTS =
+check_PROGRAMS =
+XFAIL_TESTS =
+
+DBUS_RUNNER=dbus-test-runner
+
+######################
+# Test Distance
+######################
+
+TESTS += \
+	test-distance-test
+
+check_PROGRAMS += \
+	test-distance
+
+DISTANCE_XML_REPORT = test-distance.xml
+
+test-distance-test: test-distance Makefile.am
+	@echo "#!/bin/bash" > $@
+	@echo $(XVFB_RUN) >> $@
+	@echo gtester --verbose -k -o $(DISTANCE_XML_REPORT) $(builddir)/test-distance >> $@
+	@chmod +x $@
+
+test_distance_SOURCES = \
+	test-distance.c
+
+test_distance_CFLAGS = \
+	$(HUD_CFLAGS) \
+	-Wall -Werror
+
+test_distance_LDADD = \
+	$(HUD_LIBS)
+
+DISTCLEANFILES += $(DISTANCE_XML_REPORT)
+
+######################
+# Test Usage DB Simple
+######################
+
+TESTS += \
+	test-usage-db-simple-test
+
+check_PROGRAMS += \
+	test-usage-db-simple
+
+USAGE_DB_SIMPLE_XML_REPORT = test-usage-db-simple.xml
+
+test-usage-db-simple-test: test-usage-db-simple test-usage-db-simple.sql Makefile.am
+	@echo "#!/bin/bash -e" > $@
+	@echo cd \`mktemp -d $(abs_builddir)/test-usage-db-simple.dir.XXXXXX\` >> $@
+	@echo mkdir -p hud >> $@
+	@echo cat $(abs_srcdir)/test-usage-db-simple.sql \| sqlite3 hud/usage-log.sqlite >> $@
+	@echo export HUD_CACHE_DIR=\`pwd\` >> $@
+	@echo gtester --verbose -k -o $(USAGE_DB_SIMPLE_XML_REPORT) $(abs_builddir)/test-usage-db-simple >> $@
+	@echo cd .. >> $@
+	@echo rm -rf test-usage-db-simple.dir.\* >> $@
+	@chmod +x $@
+
+test_usage_db_simple_SOURCES = \
+	test-usage-db-simple.c
+
+test_usage_db_simple_CFLAGS = \
+	$(HUD_CFLAGS) \
+	-DDATADIR=\""$(datadir)"\" \
+	-I$(top_srcdir)/service \
+	-Wall -Werror
+
+test_usage_db_simple_LDADD = \
+	$(HUD_LIBS)
+
+DISTCLEANFILES += $(USAGE_DB_SIMPLE_XML_REPORT)
+EXTRA_DIST += test-usage-db-simple.sql
+
+######################
+# Test Usage DB Old
+######################
+
+TESTS += \
+	test-usage-db-old-test
+
+check_PROGRAMS += \
+	test-usage-db-old
+
+USAGE_DB_OLD_XML_REPORT = test-usage-db-old.xml
+
+test-usage-db-old-test: test-usage-db-old test-usage-db-old.sql Makefile.am
+	@echo "#!/bin/bash -e" > $@
+	@echo cd \`mktemp -d $(abs_builddir)/test-usage-db-old.dir.XXXXXX\` >> $@
+	@echo mkdir -p hud >> $@
+	@echo cat $(abs_srcdir)/test-usage-db-old.sql \| sqlite3 hud/usage-log.sqlite >> $@
+	@echo export HUD_CACHE_DIR=\`pwd\` >> $@
+	@echo gtester --verbose -k -o $(USAGE_DB_SIMPLE_XML_REPORT) $(abs_builddir)/test-usage-db-old >> $@
+	@echo cd .. >> $@
+	@echo rm -rf test-usage-db-old.dir.\* >> $@
+	@chmod +x $@
+
+test_usage_db_old_SOURCES = \
+	test-usage-db-old.c
+
+test_usage_db_old_CFLAGS = \
+	$(HUD_CFLAGS) \
+	-DDATADIR=\""$(datadir)"\" \
+	-I$(top_srcdir)/service \
+	-Wall -Werror
+
+test_usage_db_old_LDADD = \
+	$(HUD_LIBS)
+
+DISTCLEANFILES += $(USAGE_DB_OLD_XML_REPORT)
+EXTRA_DIST += test-usage-db-old.sql
+
+#######################
+# Test Usage DB Ancient
+#######################
+
+TESTS += \
+	test-usage-db-ancient-test
+
+check_PROGRAMS += \
+	test-usage-db-ancient
+
+test-usage-db-ancient-test: test-usage-db-ancient test-usage-db-ancient.sql test-usage-dump-entries.sql Makefile.am
+	@echo "#!/bin/bash -e" > $@
+	@echo cd \`mktemp -d $(abs_builddir)/test-usage-db-ancient.dir.XXXXXX\` >> $@
+	@echo mkdir -p hud >> $@
+	@echo cat $(abs_srcdir)/test-usage-db-ancient.sql \| sqlite3 hud/usage-log.sqlite >> $@
+	@echo export HUD_CACHE_DIR=\`pwd\` >> $@
+	@echo $(abs_builddir)/test-usage-db-ancient >> $@
+	@echo if test \`cat $(abs_srcdir)/test-usage-dump-entries.sql \| sqlite3 hud/usage-log.sqlite \| wc -l\` -gt 0\; then >> $@
+	@echo echo Database has entries >> $@
+	@echo exit 1 >> $@
+	@echo fi >> $@
+	@echo cd .. >> $@
+	@echo rm -rf test-usage-db-ancient.dir.\* >> $@
+	@chmod +x $@
+
+test_usage_db_ancient_SOURCES = \
+	test-usage-db-ancient.c
+
+test_usage_db_ancient_CFLAGS = \
+	$(HUD_CFLAGS) \
+	-DDATADIR=\""$(datadir)"\" \
+	-I$(top_srcdir)/service \
+	-Wall -Werror
+
+test_usage_db_ancient_LDADD = \
+	$(HUD_LIBS)
+
+EXTRA_DIST += \
+	test-usage-db-ancient.sql \
+	test-usage-dump-entries.sql
+
+#######################
+# Test Usage DB Testapp
+#######################
+
+TESTS += \
+	test-usage-db-testapp-test
+
+check_PROGRAMS += \
+	test-usage-db-testapp
+
+USAGE_TESTAPP_XML_REPORT = $(abs_builddir)/test-usage-db-testapp.xml
+
+test-usage-db-testapp-test: test-usage-db-testapp good-app-info/testapp.desktop.hud-app-info good-app-info/testapp100.desktop.hud-app-info test-create-db.sql Makefile.am
+	@echo "#!/bin/bash -e" > $@
+	@echo cd \`mktemp -d $(abs_builddir)/test-usage-db-testapp.dir.XXXXXX\` >> $@
+	@echo mkdir -p hud >> $@
+	@echo cat $(abs_srcdir)/test-create-db.sql \| sqlite3 hud/usage-log.sqlite >> $@
+	@echo export HUD_CACHE_DIR=\`pwd\` >> $@
+	@echo export HUD_APP_INFO_DIR=$(abs_srcdir)/good-app-info >> $@
+	@echo gtester --verbose -k -o $(USAGE_TESTAPP_XML_REPORT) $(abs_builddir)/test-usage-db-testapp >> $@
+	@echo cd .. >> $@
+	@echo rm -rf test-usage-db-testapp.dir.\* >> $@
+	@chmod +x $@
+
+test_usage_db_testapp_SOURCES = \
+	test-usage-db-testapp.c
+
+test_usage_db_testapp_CFLAGS = \
+	$(HUD_CFLAGS) \
+	-DDATADIR=\""$(datadir)"\" \
+	-I$(top_srcdir)/service \
+	-Wall -Werror
+
+test_usage_db_testapp_LDADD = \
+	$(HUD_LIBS)
+
+EXTRA_DIST += \
+	test-create-db.sql \
+	good-app-info/testapp100.desktop.hud-app-info \
+	good-app-info/testapp.desktop.hud-app-info
+
+DISTCLEANFILES += $(USAGE_TESTAPP_XML_REPORT)
+
+#########################
+# Test Indicator Tracker
+#########################
+
+TESTS += \
+	test-indicator-tracker-test
+
+check_PROGRAMS += \
+	test-indicator-tracker \
+	test-indicator-tracker-owner
+
+test-indicator-tracker-test: test-indicator-tracker test-indicator-tracker-owner Makefile.am
+	@echo "#!/bin/bash -e" > $@
+	@echo $(XVFB_RUN) >> $@
+	@echo $(DBUS_RUNNER) --task $(builddir)/test-indicator-tracker --task-name Tracker --task $(builddir)/test-indicator-tracker-owner --parameter com.canonical.indicator.messages --task-name Messages --ignore-return --task $(builddir)/test-indicator-tracker-owner --parameter com.canonical.indicators.sound --task-name Sound --ignore-return >> $@
+	@chmod +x $@
+
+test_indicator_tracker_SOURCES = \
+	test-indicator-tracker.c
+
+test_indicator_tracker_CFLAGS = \
+	$(HUD_CFLAGS) \
+	-Wall -Werror
+
+test_indicator_tracker_LDADD = \
+	$(HUD_LIBS)
+
+test_indicator_tracker_owner_SOURCES = \
+	test-indicator-tracker-owner.c
+
+test_indicator_tracker_owner_CFLAGS = \
+	$(HUD_CFLAGS) \
+	-Wall -Werror
+
+test_indicator_tracker_owner_LDADD = \
+	$(HUD_LIBS)
+
+#########################
+# Test Bad App Info
+#########################
+
+TESTS += \
+	test-bad-app-info-dual-header \
+	test-bad-app-info-item-no-count \
+	test-bad-app-info-item-no-name \
+	test-bad-app-info-menu-no-name \
+	test-bad-app-info-missing-desktop \
+	test-bad-app-info-missing-menus \
+	test-bad-app-info-multiple-menus
+
+test-bad-app-info-dual-header: bad-app-info/dual-headers.hud-app-info test-bad-app-info Makefile.am
+	@echo "#!/bin/bash -e" > $@
+	@echo $(builddir)/test-bad-app-info $(srcdir)/bad-app-info/dual-headers.hud-app-info >> $@
+	@chmod +x $@
+
+test-bad-app-info-item-no-count: bad-app-info/item-no-count.hud-app-info test-bad-app-info Makefile.am
+	@echo "#!/bin/bash -e" > $@
+	@echo $(builddir)/test-bad-app-info $(srcdir)/bad-app-info/item-no-count.hud-app-info >> $@
+	@chmod +x $@
+
+test-bad-app-info-item-no-name: bad-app-info/item-no-name.hud-app-info test-bad-app-info Makefile.am
+	@echo "#!/bin/bash -e" > $@
+	@echo $(builddir)/test-bad-app-info $(srcdir)/bad-app-info/item-no-name.hud-app-info >> $@
+	@chmod +x $@
+
+test-bad-app-info-menu-no-name: bad-app-info/menu-no-name.hud-app-info test-bad-app-info Makefile.am
+	@echo "#!/bin/bash -e" > $@
+	@echo $(builddir)/test-bad-app-info $(srcdir)/bad-app-info/menu-no-name.hud-app-info >> $@
+	@chmod +x $@
+
+test-bad-app-info-missing-menus: bad-app-info/missing-menus.hud-app-info test-bad-app-info Makefile.am
+	@echo "#!/bin/bash -e" > $@
+	@echo $(builddir)/test-bad-app-info $(srcdir)/bad-app-info/missing-menus.hud-app-info >> $@
+	@chmod +x $@
+
+test-bad-app-info-missing-desktop: bad-app-info/missing-desktop.hud-app-info test-bad-app-info Makefile.am
+	@echo "#!/bin/bash -e" > $@
+	@echo $(builddir)/test-bad-app-info $(srcdir)/bad-app-info/missing-desktop.hud-app-info >> $@
+	@chmod +x $@
+
+test-bad-app-info-multiple-menus: bad-app-info/multiple-menus.hud-app-info test-bad-app-info Makefile.am
+	@echo "#!/bin/bash -e" > $@
+	@echo $(builddir)/test-bad-app-info $(srcdir)/bad-app-info/multiple-menus.hud-app-info >> $@
+	@chmod +x $@
+
+EXTRA_DIST += \
+	bad-app-info/dual-headers.hud-app-info \
+	bad-app-info/item-no-count.hud-app-info \
+	bad-app-info/item-no-name.hud-app-info \
+	bad-app-info/menu-no-name.hud-app-info \
+	bad-app-info/missing-desktop.hud-app-info \
+	bad-app-info/missing-menus.hud-app-info \
+	bad-app-info/multiple-menus.hud-app-info
+
+check_PROGRAMS += \
+	test-bad-app-info
+
+test_bad_app_info_SOURCES = \
+	test-bad-app-info.c
+
+test_bad_app_info_CFLAGS = \
+	$(HUD_CFLAGS) \
+	-I$(top_srcdir)/service \
+	-Wall -Werror
+
+test_bad_app_info_LDADD = \
+	$(HUD_LIBS)
+
+#########################
+# Test Good App Info
+#########################
+
+TESTS += \
+	test-good-app-info-tons-of-entries
+
+check_PROGRAMS += \
+	test-load-app-info
+
+test_load_app_info_SOURCES = \
+	test-load-app-info.c
+
+test_load_app_info_CFLAGS = \
+	$(HUD_CFLAGS) \
+	-I$(top_srcdir)/service \
+	-Wall -Werror
+
+test_load_app_info_LDADD = \
+	$(HUD_LIBS)
+
+test-good-app-info-tons-of-entries: good-app-info/tons-of-entries.hud-app-info test-load-app-info test-usage-dump-entries.sql Makefile.am
+	@echo "#!/bin/bash -e" > $@
+	@echo cd \`mktemp -d $(abs_builddir)/test-good-app-info-tons-of-entries.dir.XXXXXX\` >> $@
+	@echo mkdir -p hud >> $@
+	@echo $(abs_builddir)/test-load-app-info hud/usage-log.sqlite $(abs_srcdir)/good-app-info/tons-of-entries.hud-app-info >> $@
+	@echo export HUD_CACHE_DIR=\`pwd\` >> $@
+	@echo if test \`cat $(abs_srcdir)/test-usage-dump-entries.sql \| sqlite3 hud/usage-log.sqlite \| wc -l\` -ne 540\; then >> $@
+	@echo echo Database has wrong number of entries >> $@
+	@echo exit 1 >> $@
+	@echo fi >> $@
+	@echo cd .. >> $@
+	@echo rm -rf test-good-app-info-tons-of-entries.dir.\* >> $@
+	@chmod +x $@
+
+EXTRA_DIST += \
+	good-app-info/tons-of-entries.hud-app-info \
+	test-usage-dump-entries.sql
+
+#########################
+# Footer
+#########################
+
+DISTCLEANFILES += $(TESTS)

=== added directory 'tests/bad-app-info'
=== added file 'tests/bad-app-info/dual-headers.hud-app-info'
--- tests/bad-app-info/dual-headers.hud-app-info	1970-01-01 00:00:00 +0000
+++ tests/bad-app-info/dual-headers.hud-app-info	2011-11-27 16:43:00 +0000
@@ -0,0 +1,3 @@
+<hudappinfo>
+	<hudappinfo />
+<hudappinfo>

=== added file 'tests/bad-app-info/item-no-count.hud-app-info'
--- tests/bad-app-info/item-no-count.hud-app-info	1970-01-01 00:00:00 +0000
+++ tests/bad-app-info/item-no-count.hud-app-info	2011-11-27 17:53:28 +0000
@@ -0,0 +1,8 @@
+<hudappinfo>
+	<desktopfile path="/usr/share/applications/testapp.desktop" />
+	<menus>
+		<menu name="File">
+			<item name="Open" />
+		</menu>
+	<menus>
+</hudappinfo>

=== added file 'tests/bad-app-info/item-no-name.hud-app-info'
--- tests/bad-app-info/item-no-name.hud-app-info	1970-01-01 00:00:00 +0000
+++ tests/bad-app-info/item-no-name.hud-app-info	2011-11-27 17:53:28 +0000
@@ -0,0 +1,8 @@
+<hudappinfo>
+	<desktopfile path="/usr/share/applications/testapp.desktop" />
+	<menus>
+		<menu name="File">
+			<item count="1" />
+		</menu>
+	<menus>
+</hudappinfo>

=== added file 'tests/bad-app-info/menu-no-name.hud-app-info'
--- tests/bad-app-info/menu-no-name.hud-app-info	1970-01-01 00:00:00 +0000
+++ tests/bad-app-info/menu-no-name.hud-app-info	2011-11-27 17:53:28 +0000
@@ -0,0 +1,8 @@
+<hudappinfo>
+	<desktopfile path="/usr/share/applications/testapp.desktop" />
+	<menus>
+		<menu>
+			<item name="Open" count="1" />
+		</menu>
+	<menus>
+</hudappinfo>

=== added file 'tests/bad-app-info/missing-desktop.hud-app-info'
--- tests/bad-app-info/missing-desktop.hud-app-info	1970-01-01 00:00:00 +0000
+++ tests/bad-app-info/missing-desktop.hud-app-info	2011-11-27 17:53:28 +0000
@@ -0,0 +1,7 @@
+<hudappinfo>
+	<menus>
+		<menu name="File">
+			<item name="Open" count="1" />
+		</menu>
+	</menus>
+</hudappinfo>

=== added file 'tests/bad-app-info/missing-menus.hud-app-info'
--- tests/bad-app-info/missing-menus.hud-app-info	1970-01-01 00:00:00 +0000
+++ tests/bad-app-info/missing-menus.hud-app-info	2011-11-27 17:53:28 +0000
@@ -0,0 +1,6 @@
+<hudappinfo>
+	<desktopfile path="/usr/share/applications/testapp.desktop" />
+	<menu name="File">
+		<item name="Open" count="1" />
+	</menu>
+</hudappinfo>

=== added file 'tests/bad-app-info/multiple-menus.hud-app-info'
--- tests/bad-app-info/multiple-menus.hud-app-info	1970-01-01 00:00:00 +0000
+++ tests/bad-app-info/multiple-menus.hud-app-info	2011-11-28 05:30:55 +0000
@@ -0,0 +1,13 @@
+<hudappinfo>
+	<desktopfile path="/usr/share/applications/testapp.desktop" />
+	<menus>
+		<menu name="File">
+			<item name="Open" count="1" />
+		</menu>
+	<menus>
+	<menus>
+		<menu name="File">
+			<item name="Quit" count="1" />
+		</menu>
+	<menus>
+</hudappinfo>

=== added directory 'tests/good-app-info'
=== added file 'tests/good-app-info/testapp.desktop.hud-app-info'
--- tests/good-app-info/testapp.desktop.hud-app-info	1970-01-01 00:00:00 +0000
+++ tests/good-app-info/testapp.desktop.hud-app-info	2011-11-28 02:45:21 +0000
@@ -0,0 +1,8 @@
+<hudappinfo>
+	<desktopfile path="/usr/share/applications/testapp.desktop" />
+	<menus>
+		<menu name="Menu">
+			<item name="Item" count="7" />
+		</menu>
+	</menus>
+</hudappinfo>

=== added file 'tests/good-app-info/testapp100.desktop.hud-app-info'
--- tests/good-app-info/testapp100.desktop.hud-app-info	1970-01-01 00:00:00 +0000
+++ tests/good-app-info/testapp100.desktop.hud-app-info	2011-11-28 03:02:52 +0000
@@ -0,0 +1,8 @@
+<hudappinfo>
+	<desktopfile path="/usr/share/applications/testapp100.desktop" />
+	<menus>
+		<menu name="Menu">
+			<item name="Item" count="100" />
+		</menu>
+	</menus>
+</hudappinfo>

=== added file 'tests/good-app-info/tons-of-entries.hud-app-info'
--- tests/good-app-info/tons-of-entries.hud-app-info	1970-01-01 00:00:00 +0000
+++ tests/good-app-info/tons-of-entries.hud-app-info	2011-11-27 20:21:13 +0000
@@ -0,0 +1,143 @@
+<hudappinfo>
+	<desktopfile path="/usr/share/applications/tons-of-entries.desktop" />
+	<menus>
+		<menu name="Top 1">
+			<menu name="Top 1 2">
+				<item name="Item 1 2 1" count="5" />
+				<item name="Item 1 2 2" count="5" />
+				<item name="Item 1 2 3" count="5" />
+				<item name="Item 1 2 4" count="5" />
+				<item name="Item 1 2 5" count="5" />
+				<item name="Item 1 2 6" count="5" />
+				<item name="Item 1 2 7" count="5" />
+				<item name="Item 1 2 8" count="5" />
+				<item name="Item 1 2 9" count="5" />
+			</menu>
+			<menu name="Top 1 3">
+				<item name="Item 1 3 1" count="5" />
+				<item name="Item 1 3 2" count="5" />
+				<item name="Item 1 3 3" count="5" />
+				<item name="Item 1 3 4" count="5" />
+				<item name="Item 1 3 5" count="5" />
+				<item name="Item 1 3 6" count="5" />
+				<item name="Item 1 3 7" count="5" />
+				<item name="Item 1 3 8" count="5" />
+				<item name="Item 1 3 9" count="5" />
+			</menu>
+			<menu name="Top 1 4">
+				<item name="Item 1 4 1" count="5" />
+				<item name="Item 1 4 2" count="5" />
+				<item name="Item 1 4 3" count="5" />
+				<item name="Item 1 4 4" count="5" />
+				<item name="Item 1 4 5" count="5" />
+				<item name="Item 1 4 6" count="5" />
+				<item name="Item 1 4 7" count="5" />
+				<item name="Item 1 4 8" count="5" />
+				<item name="Item 1 4 9" count="5" />
+			</menu>
+			<menu name="Top 1 5">
+				<item name="Item 1 5 1" count="5" />
+				<item name="Item 1 5 2" count="5" />
+				<item name="Item 1 5 3" count="5" />
+				<item name="Item 1 5 4" count="5" />
+				<item name="Item 1 5 5" count="5" />
+				<item name="Item 1 5 6" count="5" />
+				<item name="Item 1 5 7" count="5" />
+				<item name="Item 1 5 8" count="5" />
+				<item name="Item 1 5 9" count="5" />
+			</menu>
+		</menu>
+		<menu name="Top 2">
+			<menu name="Top 2 2">
+				<item name="Item 2 2 1" count="5" />
+				<item name="Item 2 2 2" count="5" />
+				<item name="Item 2 2 3" count="5" />
+				<item name="Item 2 2 4" count="5" />
+				<item name="Item 2 2 5" count="5" />
+				<item name="Item 2 2 6" count="5" />
+				<item name="Item 2 2 7" count="5" />
+				<item name="Item 2 2 8" count="5" />
+				<item name="Item 2 2 9" count="5" />
+			</menu>
+			<menu name="Top 2 3">
+				<item name="Item 2 3 1" count="5" />
+				<item name="Item 2 3 2" count="5" />
+				<item name="Item 2 3 3" count="5" />
+				<item name="Item 2 3 4" count="5" />
+				<item name="Item 2 3 5" count="5" />
+				<item name="Item 2 3 6" count="5" />
+				<item name="Item 2 3 7" count="5" />
+				<item name="Item 2 3 8" count="5" />
+				<item name="Item 2 3 9" count="5" />
+			</menu>
+			<menu name="Top 2 4">
+				<item name="Item 2 4 1" count="5" />
+				<item name="Item 2 4 2" count="5" />
+				<item name="Item 2 4 3" count="5" />
+				<item name="Item 2 4 4" count="5" />
+				<item name="Item 2 4 5" count="5" />
+				<item name="Item 2 4 6" count="5" />
+				<item name="Item 2 4 7" count="5" />
+				<item name="Item 2 4 8" count="5" />
+				<item name="Item 2 4 9" count="5" />
+			</menu>
+			<menu name="Top 2 5">
+				<item name="Item 2 5 1" count="5" />
+				<item name="Item 2 5 2" count="5" />
+				<item name="Item 2 5 3" count="5" />
+				<item name="Item 2 5 4" count="5" />
+				<item name="Item 2 5 5" count="5" />
+				<item name="Item 2 5 6" count="5" />
+				<item name="Item 2 5 7" count="5" />
+				<item name="Item 2 5 8" count="5" />
+				<item name="Item 2 5 9" count="5" />
+			</menu>
+		</menu>
+		<menu name="Top 3">
+			<menu name="Top 3 2">
+				<item name="Item 3 2 1" count="5" />
+				<item name="Item 3 2 2" count="5" />
+				<item name="Item 3 2 3" count="5" />
+				<item name="Item 3 2 4" count="5" />
+				<item name="Item 3 2 5" count="5" />
+				<item name="Item 3 2 6" count="5" />
+				<item name="Item 3 2 7" count="5" />
+				<item name="Item 3 2 8" count="5" />
+				<item name="Item 3 2 9" count="5" />
+			</menu>
+			<menu name="Top 3 3">
+				<item name="Item 3 3 1" count="5" />
+				<item name="Item 3 3 2" count="5" />
+				<item name="Item 3 3 3" count="5" />
+				<item name="Item 3 3 4" count="5" />
+				<item name="Item 3 3 5" count="5" />
+				<item name="Item 3 3 6" count="5" />
+				<item name="Item 3 3 7" count="5" />
+				<item name="Item 3 3 8" count="5" />
+				<item name="Item 3 3 9" count="5" />
+			</menu>
+			<menu name="Top 3 4">
+				<item name="Item 3 4 1" count="5" />
+				<item name="Item 3 4 2" count="5" />
+				<item name="Item 3 4 3" count="5" />
+				<item name="Item 3 4 4" count="5" />
+				<item name="Item 3 4 5" count="5" />
+				<item name="Item 3 4 6" count="5" />
+				<item name="Item 3 4 7" count="5" />
+				<item name="Item 3 4 8" count="5" />
+				<item name="Item 3 4 9" count="5" />
+			</menu>
+			<menu name="Top 3 5">
+				<item name="Item 3 5 1" count="5" />
+				<item name="Item 3 5 2" count="5" />
+				<item name="Item 3 5 3" count="5" />
+				<item name="Item 3 5 4" count="5" />
+				<item name="Item 3 5 5" count="5" />
+				<item name="Item 3 5 6" count="5" />
+				<item name="Item 3 5 7" count="5" />
+				<item name="Item 3 5 8" count="5" />
+				<item name="Item 3 5 9" count="5" />
+			</menu>
+		</menu>
+	</menus>
+</hudappinfo>

=== added file 'tests/test-bad-app-info.c'
--- tests/test-bad-app-info.c	1970-01-01 00:00:00 +0000
+++ tests/test-bad-app-info.c	2011-11-27 19:19:32 +0000
@@ -0,0 +1,106 @@
+/*
+Make sure the app info is truly bad and we don't crash or something.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <unistd.h>
+#include <glib.h>
+#include <glib/gstdio.h>
+#include <glib-object.h>
+#include "load-app-info.h"
+#include "load-app-info.c"
+
+static void
+build_db (sqlite3 * db)
+{
+	/* Create the table */
+	int exec_status = SQLITE_OK;
+	gchar * failstring = NULL;
+	exec_status = sqlite3_exec(db,
+	                           "create table usage (application text, entry text, timestamp datetime);",
+	                           NULL, NULL, &failstring);
+	if (exec_status != SQLITE_OK) {
+		g_warning("Unable to create table: %s", failstring);
+	}
+
+	/* Import data from the system */
+
+	return;
+}
+
+int
+main (int argv, char * argc[])
+{
+	gboolean passed = TRUE;
+
+	if (argv != 2) {
+		g_printerr("Usage: %s <app-info file path>\n", argc[0]);
+		return 1;
+	}
+
+	g_type_init();
+
+	gchar * filename = NULL;
+	gint tmpfile = g_file_open_tmp("hud-test-bad-app-info-temp-db-XXXXXX", &filename, NULL);
+
+	if (tmpfile < 0) {
+		passed = FALSE;
+		goto cleanup;
+	}
+
+	close(tmpfile);
+	/* NOTE: there is a small security bug here in that we're closing the
+	   file and reopening it, so the temp isn't really gauranteed to be
+	   safe.  But, I don't think we're really worried about security in this
+	   utility. */
+
+	sqlite3 * db = NULL;
+	int open_status = sqlite3_open(filename, &db); 
+
+	if (open_status != SQLITE_OK) {
+		g_warning("Error opening usage DB: %s", filename);
+		passed = FALSE;
+		goto cleanup;
+	}
+
+	/* Create the table in the DB */
+	build_db(db);
+
+	passed = !load_app_info(argc[1], db);
+
+cleanup:
+	if (db != NULL) {
+		sqlite3_close(db);
+	}
+
+	if (filename != NULL) {
+		if (g_getenv("HUD_VERIFY_NO_UNLINK") == NULL) {
+			g_unlink(filename);
+		} else {
+			g_print("Temp db '%s' not deleted\n", filename);
+		}
+		g_free(filename);
+	}
+
+	if (passed) {
+		return 0;
+	} else {
+		return 1;
+	}
+}

=== added file 'tests/test-create-db.sql'
--- tests/test-create-db.sql	1970-01-01 00:00:00 +0000
+++ tests/test-create-db.sql	2011-11-28 02:37:10 +0000
@@ -0,0 +1,1 @@
+create table usage (application text, entry text, timestamp datetime);

=== added file 'tests/test-distance.c'
--- tests/test-distance.c	1970-01-01 00:00:00 +0000
+++ tests/test-distance.c	2011-12-02 21:14:23 +0000
@@ -0,0 +1,161 @@
+/*
+Test code for distance functions
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <glib.h>
+#include <glib-object.h>
+
+#define DUMP_MATRIX 1
+#include "../service/distance.h"
+#include "../service/distance.c"
+
+/* Ensure the base calculation works */
+static void
+test_distance_base (void)
+{
+	gchar * testdata1[] = {"foo", NULL};
+	g_assert(calculate_distance("foo", testdata1, NULL) == 0);
+
+	gchar * testdata2[] = {"bar", NULL};
+	g_assert(calculate_distance("foo", testdata2, NULL) != 0);
+
+	g_assert(calculate_distance("foo", NULL, NULL) != 0);
+
+	g_assert(calculate_distance(NULL, testdata1, NULL) != 0);
+
+	return;
+}
+
+/* Test a set of strings */
+static void
+test_set (GStrv * teststrings, int num_tests, const gchar * search, int right)
+{
+	int i;
+
+	for (i = 0; i < num_tests; i++) {
+		if (i == right)
+			continue;
+
+		if (calculate_distance(search, teststrings[i], NULL) < calculate_distance(search, teststrings[right], NULL)) {
+			gchar * teststr = g_strjoinv(" > ", teststrings[i]);
+			gchar * rightstr = g_strjoinv(" > ", teststrings[right]);
+
+			g_error("Found '%s' with search string '%s' instead of '%s'", teststr, search, rightstr);
+
+			g_free(teststr);
+			g_free(rightstr);
+		}
+	}
+
+	return;
+}
+
+/* Ensure the base calculation works */
+static void
+test_distance_subfunction (void)
+{
+	GStrv teststrings[4];
+	gchar * teststrings0[] = {"File", "Open", NULL}; teststrings[0] = teststrings0;
+	gchar * teststrings1[] = {"File", "New", NULL}; teststrings[1] = teststrings1;
+	gchar * teststrings2[] = {"File", "Print", NULL}; teststrings[2] = teststrings2;
+	gchar * teststrings3[] = {"File", "Print Preview", NULL}; teststrings[3] = teststrings3;
+
+	test_set(teststrings, 4, "Print Pre", 3);
+	return;
+}
+
+/* Ensure that we can handle some misspelling */
+static void
+test_distance_missspelll (void)
+{
+	GStrv teststrings[4];
+	gchar * teststrings0[] = {"File", "Open", NULL}; teststrings[0] = teststrings0;
+	gchar * teststrings1[] = {"File", "New", NULL}; teststrings[1] = teststrings1;
+	gchar * teststrings2[] = {"File", "Print", NULL}; teststrings[2] = teststrings2;
+	gchar * teststrings3[] = {"File", "Print Preview", NULL}; teststrings[3] = teststrings3;
+
+	test_set(teststrings, 4, "Prnt Pr", 3);
+	test_set(teststrings, 4, "Print Preiw", 3);
+	test_set(teststrings, 4, "Prnt Pr", 3);
+
+	return;
+}
+
+/* Ensure that we can find print with short strings */
+static void
+test_distance_print_issues (void)
+{
+	GStrv teststrings[6];
+	gchar * teststrings0[] = {"File", "New", NULL}; teststrings[0] = teststrings0;
+	gchar * teststrings1[] = {"File", "Open", NULL}; teststrings[1] = teststrings1;
+	gchar * teststrings2[] = {"Edit", "Undo", NULL}; teststrings[2] = teststrings2;
+	gchar * teststrings3[] = {"Help", "About", NULL}; teststrings[3] = teststrings3;
+	gchar * teststrings4[] = {"Help", "Empty", NULL}; teststrings[4] = teststrings4;
+	gchar * teststrings5[] = {"File", "Print...", NULL}; teststrings[5] = teststrings5;
+
+	test_set(teststrings, 6, "Pr", 5);
+	test_set(teststrings, 6, "Print", 5);
+	test_set(teststrings, 6, "Print...", 5);
+
+	return;
+}
+
+/* Check to make sure the returned hits are not dups and the
+   proper number */
+static void
+test_distance_dups (void)
+{
+	GStrv hits = NULL;
+	gchar * teststrings[] = {"Inflated", "Confluated", "Sublimated", "Sadated", "Situated", "Infatuated", NULL};
+
+	g_assert(calculate_distance("ted inf", teststrings, &hits) != 0);
+	g_assert(g_strv_length(hits) == 2);
+	g_assert(g_strcmp0(hits[0], hits[1]) != 0);
+
+	g_strfreev(hits);
+
+	return;
+}
+
+/* Build the test suite */
+static void
+test_distance_suite (void)
+{
+	g_test_add_func ("/hud/distance/base",          test_distance_base);
+	g_test_add_func ("/hud/distance/subfunction",   test_distance_subfunction);
+	g_test_add_func ("/hud/distance/missspelll",    test_distance_missspelll);
+	g_test_add_func ("/hud/distance/print_issues",  test_distance_print_issues);
+	g_test_add_func ("/hud/distance/duplicates",    test_distance_dups);
+	return;
+}
+
+gint
+main (gint argc, gchar * argv[])
+{
+	//gtk_init(&argc, &argv);
+	g_type_init();
+
+	g_test_init(&argc, &argv, NULL);
+
+	/* Test suites */
+	test_distance_suite();
+
+	return g_test_run ();
+}

=== added file 'tests/test-indicator-tracker-owner.c'
--- tests/test-indicator-tracker-owner.c	1970-01-01 00:00:00 +0000
+++ tests/test-indicator-tracker-owner.c	2011-11-17 04:30:19 +0000
@@ -0,0 +1,70 @@
+/*
+Test code for indicator tracker.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <glib.h>
+#include <gio/gio.h>
+
+void
+name_aquired (GDBusConnection * connection, const gchar * name, gpointer user_data)
+{
+	g_debug("Got name: %s", name);
+	return;
+}
+
+gboolean
+end_of_line (gpointer user_data)
+{
+	g_main_loop_quit((GMainLoop *)user_data);
+	return FALSE;
+}
+
+int
+main (int argc, char * argv[])
+{
+	g_type_init();
+
+	if (argc != 2) {
+		g_error("ARG, need a single argument");
+		return 1;
+	}
+
+	g_debug("Trying for name: %s", argv[1]);
+
+	g_bus_own_name(G_BUS_TYPE_SESSION,
+	               argv[1],
+	               G_BUS_NAME_OWNER_FLAGS_NONE,
+	               NULL, /* bus aquired */
+	               name_aquired,
+	               NULL, /* lost */
+	               NULL, /* data */
+	               NULL); /* destroy */
+
+	GMainLoop * mainloop = g_main_loop_new(NULL, FALSE);
+
+	g_timeout_add_seconds(2, end_of_line, mainloop);
+
+	g_main_loop_run(mainloop);
+	g_main_loop_unref(mainloop);
+
+	g_debug("Quitting");
+
+	return 0;
+}

=== added file 'tests/test-indicator-tracker.c'
--- tests/test-indicator-tracker.c	1970-01-01 00:00:00 +0000
+++ tests/test-indicator-tracker.c	2011-11-17 04:30:19 +0000
@@ -0,0 +1,88 @@
+/*
+Test code for indicator tracker.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <glib.h>
+#include <glib-object.h>
+
+#include "../service/indicator-tracker.h"
+#include "../service/indicator-tracker.c"
+
+gboolean
+end_of_line (gpointer user_data)
+{
+	g_main_loop_quit((GMainLoop *)user_data);
+	return FALSE;
+}
+
+gint
+main (gint argc, gchar * argv[])
+{
+	g_type_init();
+
+	IndicatorTracker * tracker = indicator_tracker_new();
+
+	GMainLoop * mainloop = g_main_loop_new(NULL, FALSE);
+
+	g_timeout_add_seconds(1, end_of_line, mainloop);
+
+	g_main_loop_run(mainloop);
+	g_main_loop_unref(mainloop);
+
+	int i;
+	gboolean found_messaging = FALSE;
+	gboolean found_sound = FALSE;
+	gboolean failed = FALSE;
+
+	GArray * indicators = indicator_tracker_get_indicators(tracker);
+
+	for (i = 0; i < indicators->len; i++) {
+		IndicatorTrackerIndicator * indicator = &g_array_index(indicators, IndicatorTrackerIndicator, i);
+
+		if (g_strcmp0(indicator->dbus_name_wellknown, "com.canonical.indicator.messages") == 0) {
+			found_messaging = TRUE;
+			continue;
+		}
+
+		if (g_strcmp0(indicator->dbus_name_wellknown, "com.canonical.indicators.sound") == 0) {
+			found_sound = TRUE;
+			continue;
+		}
+
+		g_warning("Found indicator we didn't expect: %s", indicator->dbus_name_wellknown);
+		failed = TRUE;
+		break;
+	}
+
+	g_object_unref(tracker);
+
+	if (!found_messaging || !found_sound) {
+		g_warning("Missing Indicators");
+		failed = TRUE;
+	}
+
+	if (!failed) {
+		g_debug("Found everything");
+		return 0;
+	} else {
+		g_warning("Failed");
+		return 1;
+	}
+}

=== added file 'tests/test-load-app-info.c'
--- tests/test-load-app-info.c	1970-01-01 00:00:00 +0000
+++ tests/test-load-app-info.c	2011-11-27 20:21:13 +0000
@@ -0,0 +1,85 @@
+/*
+Make sure the app info is truly bad and we don't crash or something.
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <unistd.h>
+#include <glib.h>
+#include <glib/gstdio.h>
+#include <glib-object.h>
+#include "load-app-info.h"
+#include "load-app-info.c"
+
+static void
+build_db (sqlite3 * db)
+{
+	/* Create the table */
+	int exec_status = SQLITE_OK;
+	gchar * failstring = NULL;
+	exec_status = sqlite3_exec(db,
+	                           "create table usage (application text, entry text, timestamp datetime);",
+	                           NULL, NULL, &failstring);
+	if (exec_status != SQLITE_OK) {
+		g_warning("Unable to create table: %s", failstring);
+	}
+
+	/* Import data from the system */
+
+	return;
+}
+
+int
+main (int argv, char * argc[])
+{
+	gboolean passed = TRUE;
+
+	if (argv != 3) {
+		g_printerr("Usage: %s <db path> <app-info file path>\n", argc[0]);
+		return 1;
+	}
+
+	g_type_init();
+
+	gchar * filename = argc[1];
+
+	sqlite3 * db = NULL;
+	int open_status = sqlite3_open(filename, &db); 
+
+	if (open_status != SQLITE_OK) {
+		g_warning("Error opening usage DB: %s", filename);
+		passed = FALSE;
+		goto cleanup;
+	}
+
+	/* Create the table in the DB */
+	build_db(db);
+
+	passed = load_app_info(argc[2], db);
+
+cleanup:
+	if (db != NULL) {
+		sqlite3_close(db);
+	}
+
+	if (passed) {
+		return 0;
+	} else {
+		return 1;
+	}
+}

=== added file 'tests/test-usage-db-ancient.c'
--- tests/test-usage-db-ancient.c	1970-01-01 00:00:00 +0000
+++ tests/test-usage-db-ancient.c	2011-11-27 17:38:51 +0000
@@ -0,0 +1,37 @@
+/*
+Test function to ensure we auto-clear the old databse
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <glib.h>
+#include <glib-object.h>
+
+#include "load-app-info.h"
+#include "load-app-info.c"
+#include "usage-tracker.h"
+#include "usage-tracker.c"
+
+gint
+main (gint argc, gchar * argv[])
+{
+	g_type_init();
+	UsageTracker * tracker = usage_tracker_new();
+	g_object_unref(tracker);
+	return 0;
+}

=== added file 'tests/test-usage-db-ancient.sql'
--- tests/test-usage-db-ancient.sql	1970-01-01 00:00:00 +0000
+++ tests/test-usage-db-ancient.sql	2011-11-11 15:23:20 +0000
@@ -0,0 +1,7 @@
+create table usage (application text, entry text, timestamp datetime);
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Shorties", datetime('now', 'utc', '-31 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Shorties", datetime('now', 'utc', '-32 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Shorties", datetime('now', 'utc', '-33 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Longer Term", datetime('now', 'utc', '-1 year', '-31 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Longer Term", datetime('now', 'utc', '-1 year', '-32 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Longer Term", datetime('now', 'utc', '-1 year', '-33 day'));

=== added file 'tests/test-usage-db-old.c'
--- tests/test-usage-db-old.c	1970-01-01 00:00:00 +0000
+++ tests/test-usage-db-old.c	2011-11-27 17:38:51 +0000
@@ -0,0 +1,80 @@
+/*
+Test function to ensure we auto-clear the old databse
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <glib.h>
+#include <glib-object.h>
+
+#include "load-app-info.h"
+#include "load-app-info.c"
+#include "usage-tracker.h"
+#include "usage-tracker.c"
+
+/* Ensure the base object works */
+static void
+test_usage_db_base (void)
+{
+	UsageTracker * tracker = usage_tracker_new();
+	g_assert(tracker != NULL);
+	g_assert(IS_USAGE_TRACKER(tracker));
+
+	g_object_unref(tracker);
+	return;
+}
+
+static void
+test_usage_db_counts (void)
+{
+	UsageTracker * tracker = usage_tracker_new();
+	g_assert(tracker != NULL);
+	g_assert(IS_USAGE_TRACKER(tracker));
+
+	g_assert(usage_tracker_get_usage(tracker, "testapp.desktop", "Zero") == 0);
+	g_assert(usage_tracker_get_usage(tracker, "testapp.desktop", "One") == 1);
+	g_assert(usage_tracker_get_usage(tracker, "testapp.desktop", "Two") == 1);
+	g_assert(usage_tracker_get_usage(tracker, "testapp.desktop", "Three") == 1);
+	g_assert(usage_tracker_get_usage(tracker, "testapp.desktop", "Four") == 1);
+
+	g_object_unref(tracker);
+	return;
+}
+
+/* Build the test suite */
+static void
+test_usage_db_suite (void)
+{
+	g_test_add_func ("/hud/usage/old/base",          test_usage_db_base);
+	g_test_add_func ("/hud/usage/old/counts",        test_usage_db_counts);
+	return;
+}
+
+gint
+main (gint argc, gchar * argv[])
+{
+	//gtk_init(&argc, &argv);
+	g_type_init();
+
+	g_test_init(&argc, &argv, NULL);
+
+	/* Test suites */
+	test_usage_db_suite();
+
+	return g_test_run ();
+}

=== added file 'tests/test-usage-db-old.sql'
--- tests/test-usage-db-old.sql	1970-01-01 00:00:00 +0000
+++ tests/test-usage-db-old.sql	2011-11-11 03:02:15 +0000
@@ -0,0 +1,11 @@
+create table usage (application text, entry text, timestamp datetime);
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "One", datetime('now', 'utc'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Two", datetime('now', 'utc'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Two", datetime('now', 'utc', '-31 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Three", datetime('now', 'utc'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Three", datetime('now', 'utc', '-31 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Three", datetime('now', 'utc', '-32 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Four", datetime('now', 'utc'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Four", datetime('now', 'utc', '-31 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Four", datetime('now', 'utc', '-32 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Four", datetime('now', 'utc', '-33 day'));

=== added file 'tests/test-usage-db-simple.c'
--- tests/test-usage-db-simple.c	1970-01-01 00:00:00 +0000
+++ tests/test-usage-db-simple.c	2011-11-27 17:38:51 +0000
@@ -0,0 +1,106 @@
+/*
+Test function to ensure we can use a simple databse
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <glib.h>
+#include <glib-object.h>
+
+#include "load-app-info.h"
+#include "load-app-info.c"
+#include "usage-tracker.h"
+#include "usage-tracker.c"
+
+/* Ensure the base object works */
+static void
+test_usage_db_base (void)
+{
+	UsageTracker * tracker = usage_tracker_new();
+	g_assert(tracker != NULL);
+	g_assert(IS_USAGE_TRACKER(tracker));
+
+	g_object_unref(tracker);
+	return;
+}
+
+static void
+test_usage_db_counts (void)
+{
+	UsageTracker * tracker = usage_tracker_new();
+	g_assert(tracker != NULL);
+	g_assert(IS_USAGE_TRACKER(tracker));
+
+	g_assert(usage_tracker_get_usage(tracker, "testapp.desktop", "Zero") == 0);
+	g_assert(usage_tracker_get_usage(tracker, "testapp.desktop", "One") == 1);
+	g_assert(usage_tracker_get_usage(tracker, "testapp.desktop", "Two") == 2);
+	g_assert(usage_tracker_get_usage(tracker, "testapp.desktop", "Three") == 3);
+	g_assert(usage_tracker_get_usage(tracker, "testapp.desktop", "Four") == 4);
+
+	g_object_unref(tracker);
+	return;
+}
+
+static void
+test_usage_db_insert (void)
+{
+	UsageTracker * tracker = usage_tracker_new();
+	g_assert(tracker != NULL);
+	g_assert(IS_USAGE_TRACKER(tracker));
+
+	int i = 0;
+
+	for (i = 0; i < 5; i++) {
+		usage_tracker_mark_usage(tracker, "testapp.desktop", "Five");
+	}
+
+	g_assert(usage_tracker_get_usage(tracker, "testapp.desktop", "Five") == 5);
+
+	for (i = 0; i < 100; i++) {
+		usage_tracker_mark_usage(tracker, "testapp.desktop", "Hundred");
+	}
+
+	g_assert(usage_tracker_get_usage(tracker, "testapp.desktop", "Hundred") == 100);
+
+	g_object_unref(tracker);
+	return;
+}
+
+/* Build the test suite */
+static void
+test_usage_db_suite (void)
+{
+	g_test_add_func ("/hud/usage/simple/base",          test_usage_db_base);
+	g_test_add_func ("/hud/usage/simple/counts",        test_usage_db_counts);
+	g_test_add_func ("/hud/usage/simple/insert",        test_usage_db_insert);
+	return;
+}
+
+gint
+main (gint argc, gchar * argv[])
+{
+	//gtk_init(&argc, &argv);
+	g_type_init();
+
+	g_test_init(&argc, &argv, NULL);
+
+	/* Test suites */
+	test_usage_db_suite();
+
+	return g_test_run ();
+}

=== added file 'tests/test-usage-db-simple.sql'
--- tests/test-usage-db-simple.sql	1970-01-01 00:00:00 +0000
+++ tests/test-usage-db-simple.sql	2011-11-11 03:02:15 +0000
@@ -0,0 +1,11 @@
+create table usage (application text, entry text, timestamp datetime);
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "One", datetime('now', 'utc'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Two", datetime('now', 'utc'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Two", datetime('now', 'utc', '-1 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Three", datetime('now', 'utc'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Three", datetime('now', 'utc', '-1 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Three", datetime('now', 'utc', '-2 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Four", datetime('now', 'utc'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Four", datetime('now', 'utc', '-1 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Four", datetime('now', 'utc', '-2 day'));
+insert into usage (application, entry, timestamp) values ("testapp.desktop", "Four", datetime('now', 'utc', '-3 day'));

=== added file 'tests/test-usage-db-testapp.c'
--- tests/test-usage-db-testapp.c	1970-01-01 00:00:00 +0000
+++ tests/test-usage-db-testapp.c	2011-12-02 19:31:18 +0000
@@ -0,0 +1,81 @@
+/*
+Test code for usage DB based on testapp data
+
+Copyright 2011 Canonical Ltd.
+
+Authors:
+    Ted Gould <ted@canonical.com>
+
+This program is free software: you can redistribute it and/or modify it 
+under the terms of the GNU General Public License version 3, as published 
+by the Free Software Foundation.
+
+This program is distributed in the hope that it will be useful, but 
+WITHOUT ANY WARRANTY; without even the implied warranties of 
+MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
+PURPOSE.  See the GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along 
+with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <glib.h>
+#include <glib-object.h>
+
+#define DUMP_MATRIX 1
+#include "load-app-info.h"
+#include "load-app-info.c"
+#include "usage-tracker.h"
+#include "usage-tracker.c"
+#include "shared-values.h"
+
+static void
+test_usage_testapp (void)
+{
+	UsageTracker * tracker = usage_tracker_new();
+
+	g_assert(tracker != NULL);
+	g_assert(IS_USAGE_TRACKER(tracker));
+
+	g_assert(usage_tracker_get_usage(tracker, "/usr/share/applications/testapp.desktop", "Menu" DB_SEPARATOR "Item") == 7);
+
+	g_object_unref(tracker);
+	return;
+}
+
+static void
+test_usage_testapp_clip (void)
+{
+	UsageTracker * tracker = usage_tracker_new();
+
+	g_assert(tracker != NULL);
+	g_assert(IS_USAGE_TRACKER(tracker));
+
+	g_assert(usage_tracker_get_usage(tracker, "/usr/share/applications/testapp100.desktop", "Menu" DB_SEPARATOR "Item") == 30);
+
+	g_object_unref(tracker);
+	return;
+}
+
+/* Build the test suite */
+static void
+test_usage_testapp_suite (void)
+{
+	g_test_add_func ("/hud/usage/testapp/basic",     test_usage_testapp);
+	g_test_add_func ("/hud/usage/testapp/clip",      test_usage_testapp_clip);
+	return;
+}
+
+gint
+main (gint argc, gchar * argv[])
+{
+	//gtk_init(&argc, &argv);
+	g_type_init();
+
+	g_test_init(&argc, &argv, NULL);
+
+	/* Test suites */
+	test_usage_testapp_suite();
+
+	return g_test_run ();
+}

=== added file 'tests/test-usage-dump-entries.sql'
--- tests/test-usage-dump-entries.sql	1970-01-01 00:00:00 +0000
+++ tests/test-usage-dump-entries.sql	2011-11-27 20:21:13 +0000
@@ -0,0 +1,1 @@
+select * from usage;

